// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class DMObjectIdentity : IModelElement, IPrimaryKeyDef, IMergableBo
    {
//        public override string ToString()
//        {
//            return ObjectIdentityID == null? "": StringUtilities.GuidToUpper(ObjectIdentityID.Value);
//        }

        public DMObjectIdentity() : this(null)
        {
        }

        protected internal DMObjectIdentity(ClassDef def) : base(def)
        {
            this.Relationships.GetMultiple<DMProperty>("Properties").CurrentBusinessObjectCollection.BusinessObjectAdded
                += Properties_OnBusinessObjectAdded;
        }

        protected DMObjectIdentity(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            this.Relationships.GetMultiple<DMProperty>("Properties").CurrentBusinessObjectCollection.BusinessObjectAdded
                += Properties_OnBusinessObjectAdded;
        }

        private void Properties_OnBusinessObjectAdded(object sender, BOEventArgs<DMProperty> e)
        {
            DMProperty dmProperty = e.BusinessObject;
            if (!dmProperty.AutoIncrementing.GetValueOrDefault()) 
                dmProperty.Compulsory = true;
            dmProperty.ReadWriteRule = PropReadWriteRule.WriteNew;
        }

        ~DMObjectIdentity()
        {
            this.Relationships.GetMultiple<DMProperty>("Properties").CurrentBusinessObjectCollection.BusinessObjectAdded
                -= Properties_OnBusinessObjectAdded;
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMObjectIdentityAllPropsCompulsoryRule());
        }

        protected override void UpdateObjectBeforePersisting(ITransactionCommitter transactionCommitter)
        {
            base.UpdateObjectBeforePersisting(transactionCommitter);
            this.IsObjectID = false;
            if (this.Properties.Count != 1) return;
            DMProperty property = this.Properties[0];
            if (property.PropertyType != null && property.PropertyTypeString == "System.Guid")
            {
                this.IsObjectID = true;
            }
        }

        ///<summary>
        ///Returns a <see cref="T:System.String" /> that represents the current <see cref="T:System.Object" />.
        ///</summary>
        ///
        ///<returns>
        ///A <see cref="T:System.String" /> that represents the current <see cref="T:System.Object" />.
        ///</returns>
        ///<filterpriority>2</filterpriority>
        public override string ToString()
        {
            if (this.Class == null)
            {
                return ObjectIdentityID == null
                           ? "-unnamed DMObjectIdentity-"
                           : StringUtilities.GuidToUpper(ObjectIdentityID.Value);
            }
            return this.Class + " = Identity";
        }

        /// <summary>
        /// Returns true if the properties in the list are exactly the same properties as the 
        /// properties already associatedWith this objectID else returns false.
        /// </summary>
        /// <param name="properties">The properties being compared to</param>
        /// <returns></returns>
        public bool ArePropertiesEqual(IList<DMProperty> properties)
        {
            if (properties == null) return this.Properties.Count <= 0;
            if (this.Properties.Count != properties.Count) return false;

            return properties.All(property => this.Properties.Contains(property));
        }

        public IModelElement Parent
        {
            get { return this.Class; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the ObjectIdentity by setting the related Class object", "");
            }
        }

        #region Implementation of IPrimaryKeyDef

        bool IPrimaryKeyDef.IsGuidObjectID
        {
            get { return this.IsObjectID ?? false; }
            set { this.IsObjectID = value; }
        }

        void IKeyDef.Add(IPropDef propDef)
        {
           this.Properties.Add((DMProperty) propDef);
        }

        public IBOKey CreateBOKey(IBOPropCol lBOPropCol)
        {
            throw new System.NotImplementedException();
        }

        public bool IgnoreIfNull
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        string IKeyDef.KeyName
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        public string Message
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        int IKeyDef.Count
        {
            get { return this.Properties.Count; }
        }

        public bool IsCompositeKey
        {
            get { return this.Properties.Count > 1; }
        }

        /// <summary>
        /// Returns true if the Object ID has one or more property
        /// </summary>
        public bool HasProperties
        {
            get { return this.Properties.Count > 0; }
        }
        /// <summary>
        /// Returns true if the Object Id has only one property
        /// </summary>
        public bool HasSingleProperties
        {
            get { return this.Properties.Count == 1; }
        }

        IPropDef IKeyDef.this[string propName]
        {
            get { throw new System.NotImplementedException(); }
        }

        IPropDef IKeyDef.this[int index]
        {
            get { return this.Properties[index];  }
        }

        public IEnumerator GetEnumerator()
        {
            return this.Properties.GetEnumerator();
        }

        void IKeyDef.Clear()
        { 
            this.Properties.ForEach(property => property.MarkForDelete());
        }

        #endregion

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}