// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class DMPropertyType : IModelPropertyType, IMergableBo
    {
        public const string PROP_TYPE_INT32 = "System.Int32";
        public const string PROP_TYPE_STRING = "System.String";
        public const string PROP_TYPE_DECIMAL = "System.Decimal";
        public const string PROP_TYPE_SINGLE = "System.Single";
        public const string PROP_TYPE_DOUBLE = "System.Double";
        public const string PROP_TYPE_DATETIME = "System.DateTime";
        public const string PROP_TYPE_GUID = "System.Guid";
        public const string PROP_TYPE_TIMESPAN = "System.TimeSpan";

        public DMPropertyType() : this(null)
        {
        }
		
        public DMPropertyType(string assemblyName, string propertyTypeName)
        {
            AssemblyName = assemblyName;
            PropertyTypeName = propertyTypeName;
            
        }
        
        public Type GetActualType()
        {
            return TypeLoader.LoadType(this.AssemblyName, this.PropertyTypeName);
        }

        protected internal DMPropertyType(ClassDef def) : base(def)
        {
            SetUpPropertyLinks();
        }

        protected DMPropertyType(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetUpPropertyLinks();
        }

//        private string TransformPropertyTypeNameToID(string input)
//        {
//            return this.AssemblyName + "." + this.PropertyTypeName;
//        }

        private void SetUpPropertyLinks()
        {
//            new PropertyLink<string, string>(this, "AssemblyName", "PropertyTypeID", TransformPropertyTypeNameToID);
//            new PropertyLink<string, string>(this, "PropertyTypeName", "PropertyTypeID", TransformPropertyTypeNameToID);
        }

        public override string ToString()
        {
            if (String.IsNullOrEmpty(PropertyTypeName))
            {
                return this.PropertyTypeID == null ? "-unnamed propertyType-" : Convert.ToString(this.PropertyTypeID);
            }
            return this.PropertyTypeName;
        }

        public string PropertyTypeFullName
        {
            get { return this.AssemblyName + "." + this.PropertyTypeName; }
        }


        public override bool IsEditable(out string message)
        {
            if (!base.IsEditable(out message)) return false;
            if (string.IsNullOrEmpty(this.AssemblyName)) return true;
            message = "The Property Type '" + this.PropertyTypeName + "' with the Assembly Name '" + this.AssemblyName + "' cannot be edited.";
            return (!this.AssemblyName.StartsWith("System"));
        }

        public override bool IsDeletable(out string message)
        {
            if (!base.IsDeletable(out message)) return false;
            if (string.IsNullOrEmpty(this.AssemblyName)) return true;
            message = "The Property Type '" + this.PropertyTypeName + "' with the Assembly Name '" + this.AssemblyName + "' cannot be deleted.";
            return !this.AssemblyName.StartsWith("System");
        }

        public static DMPropertyType Find(DMSolution solution, string assembly, string typeName)
        {
            return solution.PropertyTypes.Find(type => type.AssemblyName == assembly && type.PropertyTypeName == typeName);
            //string criteria = String.Format("PropertyTypeName = '{0}' AND AssemblyName = '{1}'", typeName, assembly);
            //return Broker.GetBusinessObject<DMPropertyType>(criteria);
        }

        #region Implementation of IModelElement

        IModelElement IModelElement.Parent
        {
            get { return this.Solution; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the PropertyType by setting the related Solution object", "");
            }
        }

        #endregion

        #region Implementation of IModelPropertyType

        bool IModelPropertyType.IsValueType
        {
            get
            {
                Type propertyTypeType = this.GetTypeObject();
                if (propertyTypeType != null) return propertyTypeType.IsValueType || propertyTypeType.IsEnum;
                return false;
            }
        }

        private Type GetTypeObject()
        {
            try
            {
                Type propertyType = TypeLoader.LoadType(AssemblyName, PropertyTypeName);
                return propertyType;
            }
            catch
            {
                return null;
            }
        }

        #endregion

        public static DMPropertyType FindOrCreate(DMSolution solution, string assembly, string typeName)
        {
            DMPropertyType dmPropertyType;
            dmPropertyType = Find(solution, assembly, typeName);
            if (dmPropertyType == null)
            {
                dmPropertyType = solution.PropertyTypes.CreateBusinessObject();
                dmPropertyType.AssemblyName = assembly;
                dmPropertyType.PropertyTypeName = typeName;
            }
            return dmPropertyType;
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}