// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class DMUniqueConstraint : IModelKey, IKeyDef, IMergableBo
    {
        public DMUniqueConstraint()
        {
        }

        protected internal DMUniqueConstraint(IClassDef def) : base(def)
        {
        }

        protected DMUniqueConstraint(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(UniqueConstraintName))
            {
                return this.UniqueConstraintID == null
                           ? "-unnamed UniqueConstraint-"
                           : Convert.ToString(this.UniqueConstraintID);
            }
            return this.UniqueConstraintName;
        }

        protected override bool AreCustomRulesValid(out string customRuleErrors)
        {
            bool rulesValid = base.AreCustomRulesValid(out customRuleErrors);
            DMClass dmClass = this.Class;
            if (dmClass == null) return rulesValid;
            DMObjectIdentity dmObjectIdentity = dmClass.ObjectIdentity;
            if (dmObjectIdentity == null) return rulesValid;
            customRuleErrors = CheckUniqueContraintProperties(dmClass, dmObjectIdentity, customRuleErrors);
            return customRuleErrors.Length <= 0;
        }

        private string CheckUniqueContraintProperties
            (DMClass dmClass, DMObjectIdentity dmObjectIdentity, string customRuleErrors)
        {
            BusinessObjectCollection<DMProperty> objectIdentityProperties = dmObjectIdentity.Properties;
            bool propsExistAsObjectIdentitiy = false;
            foreach (DMUniqueConstraintProperty uniqueConstraintProperty in this.UniqueConstraintProperties)
            {
                propsExistAsObjectIdentitiy = CheckPropExistAsObjectIdentity
                    (objectIdentityProperties, uniqueConstraintProperty.Property);
                if (!propsExistAsObjectIdentitiy) break;
            }
            if (propsExistAsObjectIdentitiy)
            {
                customRuleErrors += "You cannot have a unique constraint for the entity '" + dmClass.ToString()
                                    + "' with the same properties " + "as the primary key.";
            }
            return customRuleErrors;
        }

        private static bool CheckPropExistAsObjectIdentity
            (BusinessObjectCollection<DMProperty> properties, DMProperty dmProperty)
        {
            foreach (DMProperty property in properties)
            {
                if (property == dmProperty) return true;
            }
            return false;
        }

        public DMUniqueConstraintProperty GetKeyPropertyInfo(string propertyName)
        {
            foreach (DMUniqueConstraintProperty info in this.UniqueConstraintProperties)
            {
                if (info.Property.PropertyName == propertyName) return info;
            }
            return null;
        }

        public DMProperty GetPropertyInfo(string columnName)
        {
            DMUniqueConstraintProperty constraintProperty = GetKeyPropertyInfo(columnName);
            return constraintProperty != null ? constraintProperty.Property : null;
        }

        public DMUniqueConstraintProperty AddPropertyInfo(DMProperty property)
        {
            if (property == null) throw new ArgumentNullException("property");
            DMUniqueConstraintProperty constraintProperty = this.GetKeyPropertyInfo(property.PropertyName);
            if (constraintProperty != null)
            {
                //if (constraintProperty.Property == property) return constraintProperty;
                string name = this.Class == null ? "" : this.Class.ClassNameBO;

                string message = string.Format
                    ("A property with name '{0}' could not be added to the "
                     +
                     "Alternate Key Info for the business object '{1}' since it already exists in the business object alternate key",
                     property.PropertyName, name);
                throw new HabaneroDeveloperException(message, message);
            }

            constraintProperty = new DMUniqueConstraintProperty {Property = property};
            this.UniqueConstraintProperties.Add(constraintProperty);
            return constraintProperty;
        }

        /// <summary>
        /// Returns a list of column infos associated with this PrimaryKey
        /// </summary>
        public ReadOnlyCollection<DMProperty> Properties
        {
            get
            {
                List<DMProperty> listColumns = new List<DMProperty>();
                foreach (DMUniqueConstraintProperty alternateKeyPropertyInfo in this.UniqueConstraintProperties)
                {
                    listColumns.Add(alternateKeyPropertyInfo.Property);
                }
                return new ReadOnlyCollection<DMProperty>(listColumns);
            }
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMUniqueConstraintMustHaveProps());
        }

        #region Implementation of IModelElement

        IModelElement IModelElement.Parent
        {
            get { return this.Class; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the IModelKey by setting the related Class object", "");
            }
        }

        #endregion

        #region Implementation of IModelKey

        string IModelKey.KeyName
        {
            get { return this.UniqueConstraintName; }
        }

        IList<IModelProperty> IModelKey.KeyProperties
        {
            get
            {
                List<IModelProperty> listColumns = new List<IModelProperty>();
                foreach (DMUniqueConstraintProperty alternateKeyPropertyInfo in this.UniqueConstraintProperties)
                {
                    listColumns.Add(alternateKeyPropertyInfo.Property);
                }
                return listColumns;
            }
        }

        #endregion

        #region Implementation of IKeyDef

        string IKeyDef.KeyName
        {
            get
            {
                if (String.IsNullOrEmpty(UniqueConstraintName))
                {
                    string keyName = "";
                    this.UniqueConstraintProperties.ForEach(property => keyName += property.Property.PropertyName);
                    return keyName;
                }
                return UniqueConstraintName;
            }
            set { UniqueConstraintName = value; }
        }

        bool IKeyDef.IgnoreIfNull { get { return IgnoreIfNull ?? false; } set { IgnoreIfNull = value; } }

        string IKeyDef.Message { get { return Message; } set { Message = value; } }

        void IKeyDef.Add(IPropDef propDef)
        {
            AddPropertyInfo((DMProperty) propDef);
        }

        IBOKey IKeyDef.CreateBOKey(IBOPropCol lBOPropCol)
        {
            throw new System.NotImplementedException();
        }

        IPropDef IKeyDef.this[string propName]
        {
            get
            {
                DMUniqueConstraintProperty uniqueConstraintProperty = this.UniqueConstraintProperties.Find(property => property.Property.PropertyName == propName);
                if (uniqueConstraintProperty == null) throw new IndexOutOfRangeException("Property " + propName + " not found on IKeyDef " + ((IKeyDef)this).KeyName);
                return uniqueConstraintProperty.Property;
            }
        }

        IPropDef IKeyDef.this[int index]
        {
            get { throw new System.NotImplementedException(); }
        }

        public int Count
        {
            get { return this.UniqueConstraintProperties.Count; }
        }
        
        void IKeyDef.Clear()
        {
            this.UniqueConstraintProperties.ForEach(property => property.MarkForDelete());
        }

        #endregion
        
        #region Implementation of IEnumerable

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.UniqueConstraintProperties.GetEnumerator();
        }

        #endregion

//        public bool AreAllPropertiesEqual(IList<DMProperty> properties)
//        {
//            throw new NotImplementedException();
//        }
        public bool AreAllPropertiesEqual(IList<DMProperty> properties)
        {
            if (this.UniqueConstraintProperties.Count != properties.Count) return false;
            foreach (DMProperty property in properties)
            {
                if (!HasProperty(property)) return false;
            }
            return true;
        }

        public bool HasProperty(DMProperty property)
        {
            foreach (DMUniqueConstraintProperty constraintProperty in this.UniqueConstraintProperties)
            {
                if (constraintProperty.Property == property) return true;
            }
            return false;
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}