// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIField : IModelElement,  IUIFormField, IOrderableObject, IMergableBo
    {
        public UIField()
        {
//            new PropertyLink<string, string>
//                (this, "Property", "LabelText", value => StringUtilities.DelimitPascalCase(Convert.ToString(value), " "));
        }


        protected internal UIField(ClassDef def) : base(def)
        {
        }

        protected UIField(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            //return this.PropertyName;
            //if (this.UIColumnLayout == null && this.Property == null)
            //{
            //    return this.UIFieldID == null ? "-unnamed UIField-" : Convert.ToString(this.UIFieldID);
            //}
            string formToString = (this.UIColumnLayout == null)
                                      ? ""
                                      : this.UIColumnLayout.ToString() + " - ";
            return formToString +
                   ((String.IsNullOrEmpty(this.PropertyName))
                        ? "Un-named Property"
                        : this.PropertyName);
        }

        //public string PropertyName
        //{
        //    get { return this.Property == null ? "" : this.Property.PropertyName; }
        //}

        public IModelElement Parent
        {
            get { return this.UIColumnLayout; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIField by setting the related UIColumnLayout object", "");
            }
        }

        //public string PropertyOrRelationshipName
        //{
        //    get
        //    {
        //        DMProperty property = this.Property;
        //        if (property != null) return property.PropertyName;
        //        DMRelationship relationship = this.DMRelationship;
        //        if (property == null && relationship == null) return "";
        //        return property == null ? relationship.RelationshipName : property.PropertyName;
        //    }
        //}

        /// <summary>
        /// Gets the label for this form field.
        /// </summary>
        /// <returns>
        /// The label for this form field 
        /// </returns>
        string IUIFormField.GetLabel()
        {
            if (string.IsNullOrEmpty(this.LabelText)) return this.PropertyName + ":";
            return this.LabelText;
        }

        /// <summary>
        /// Returns the parameter value for the name provided
        /// </summary>
        /// <param name="parameterName">The parameter name</param>
        /// <returns>
        /// Returns the parameter value or null if not found
        /// </returns>
        object IUIFormField.GetParameterValue(string parameterName)
        {
            if (parameterName == null) throw new ArgumentNullException("parameterName");
            UIParameter uiParameter = GetParameter(parameterName);
            if (uiParameter == null)
            {
                throw new ArgumentException("There is no parameter with the name '" + parameterName + "' for the UIField", "parameterName");
            }
            return uiParameter.Value;
        }

        /// <summary>
        /// Returns true if the UIFormField has a paramter value.
        /// </summary>
        /// <param name="parameterName"/>
        /// <returns/>
        bool IUIFormField.HasParameterValue(string parameterName)
        {
            if (parameterName == null) throw new ArgumentNullException("parameterName");
            UIParameter uiParameter = GetParameter(parameterName);
            return uiParameter != null;
        }

        /// <summary>
        /// Returns the property name
        /// </summary>
        string IUIFormField.PropertyName
        {
            get
            {
                return this.PropertyName;
            }
            set { this.PropertyName = value; }
        }

        /// <summary>
        /// Returns the mapper type name
        /// </summary>
        string IUIFormField.MapperTypeName
        {
            get
            {
                UIControlMapperType controlMapperType = this.UIControlMapperType;
                return controlMapperType == null ? "" : controlMapperType.TypeName;
            }
            set { throw new NotImplementedException("This should be set when the UIControlMapperType is set for the UIField."); }
        }

        /// <summary>
        /// Returns the mapper assembly
        /// </summary>
        string IUIFormField.MapperAssembly
        {
            get
            {
                UIControlMapperType controlMapperType = this.UIControlMapperType;
                return controlMapperType == null ? "" : controlMapperType.AssemblyName;
            }
        }

        /// <summary>
        /// The name of the property type assembly
        /// </summary>
        string IUIFormField.ControlAssemblyName
        {
            get
            {
                UIControlType controlType = this.UIControlType;
                return controlType == null ? "" : controlType.AssemblyName;
            }
            set { throw new NotImplementedException("This should be set when the UIControlType is set for the UIField."); }
        }

        /// <summary>
        /// The name of the control type
        /// </summary>
        string IUIFormField.ControlTypeName
        {
            get
            {
                UIControlType controlType = this.UIControlType;
                return controlType == null ? "" : controlType.TypeName;
            }
            set { throw new NotImplementedException("This should be set when the UIControlType is set for the UIField."); }
        }

        /// <summary>
        /// Returns the control type
        /// </summary>
        Type IUIFormField.ControlType
        {
            get
            {
                UIControlType controlType = this.UIControlType;
                if (controlType != null)
                {
                    Type type = TypeLoader.LoadType(controlType.AssemblyName, controlType.TypeName);
                    return type;
                }
                return null;
            }
            set { throw new NotImplementedException("Please set this via the UIControlType relationship."); }
        }

        /// <summary>
        /// Indicates whether the control is editable
        /// </summary>
        bool IUIFormField.Editable
        {
            get { return this.Editable.Value; }
            set { this.Editable = value; }
        }

        /// <summary>
        /// Returns the text that will be shown in the Tool Tip for the control.
        /// </summary>
        string IUIFormField.ToolTipText
        {
            get { return this.ToolTipText; }
        }

        /// <summary>
        /// Returns the Hashtable containing the property attributes
        /// </summary>
        Hashtable IUIFormField.Parameters
        {
            get
            {
                Hashtable hashtable = new Hashtable();
                foreach (UIParameter parameter in UIParameters)
                {
                    hashtable.Add(parameter.Name, parameter.Value);
                }
                return hashtable;
            }
        }

        /// <summary>
        /// Is the field compulsory (i.e. must it be shown as compulsory on the form or not)
        /// </summary>
        bool IUIFormField.IsCompulsory
        {
            get
            {
                IDMProperty dmProperty = this.GetDMProperty();
                if (dmProperty == null) return false;
                return dmProperty.IsCompulsory;
            }
        }

        /// <summary>
        /// The <see cref="P:Habanero.BO.ClassDefinition.IUIFormField.UIFormColumn"/> that this form field is to be placed in.
        /// </summary>
        IUIFormColumn IUIFormField.UIFormColumn
        {
            get { return this.UIColumnLayout; }
            set { throw new NotImplementedException("This should be set via the UIColumnLayout relationship."); }
        }
         
        /// <summary>
        /// The <see cref="T:Habanero.BO.ClassDefinition.LayoutStyle"/> to be used for this form field.
        /// </summary>
        LayoutStyle IUIFormField.Layout
        {
            get
            {
                return (LayoutStyle) Enum.Parse(typeof(LayoutStyle), this.Layout);
            }
            set { this.Layout = value.ToString(); }
        }

        /// <summary>
        /// Returns the label
        /// </summary>
        string IUIFormField.Label
        {
            get { return this.LabelText; }
            set { this.LabelText = value; }
        }

        private UIParameter GetParameter(string parameterName)
        {
            foreach (UIParameter uiParameter in UIParameters)
            {
                if (uiParameter.Name == parameterName)
                {
                    return uiParameter;
                }
            }
            return null;
        }

        public IDMProperty GetDMProperty() {
            return this.UIColumnLayout.UITab.UIFormInfo.UIView.Class.GetDMProperty(this.PropertyName);
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}