// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIGridFilterProp : IModelElement, IFilterPropertyDef, IMergableBo
    {
        public UIGridFilterProp()
        {
        }

        protected internal UIGridFilterProp(ClassDef def) : base(def)
        {
        }

        protected UIGridFilterProp(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        //public string PropertyName
        //{
        //    get { return this.Property == null ? null : this.Property.PropertyName; }
        //}

        //public string PropertyDisplayName
        //{
        //    get { return this.Property == null ? null : this.Property.DisplayName; }
        //}

        public virtual String LabelText
        {
            get
            {
                string labelText = ((String) (base.GetPropertyValue("LabelText")));
                return string.IsNullOrEmpty(labelText) ? PropertyName : labelText;
            }
            set { base.SetPropertyValue("LabelText", value); }
        }

        public IModelElement Parent
        {
            get { return this.UIGridFilter; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIGridFilterProp by setting the related UIGridFilter object", "");
            }
        }

        /// <summary>
        /// The text to use to label the filter control.  This shows up as a label to the left of the control.
        /// </summary>
        string IFilterPropertyDef.Label
        {
            get { return this.LabelText; }
        }

        /// <summary>
        /// The type of filter to use.  This type must implement ICustomFilter.  The default is StringTextBoxFilter
        /// </summary>
        string IFilterPropertyDef.FilterType
        {
            get
            {
                UITypeDefinition gridFilterType = this.UIGridFilterType;
                return gridFilterType == null ? "" : gridFilterType.TypeName;
            }
            set { throw new NotImplementedException("This should be set when the UIGridFilterType is set for the UIGridFilterProp."); }
        }

        /// <summary>
        /// The assembly to find the filter class in.  The default is Habanero.Faces.Base
        /// </summary>
        string IFilterPropertyDef.FilterTypeAssembly
        {
            get
            {
                UITypeDefinition gridFilterType = this.UIGridFilterType;
                return gridFilterType == null ? "" : gridFilterType.AssemblyName;
            }
            set { throw new NotImplementedException("This should be set when the UIGridFilterType is set for the UIGridFilterProp."); }
        }

        /// <summary>
        /// The operator to use in this filter, for those filters that allow the use of different operators.
        /// </summary>
        FilterClauseOperator IFilterPropertyDef.FilterClauseOperator
        {
            get { return this.FilterClauseOp.Value; }
            set { this.FilterClauseOp = value; }
        }

        /// <summary>
        /// A set of parameters to apply to the instantiated filter.  These are applied using reflection.  For instance, if
        ///             a parameter is specified in this dictionary called 'AllowNull' with a value of 'true', then once the filter
        ///             (which must be of type ICustomFilter) is 
        ///             instantiated , the AllowNull property will be set with a value of true via
        ///             reflection.
        /// </summary>
        Dictionary<string, string> IFilterPropertyDef.Parameters
        {
            get
            {
                Dictionary<string, string> parameters = new  Dictionary<string, string>() ;
                foreach (UIParameter parameter in UIParameters)
                {
                    parameters.Add(parameter.Name, parameter.Value);
                }
                return parameters;
            }
            set {
                foreach (KeyValuePair<string, string> keyValuePair in value)
                {
                    UIParameter parameter = this.UIParameters.Find(p => p.Name == keyValuePair.Key);
                    if (parameter == null)
                    {
                        this.UIParameters.Add(new UIParameter()
                                        {
                                            Name = keyValuePair.Key,
                                            Value = keyValuePair.Value
                                        });

                    } else
                    {
                        parameter.Value = keyValuePair.Value;
                    }
                    }
            }
        }

        public override string ToString()
        {
            return UIGridFilter + " - " + PropertyName;
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}