// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UITab : IModelElement, IUIFormTab, IOrderableObject, IMergableBo
    {
        private OrderedCollectionController<UIColumnLayout> _orderedCollectionController;

        public UITab()
        {
            SetupUITab();
        }

        protected internal UITab(ClassDef def) : base(def)
        {
            SetupUITab();
        }

        protected UITab(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetupUITab();
        }

        private void SetupUITab()
        {
            _orderedCollectionController = new OrderedCollectionController<UIColumnLayout>(UIColumnLayouts);
        }

        public IModelElement Parent
        {
            get { return this.UIFormInfo; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UITab by setting the related UIFormInfo object", "");
            }
        }

        public override string ToString() { return this.Name; }

        /// <summary>
        /// Returns an enumerator that iterates through a collection.
        /// </summary>
        /// <returns>
        /// An <see cref="T:System.Collections.IEnumerator"/> object that can be used to iterate through the collection.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.UIColumnLayouts.Clone().GetEnumerator();
        }

        /// <summary>
        /// Copies the elements of the <see cref="T:System.Collections.ICollection"/> to an <see cref="T:System.Array"/>, starting at a particular <see cref="T:System.Array"/> index.
        /// </summary>
        /// <param name="array">The one-dimensional <see cref="T:System.Array"/> that is the destination of the elements copied from <see cref="T:System.Collections.ICollection"/>. The <see cref="T:System.Array"/> must have zero-based indexing. 
        ///                 </param><param name="index">The zero-based index in <paramref name="array"/> at which copying begins. 
        ///                 </param><exception cref="T:System.ArgumentNullException"><paramref name="array"/> is null. 
        ///                 </exception><exception cref="T:System.ArgumentOutOfRangeException"><paramref name="index"/> is less than zero. 
        ///                 </exception><exception cref="T:System.ArgumentException"><paramref name="array"/> is multidimensional.
        ///                     -or- 
        ///                 <paramref name="index"/> is equal to or greater than the length of <paramref name="array"/>.
        ///                     -or- 
        ///                     The number of elements in the source <see cref="T:System.Collections.ICollection"/> is greater than the available space from <paramref name="index"/> to the end of the destination <paramref name="array"/>. 
        ///                 </exception><exception cref="T:System.ArgumentException">The type of the source <see cref="T:System.Collections.ICollection"/> cannot be cast automatically to the type of the destination <paramref name="array"/>. 
        ///                 </exception><filterpriority>2</filterpriority>
        void ICollection.CopyTo(Array array, int index)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// The number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        int ICollection.Count
        {
            get {return this.UIColumnLayouts.Count;}
        }

        /// <summary>
        /// Gets an object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// An object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        object ICollection.SyncRoot
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets a value indicating whether access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe).
        /// </summary>
        /// <returns>
        /// true if access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe); otherwise, false.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        bool ICollection.IsSynchronized
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Adds a column definition to the collection of definitions
        /// </summary>
        /// <param name="column">The UIFormColumn object</param>
        void IUIFormTab.Add(IUIFormColumn column)
        {
            if (column == null) return;
            this.UIColumnLayouts.Add((UIColumnLayout) column);
        }

        /// <summary>
        /// Removes a column definition from the collection of definitions
        /// </summary>
        /// <param name="column">The UIFormColumn object</param>
        void IUIFormTab.Remove(IUIFormColumn column)
        {
            if (column == null) return;
            throw new NotImplementedException();
        }

        /// <summary>
        /// Checks if a column definition is in the collection of definitions
        /// </summary>
        /// <param name="column">The UIFormColumn object</param>
        bool IUIFormTab.Contains(IUIFormColumn column)
        {
            if (column == null) return false;
            return this.UIColumnLayouts.Contains((UIColumnLayout) column);
        }

        /// <summary>
        /// Provides an indexing facility so that the contents of the definition
        ///             collection can be accessed with square brackets like an array
        /// </summary>
        /// <param name="index">The index position to access</param>
        /// <returns>
        /// Returns the property definition at the index position
        ///             specified
        /// </returns>
        IUIFormColumn IUIFormTab.this[int index]
        {
            get { return this.UIColumnLayouts[index]; }
        }

        /// <summary>
        /// Gets and sets the tab name
        /// </summary>
        string IUIFormTab.Name
        {
            get { return this.Name; }
            set { this.Name = value; }
        }

        /// <summary>
        /// Gets and sets the UIFormGrid definition
        /// </summary>
        IUIFormGrid IUIFormTab.UIFormGrid
        {
            get { throw new NotImplementedException(); }
            set { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Returns the <see cref="P:Habanero.BO.ClassDefinition.IUIFormTab.UIForm"/> that this <see cref="T:Habanero.BO.ClassDefinition.UIFormTab"/> is defined for.
        /// </summary>
        IUIForm IUIFormTab.UIForm
        {
            get
            {
                return this.UIFormInfo;
            }
            set
            {
                throw new NotImplementedException("Please set this via the UIFormInfo relationship.");
            }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}