using System.Collections.Generic;
using FireStarter.Base;
using FireStarter.CodeGeneration.Generator;
using FireStarter.CodeGeneration.Parser;
using FireStarterModeller.BO;

namespace FireStarterModeller.Logic
{
    //TODO Eric 31 Aug 2009: There are two almost identical templates being used
    // between this and the DMToEntityClassDefsXmlConverter.  Need to merge so sections of the
    // templates are not duplicated.
    // NOTE: the non "Parameter_Type" templates are the right ones for normal ClassDef generation
    public class DMToClassDefsXmlConverter : IDMToClassDefsXmlConverter
    {

        public string ConvertToXml(DMSolution solution)
        {
            List<IActionParser> actionParsers = StatementParser.GetDefaultActionParsers();
            actionParsers.Add(new IncludeExpressionParser(new ResourceTemplateLoader(this.GetType().Assembly, "FireStarterModeller.Logic.ClassDefXmlTemplate")));
            return ConvertToXml(solution, ClassDefXmlTemplate.ClassDefXmlTemplateText, actionParsers);
        }

        public string ConvertToXml(DMClass dmClass)
        {
            List<IActionParser> actionParsers = StatementParser.GetDefaultActionParsers();
            actionParsers.Add(new IncludeExpressionParser(new ResourceTemplateLoader(this.GetType().Assembly, "FireStarterModeller.Logic.ClassDefXmlTemplate")));
            return ConvertToXml(dmClass, ClassDefXmlTemplate.SingleClassDefXmlTemplateText, actionParsers);
        }

        public string ConvertToXml(UIView uiView)
        {
            return ConvertToXml(uiView, ClassDefXmlTemplate.UIViewXmlTemplateText, StatementParser.GetDefaultActionParsers());
        }

        private string ConvertToXml(IModelElement element, string template,  List<IActionParser> actionParsers)
        {
            ModelStrategyMapper modelStrategyMapper = new ModelStrategyMapper();
            modelStrategyMapper.SetStrategy(typeof(IModelElement), new ReflectionGenerationStrategy());

            StatementParser statementParser = new StatementParser();
            TemplateExpression templateExpression = statementParser.Parse(ref template, actionParsers);
            string xmlForSolution = templateExpression.Generate(modelStrategyMapper, element);
            return xmlForSolution;
        }
    }
}