// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DBForeignKey objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DBForeignKey with a random value assigned to every property
        /// </summary>
        public static DBForeignKey CreateSavedDBForeignKey()
		{
		    DBForeignKey dBForeignKey = CreateUnsavedValidDBForeignKey();
			dBForeignKey.Save();
			return dBForeignKey;
		}

        /// <summary>
        /// Creates a new unsaved DBForeignKey with a random value assigned to every property
        /// </summary>
		public static DBForeignKey CreateUnsavedValidDBForeignKey()
		{
			DBForeignKey dBForeignKey = new DBForeignKey();
			dBForeignKey.ParentTableID = TestUtils.CreateSavedDBTable().TableID;
			dBForeignKey.RelatedTableID = TestUtils.CreateSavedDBTable().TableID;
			dBForeignKey.ForeignKeyName = TestUtils.GetRandomString();
			dBForeignKey.PendingChangeType = null;
			dBForeignKey.Approved = TestUtils.GetRandomBoolean();
			return dBForeignKey;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DBForeignKey where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DBForeignKey CreateUnsavedDefaultDBForeignKey()
		{
			DBForeignKey dBForeignKey = new DBForeignKey();
			return dBForeignKey;
		}
    }
    
    // Provides the part of the test class that tests DBForeignKey objects
    [TestFixture]
    public partial class TestDBForeignKey : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBForeignKeyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBForeignKey dBForeignKey = new DBForeignKey();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dBForeignKey.ForeignKeyID);
            Assert.IsInstanceOfType(dBForeignKey.Props["ForeignKeyID"].PropertyType, dBForeignKey.ForeignKeyID);
                        Assert.IsNull(dBForeignKey.ParentTableID);
                        Assert.IsNull(dBForeignKey.RelatedTableID);
                        Assert.IsNull(dBForeignKey.ForeignKeyName);
                        Assert.IsNotNull(dBForeignKey.PendingChangeType);
            Assert.IsInstanceOfType(dBForeignKey.Props["PendingChangeType"].PropertyType, dBForeignKey.PendingChangeType);
                        Assert.IsNull(dBForeignKey.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBForeignKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateUnsavedValidDBForeignKey();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBForeignKey.Status.IsNew);
            BusinessObjectCollection<DBForeignKey> col = new BusinessObjectCollection<DBForeignKey>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBForeignKey.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBForeignKey.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBForeignKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();

            //---------------Execute Test ----------------------
            DBForeignKey loadedDBForeignKey = Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dBForeignKey.ForeignKeyID, loadedDBForeignKey.ForeignKeyID);
                        Assert.AreEqual(dBForeignKey.ParentTableID, loadedDBForeignKey.ParentTableID);
                        Assert.AreEqual(dBForeignKey.RelatedTableID, loadedDBForeignKey.RelatedTableID);
                        Assert.AreEqual(dBForeignKey.ForeignKeyName, loadedDBForeignKey.ForeignKeyName);
                        Assert.AreEqual(dBForeignKey.PendingChangeType, loadedDBForeignKey.PendingChangeType);
                        Assert.AreEqual(dBForeignKey.Approved, loadedDBForeignKey.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBForeignKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBForeignKey.Delete();
            dBForeignKey.Save();
            //---------------Test Result -----------------------
            try
            {
                DBForeignKey retrievedDBForeignKey = Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBForeignKey", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBForeignKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForParentTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.ParentTableID = (System.Guid) valueForParentTableID;
            object valueForRelatedTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.RelatedTableID = (System.Guid) valueForRelatedTableID;
            object valueForForeignKeyName = TestUtils.GetRandomString();
            dBForeignKey.ForeignKeyName = (System.String) valueForForeignKeyName;
            object valueForPendingChangeType = null;
            dBForeignKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBForeignKey.Approved = (System.Boolean) valueForApproved;
            dBForeignKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBForeignKey retrievedDBForeignKey =
                    Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
            
            Assert.AreEqual(valueForParentTableID, retrievedDBForeignKey.ParentTableID);
            Assert.AreEqual(valueForRelatedTableID, retrievedDBForeignKey.RelatedTableID);
            Assert.AreEqual(valueForForeignKeyName, retrievedDBForeignKey.ForeignKeyName);
            Assert.AreEqual(valueForPendingChangeType, retrievedDBForeignKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, retrievedDBForeignKey.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = new DBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForParentTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.ParentTableID = (System.Guid) valueForParentTableID;
            object valueForRelatedTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.RelatedTableID = (System.Guid) valueForRelatedTableID;
            object valueForForeignKeyName = TestUtils.GetRandomString();
            dBForeignKey.ForeignKeyName = (System.String) valueForForeignKeyName;
            object valueForPendingChangeType = null;
            dBForeignKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBForeignKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForParentTableID, dBForeignKey.ParentTableID);
            Assert.AreEqual(valueForRelatedTableID, dBForeignKey.RelatedTableID);
            Assert.AreEqual(valueForForeignKeyName, dBForeignKey.ForeignKeyName);
            Assert.AreEqual(valueForPendingChangeType, dBForeignKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBForeignKey.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = new DBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForParentTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.ParentTableID = (System.Guid) valueForParentTableID;
            object valueForRelatedTableID = TestUtils.CreateSavedDBTable().TableID;
            dBForeignKey.RelatedTableID = (System.Guid) valueForRelatedTableID;
            object valueForForeignKeyName = TestUtils.GetRandomString();
            dBForeignKey.ForeignKeyName = (System.String) valueForForeignKeyName;
            object valueForPendingChangeType = null;
            dBForeignKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBForeignKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForParentTableID, dBForeignKey.GetPropertyValue("ParentTableID"));
            Assert.AreEqual(valueForRelatedTableID, dBForeignKey.GetPropertyValue("RelatedTableID"));
            Assert.AreEqual(valueForForeignKeyName, dBForeignKey.GetPropertyValue("ForeignKeyName"));
            Assert.AreEqual(valueForPendingChangeType, dBForeignKey.GetPropertyValue("PendingChangeType"));
            Assert.AreEqual(valueForApproved, dBForeignKey.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = new DBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForParentTableID = TestUtils.CreateSavedDBTable().TableID;            
            dBForeignKey.SetPropertyValue("ParentTableID", valueForParentTableID);
            object valueForRelatedTableID = TestUtils.CreateSavedDBTable().TableID;            
            dBForeignKey.SetPropertyValue("RelatedTableID", valueForRelatedTableID);
            object valueForForeignKeyName = TestUtils.GetRandomString();            
            dBForeignKey.SetPropertyValue("ForeignKeyName", valueForForeignKeyName);
            object valueForPendingChangeType = null;            
            dBForeignKey.SetPropertyValue("PendingChangeType", valueForPendingChangeType);
            object valueForApproved = TestUtils.GetRandomBoolean();            
            dBForeignKey.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForParentTableID, dBForeignKey.ParentTableID);
            Assert.AreEqual(valueForRelatedTableID, dBForeignKey.RelatedTableID);
            Assert.AreEqual(valueForForeignKeyName, dBForeignKey.ForeignKeyName);
            Assert.AreEqual(valueForPendingChangeType, dBForeignKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBForeignKey.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBForeignKey.ParentTableID = null;
            dBForeignKey.RelatedTableID = null;
            dBForeignKey.ForeignKeyName = null;
            dBForeignKey.PendingChangeType = null;
            dBForeignKey.Approved = null;
            dBForeignKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBForeignKey retrievedDBForeignKey =
                    Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
            
            Assert.IsNull(retrievedDBForeignKey.ParentTableID);
            Assert.IsNull(retrievedDBForeignKey.RelatedTableID);
            Assert.IsNull(retrievedDBForeignKey.ForeignKeyName);
            Assert.IsNull(retrievedDBForeignKey.PendingChangeType);
            Assert.IsNull(retrievedDBForeignKey.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKey dBForeignKey = TestUtils.CreateUnsavedValidDBForeignKey();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBForeignKey.ForeignKeyID = null;
            
            try
            {
                dBForeignKey.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Foreign Key I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBForeignKey>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ForeignKeyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ParentTableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelatedTableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ForeignKeyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ParentTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();

            FireStarterModeller.BO.DBTable boForRelationshipParentTable = TestUtils.CreateSavedDBTable();
            dBForeignKey.ParentTable = boForRelationshipParentTable;
            dBForeignKey.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipParentTable.ID);
            DBForeignKey loadedDBForeignKey = Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipParentTable, loadedDBForeignKey.ParentTable);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKey.ParentTable);
            Assert.AreEqual(loadedRelatedBO, dBForeignKey.ParentTable);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_RelatedTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();

            FireStarterModeller.BO.DBTable boForRelationshipRelatedTable = TestUtils.CreateSavedDBTable();
            dBForeignKey.RelatedTable = boForRelationshipRelatedTable;
            dBForeignKey.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipRelatedTable.ID);
            DBForeignKey loadedDBForeignKey = Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelatedTable, loadedDBForeignKey.RelatedTable);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKey.RelatedTable);
            Assert.AreEqual(loadedRelatedBO, dBForeignKey.RelatedTable);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ForeignKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumns = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumns.ForeignKeyID = dBForeignKey.ForeignKeyID;
            boForRelationshipForeignKeyColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBForeignKey.ForeignKeyColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBForeignKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBForeignKeyColumn>(boForRelationshipForeignKeyColumns.ID);
            DBForeignKey loadedDBForeignKey = Broker.GetBusinessObject<DBForeignKey>(dBForeignKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBForeignKey.ForeignKeyColumns.Count);
            Assert.AreEqual(boForRelationshipForeignKeyColumns, loadedDBForeignKey.ForeignKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKey.ForeignKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, dBForeignKey.ForeignKeyColumns[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ForeignKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKey dBForeignKey = TestUtils.CreateSavedDBForeignKey();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumns = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumns.ForeignKeyID = dBForeignKey.ForeignKeyID;
            boForRelationshipForeignKeyColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBForeignKey.ForeignKeyColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBForeignKey>().RelationshipDefCol["ForeignKeyColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBForeignKey.Delete();
                dBForeignKey.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'ForeignKeyColumns' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
