// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DBPrimaryKey objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DBPrimaryKey with a random value assigned to every property
        /// </summary>
        public static DBPrimaryKey CreateSavedDBPrimaryKey()
		{
		    DBPrimaryKey dBPrimaryKey = CreateUnsavedValidDBPrimaryKey();
			dBPrimaryKey.Save();
			return dBPrimaryKey;
		}

        /// <summary>
        /// Creates a new unsaved DBPrimaryKey with a random value assigned to every property
        /// </summary>
		public static DBPrimaryKey CreateUnsavedValidDBPrimaryKey()
		{
			DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();
			dBPrimaryKey.TableID = TestUtils.CreateSavedDBTable().TableID;
			dBPrimaryKey.PendingChangeType = null;
			dBPrimaryKey.Approved = TestUtils.GetRandomBoolean();
			return dBPrimaryKey;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DBPrimaryKey where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DBPrimaryKey CreateUnsavedDefaultDBPrimaryKey()
		{
			DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();
			return dBPrimaryKey;
		}
    }
    
    // Provides the part of the test class that tests DBPrimaryKey objects
    [TestFixture]
    public partial class TestDBPrimaryKey : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBPrimaryKeyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dBPrimaryKey.PrimaryKeyID);
            Assert.IsInstanceOfType(dBPrimaryKey.Props["PrimaryKeyID"].PropertyType, dBPrimaryKey.PrimaryKeyID);
                        Assert.IsNull(dBPrimaryKey.TableID);
                        Assert.IsNotNull(dBPrimaryKey.PendingChangeType);
            Assert.IsInstanceOfType(dBPrimaryKey.Props["PendingChangeType"].PropertyType, dBPrimaryKey.PendingChangeType);
                        Assert.IsNull(dBPrimaryKey.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBPrimaryKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateUnsavedValidDBPrimaryKey();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBPrimaryKey.Status.IsNew);
            BusinessObjectCollection<DBPrimaryKey> col = new BusinessObjectCollection<DBPrimaryKey>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBPrimaryKey.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBPrimaryKey.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBPrimaryKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();

            //---------------Execute Test ----------------------
            DBPrimaryKey loadedDBPrimaryKey = Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dBPrimaryKey.PrimaryKeyID, loadedDBPrimaryKey.PrimaryKeyID);
                        Assert.AreEqual(dBPrimaryKey.TableID, loadedDBPrimaryKey.TableID);
                        Assert.AreEqual(dBPrimaryKey.PendingChangeType, loadedDBPrimaryKey.PendingChangeType);
                        Assert.AreEqual(dBPrimaryKey.Approved, loadedDBPrimaryKey.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBPrimaryKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBPrimaryKey.Delete();
            dBPrimaryKey.Save();
            //---------------Test Result -----------------------
            try
            {
                DBPrimaryKey retrievedDBPrimaryKey = Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBPrimaryKey", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBPrimaryKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBPrimaryKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBPrimaryKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBPrimaryKey.Approved = (System.Boolean) valueForApproved;
            dBPrimaryKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBPrimaryKey retrievedDBPrimaryKey =
                    Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);
            
            Assert.AreEqual(valueForTableID, retrievedDBPrimaryKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, retrievedDBPrimaryKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, retrievedDBPrimaryKey.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBPrimaryKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBPrimaryKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBPrimaryKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTableID, dBPrimaryKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, dBPrimaryKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBPrimaryKey.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBPrimaryKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBPrimaryKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBPrimaryKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTableID, dBPrimaryKey.GetPropertyValue("TableID"));
            Assert.AreEqual(valueForPendingChangeType, dBPrimaryKey.GetPropertyValue("PendingChangeType"));
            Assert.AreEqual(valueForApproved, dBPrimaryKey.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = new DBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;            
            dBPrimaryKey.SetPropertyValue("TableID", valueForTableID);
            object valueForPendingChangeType = null;            
            dBPrimaryKey.SetPropertyValue("PendingChangeType", valueForPendingChangeType);
            object valueForApproved = TestUtils.GetRandomBoolean();            
            dBPrimaryKey.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTableID, dBPrimaryKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, dBPrimaryKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBPrimaryKey.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBPrimaryKey.TableID = null;
            dBPrimaryKey.PendingChangeType = null;
            dBPrimaryKey.Approved = null;
            dBPrimaryKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBPrimaryKey retrievedDBPrimaryKey =
                    Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);
            
            Assert.IsNull(retrievedDBPrimaryKey.TableID);
            Assert.IsNull(retrievedDBPrimaryKey.PendingChangeType);
            Assert.IsNull(retrievedDBPrimaryKey.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            // There are no compulsory properties
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBPrimaryKey>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PrimaryKeyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Table()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();

            FireStarterModeller.BO.DBTable boForRelationshipTable = TestUtils.CreateSavedDBTable();
            dBPrimaryKey.Table = boForRelationshipTable;
            dBPrimaryKey.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipTable.ID);
            DBPrimaryKey loadedDBPrimaryKey = Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipTable, loadedDBPrimaryKey.Table);
            Assert.AreEqual(loadedRelatedBO, loadedDBPrimaryKey.Table);
            Assert.AreEqual(loadedRelatedBO, dBPrimaryKey.Table);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_PrimaryKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();

            FireStarterModeller.BO.DBPrimaryKeyColumn boForRelationshipPrimaryKeyColumns = TestUtils.CreateUnsavedValidDBPrimaryKeyColumn();
            boForRelationshipPrimaryKeyColumns.PrimaryKeyID = dBPrimaryKey.PrimaryKeyID;
            boForRelationshipPrimaryKeyColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBPrimaryKey.PrimaryKeyColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBPrimaryKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBPrimaryKeyColumn>(boForRelationshipPrimaryKeyColumns.ID);
            DBPrimaryKey loadedDBPrimaryKey = Broker.GetBusinessObject<DBPrimaryKey>(dBPrimaryKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBPrimaryKey.PrimaryKeyColumns.Count);
            Assert.AreEqual(boForRelationshipPrimaryKeyColumns, loadedDBPrimaryKey.PrimaryKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBPrimaryKey.PrimaryKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, dBPrimaryKey.PrimaryKeyColumns[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_PrimaryKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKey dBPrimaryKey = TestUtils.CreateSavedDBPrimaryKey();

            FireStarterModeller.BO.DBPrimaryKeyColumn boForRelationshipPrimaryKeyColumns = TestUtils.CreateUnsavedValidDBPrimaryKeyColumn();
            boForRelationshipPrimaryKeyColumns.PrimaryKeyID = dBPrimaryKey.PrimaryKeyID;
            boForRelationshipPrimaryKeyColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBPrimaryKey.PrimaryKeyColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBPrimaryKey>().RelationshipDefCol["PrimaryKeyColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBPrimaryKey.Delete();
                dBPrimaryKey.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'PrimaryKeyColumns' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
