// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMDatabaseLookupList objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMDatabaseLookupList with a random value assigned to every property
        /// </summary>
        public static DMDatabaseLookupList CreateSavedDMDatabaseLookupList()
		{
		    DMDatabaseLookupList dMDatabaseLookupList = CreateUnsavedValidDMDatabaseLookupList();
			dMDatabaseLookupList.Save();
			return dMDatabaseLookupList;
		}

        /// <summary>
        /// Creates a new unsaved DMDatabaseLookupList with a random value assigned to every property
        /// </summary>
		public static DMDatabaseLookupList CreateUnsavedValidDMDatabaseLookupList()
		{
			DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();
			dMDatabaseLookupList.Sql = TestUtils.GetRandomString();
			dMDatabaseLookupList.TimeOut = (decimal)TestUtils.GetRandomInt();
			dMDatabaseLookupList.LookupClassName = TestUtils.GetRandomString();
			dMDatabaseLookupList.Assembly = TestUtils.GetRandomString();
			dMDatabaseLookupList.Generated = TestUtils.GetRandomBoolean();
			return dMDatabaseLookupList;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMDatabaseLookupList where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMDatabaseLookupList CreateUnsavedDefaultDMDatabaseLookupList()
		{
			DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();
			return dMDatabaseLookupList;
		}
    }
    
    // Provides the part of the test class that tests DMDatabaseLookupList objects
    [TestFixture]
    public partial class TestDMDatabaseLookupList : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMDatabaseLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMDatabaseLookupList.DatabaseLookupListID);
            Assert.IsInstanceOfType(dMDatabaseLookupList.Props["DatabaseLookupListID"].PropertyType, dMDatabaseLookupList.DatabaseLookupListID);
                        Assert.IsNull(dMDatabaseLookupList.Sql);
                        Assert.IsNotNull(dMDatabaseLookupList.TimeOut);
            Assert.IsInstanceOfType(dMDatabaseLookupList.Props["TimeOut"].PropertyType, dMDatabaseLookupList.TimeOut);
                        Assert.IsNull(dMDatabaseLookupList.LookupClassName);
                        Assert.IsNull(dMDatabaseLookupList.Assembly);
                        Assert.IsNotNull(dMDatabaseLookupList.LookupListID);
            Assert.IsInstanceOfType(dMDatabaseLookupList.Props["LookupListID"].PropertyType, dMDatabaseLookupList.LookupListID);
                        Assert.IsNotNull(dMDatabaseLookupList.Generated);
            Assert.IsInstanceOfType(dMDatabaseLookupList.Props["Generated"].PropertyType, dMDatabaseLookupList.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateUnsavedValidDMDatabaseLookupList();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMDatabaseLookupList.Status.IsNew);
            BusinessObjectCollection<DMDatabaseLookupList> col = new BusinessObjectCollection<DMDatabaseLookupList>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMDatabaseLookupList.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMDatabaseLookupList.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateSavedDMDatabaseLookupList();

            //---------------Execute Test ----------------------
            DMDatabaseLookupList loadedDMDatabaseLookupList = Broker.GetBusinessObject<DMDatabaseLookupList>(dMDatabaseLookupList.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMDatabaseLookupList.DatabaseLookupListID, loadedDMDatabaseLookupList.DatabaseLookupListID);
                        Assert.AreEqual(dMDatabaseLookupList.Sql, loadedDMDatabaseLookupList.Sql);
                        Assert.AreEqual(dMDatabaseLookupList.TimeOut, loadedDMDatabaseLookupList.TimeOut);
                        Assert.AreEqual(dMDatabaseLookupList.LookupClassName, loadedDMDatabaseLookupList.LookupClassName);
                        Assert.AreEqual(dMDatabaseLookupList.Assembly, loadedDMDatabaseLookupList.Assembly);
                        Assert.AreEqual(dMDatabaseLookupList.LookupListID, loadedDMDatabaseLookupList.LookupListID);
                        Assert.AreEqual(dMDatabaseLookupList.Generated, loadedDMDatabaseLookupList.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMDatabaseLookupList.Delete();
            dMDatabaseLookupList.Save();
            //---------------Test Result -----------------------
            try
            {
                DMDatabaseLookupList retrievedDMDatabaseLookupList = Broker.GetBusinessObject<DMDatabaseLookupList>(dMDatabaseLookupList.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMDatabaseLookupList", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtils.GetRandomString();
            dMDatabaseLookupList.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtils.GetRandomInt();
            dMDatabaseLookupList.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtils.GetRandomString();
            dMDatabaseLookupList.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtils.GetRandomString();
            dMDatabaseLookupList.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMDatabaseLookupList.Generated = (System.Boolean) valueForGenerated;
            dMDatabaseLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMDatabaseLookupList retrievedDMDatabaseLookupList =
                    Broker.GetBusinessObject<DMDatabaseLookupList>(dMDatabaseLookupList.ID);
            
            Assert.AreEqual(valueForSql, retrievedDMDatabaseLookupList.Sql);
            Assert.AreEqual(valueForTimeOut, retrievedDMDatabaseLookupList.TimeOut);
            Assert.AreEqual(valueForLookupClassName, retrievedDMDatabaseLookupList.LookupClassName);
            Assert.AreEqual(valueForAssembly, retrievedDMDatabaseLookupList.Assembly);
            Assert.AreEqual(valueForGenerated, retrievedDMDatabaseLookupList.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtils.GetRandomString();
            dMDatabaseLookupList.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtils.GetRandomInt();
            dMDatabaseLookupList.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtils.GetRandomString();
            dMDatabaseLookupList.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtils.GetRandomString();
            dMDatabaseLookupList.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMDatabaseLookupList.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMDatabaseLookupList.Sql);
            Assert.AreEqual(valueForTimeOut, dMDatabaseLookupList.TimeOut);
            Assert.AreEqual(valueForLookupClassName, dMDatabaseLookupList.LookupClassName);
            Assert.AreEqual(valueForAssembly, dMDatabaseLookupList.Assembly);
            Assert.AreEqual(valueForGenerated, dMDatabaseLookupList.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtils.GetRandomString();
            dMDatabaseLookupList.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtils.GetRandomInt();
            dMDatabaseLookupList.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtils.GetRandomString();
            dMDatabaseLookupList.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtils.GetRandomString();
            dMDatabaseLookupList.Assembly = (System.String) valueForAssembly;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMDatabaseLookupList.GetPropertyValue("Sql"));
            Assert.AreEqual(valueForTimeOut, dMDatabaseLookupList.GetPropertyValue("TimeOut"));
            Assert.AreEqual(valueForLookupClassName, dMDatabaseLookupList.GetPropertyValue("LookupClassName"));
            Assert.AreEqual(valueForAssembly, dMDatabaseLookupList.GetPropertyValue("Assembly"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = new DMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtils.GetRandomString();            
            dMDatabaseLookupList.SetPropertyValue("Sql", valueForSql);
            object valueForTimeOut = (decimal)TestUtils.GetRandomInt();            
            dMDatabaseLookupList.SetPropertyValue("TimeOut", valueForTimeOut);
            object valueForLookupClassName = TestUtils.GetRandomString();            
            dMDatabaseLookupList.SetPropertyValue("LookupClassName", valueForLookupClassName);
            object valueForAssembly = TestUtils.GetRandomString();            
            dMDatabaseLookupList.SetPropertyValue("Assembly", valueForAssembly);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMDatabaseLookupList.Sql);
            Assert.AreEqual(valueForTimeOut, dMDatabaseLookupList.TimeOut);
            Assert.AreEqual(valueForLookupClassName, dMDatabaseLookupList.LookupClassName);
            Assert.AreEqual(valueForAssembly, dMDatabaseLookupList.Assembly);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMDatabaseLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMDatabaseLookupList retrievedDMDatabaseLookupList =
                    Broker.GetBusinessObject<DMDatabaseLookupList>(dMDatabaseLookupList.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateUnsavedValidDMDatabaseLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMDatabaseLookupList.DatabaseLookupListID = null;
            dMDatabaseLookupList.Sql = null;
            dMDatabaseLookupList.TimeOut = null;
            dMDatabaseLookupList.LookupClassName = null;
            dMDatabaseLookupList.Assembly = null;
            dMDatabaseLookupList.LookupListID = null;
            dMDatabaseLookupList.Generated = null;
            
            try
            {
                dMDatabaseLookupList.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Database Lookup List I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Sql' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Time Out' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Lookup Class Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Assembly' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Lookup List I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMDatabaseLookupList>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DatabaseLookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Sql"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TimeOut"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LookupClassName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Assembly"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        
        
        
        
        
        
       
        [Test]
        public void Test_Inheritance_SuperClassDef_Exists()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = ClassDef.Get<DMDatabaseLookupList>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.IsNotNull(superClassDef);
        }

        [Test]  
        public void Test_Inheritance_SuperClassDef_PropertiesCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = ClassDef.Get<DMDatabaseLookupList>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.AreEqual("DMLookupList", superClassDef.ClassName);
            Assert.AreEqual("FireStarterModeller.BO", superClassDef.AssemblyName);
            Assert.IsNull(superClassDef.ID);
        }
		
        [Test]
        public void Test_Inheritance_SuperClassDef_RelatedClassIsCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            ClassDef classDef = ClassDef.Get<DMDatabaseLookupList>();
            SuperClassDef superClassDef = classDef.SuperClassDef;
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ClassDef relatedClassDef = ClassDef.ClassDefs[superClassDef.AssemblyName, superClassDef.ClassName];
            //---------------Test Result -----------------------
            Assert.IsNotNull(relatedClassDef);
                        IPropDef relatedPrimaryKeyDef = relatedClassDef.PrimaryKeyDef[0];
            Assert.IsNotNull(relatedPrimaryKeyDef);
            IPropDef propDef = classDef.PropDefColIncludingInheritance[relatedPrimaryKeyDef.PropertyName];
            Assert.IsNotNull(propDef, "Where no child ID match has been specified, the child must have a property with the same name and type as the parent ID");
            Assert.AreEqual(propDef.PropertyType, relatedPrimaryKeyDef.PropertyType);
        }
        
		
        [Test]
        public void Test_Inheritance_CodeClass_InheritsCorrectly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMDatabaseLookupList dMDatabaseLookupList = TestUtils.CreateUnsavedValidDMDatabaseLookupList();
            //---------------Test Result -----------------------
            Assert.IsInstanceOfType(typeof(FireStarterModeller.BO.DMLookupList), dMDatabaseLookupList);
        }        
    }
}
