// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMListItem objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMListItem with a random value assigned to every property
        /// </summary>
        public static DMListItem CreateSavedDMListItem()
		{
		    DMListItem dMListItem = CreateUnsavedValidDMListItem();
			dMListItem.Save();
			return dMListItem;
		}

        /// <summary>
        /// Creates a new unsaved DMListItem with a random value assigned to every property
        /// </summary>
		public static DMListItem CreateUnsavedValidDMListItem()
		{
			DMListItem dMListItem = new DMListItem();
			dMListItem.Value = TestUtils.GetRandomString();
			dMListItem.Display = TestUtils.GetRandomString();
			dMListItem.Generated = TestUtils.GetRandomBoolean();
			dMListItem.SimpleLookupListID = TestUtils.CreateSavedDMSimpleLookupList().SimpleLookupListID;
			return dMListItem;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMListItem where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMListItem CreateUnsavedDefaultDMListItem()
		{
			DMListItem dMListItem = new DMListItem();
			return dMListItem;
		}
    }
    
    // Provides the part of the test class that tests DMListItem objects
    [TestFixture]
    public partial class TestDMListItem : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMListItemWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMListItem dMListItem = new DMListItem();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMListItem.ListItemID);
            Assert.IsInstanceOfType(dMListItem.Props["ListItemID"].PropertyType, dMListItem.ListItemID);
                        Assert.IsNull(dMListItem.Value);
                        Assert.IsNull(dMListItem.Display);
                        Assert.IsNotNull(dMListItem.Generated);
            Assert.IsInstanceOfType(dMListItem.Props["Generated"].PropertyType, dMListItem.Generated);
                        Assert.IsNull(dMListItem.SimpleLookupListID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMListItem()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = TestUtils.CreateUnsavedValidDMListItem();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMListItem.Status.IsNew);
            BusinessObjectCollection<DMListItem> col = new BusinessObjectCollection<DMListItem>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMListItem.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMListItem.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMListItem()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = TestUtils.CreateSavedDMListItem();

            //---------------Execute Test ----------------------
            DMListItem loadedDMListItem = Broker.GetBusinessObject<DMListItem>(dMListItem.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMListItem.ListItemID, loadedDMListItem.ListItemID);
                        Assert.AreEqual(dMListItem.Value, loadedDMListItem.Value);
                        Assert.AreEqual(dMListItem.Display, loadedDMListItem.Display);
                        Assert.AreEqual(dMListItem.Generated, loadedDMListItem.Generated);
                        Assert.AreEqual(dMListItem.SimpleLookupListID, loadedDMListItem.SimpleLookupListID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMListItem()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = TestUtils.CreateSavedDMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMListItem.Delete();
            dMListItem.Save();
            //---------------Test Result -----------------------
            try
            {
                DMListItem retrievedDMListItem = Broker.GetBusinessObject<DMListItem>(dMListItem.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMListItem", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMListItem()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = TestUtils.CreateSavedDMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForValue = TestUtils.GetRandomString();
            dMListItem.Value = (System.String) valueForValue;
            object valueForDisplay = TestUtils.GetRandomString();
            dMListItem.Display = (System.String) valueForDisplay;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMListItem.Generated = (System.Boolean) valueForGenerated;
            object valueForSimpleLookupListID = TestUtils.CreateSavedDMSimpleLookupList().SimpleLookupListID;
            dMListItem.SimpleLookupListID = (System.Guid) valueForSimpleLookupListID;
            dMListItem.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMListItem retrievedDMListItem =
                    Broker.GetBusinessObject<DMListItem>(dMListItem.ID);
            
            Assert.AreEqual(valueForValue, retrievedDMListItem.Value);
            Assert.AreEqual(valueForDisplay, retrievedDMListItem.Display);
            Assert.AreEqual(valueForGenerated, retrievedDMListItem.Generated);
            Assert.AreEqual(valueForSimpleLookupListID, retrievedDMListItem.SimpleLookupListID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = new DMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForValue = TestUtils.GetRandomString();
            dMListItem.Value = (System.String) valueForValue;
            object valueForDisplay = TestUtils.GetRandomString();
            dMListItem.Display = (System.String) valueForDisplay;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMListItem.Generated = (System.Boolean) valueForGenerated;
            object valueForSimpleLookupListID = TestUtils.CreateSavedDMSimpleLookupList().SimpleLookupListID;
            dMListItem.SimpleLookupListID = (System.Guid) valueForSimpleLookupListID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForValue, dMListItem.Value);
            Assert.AreEqual(valueForDisplay, dMListItem.Display);
            Assert.AreEqual(valueForGenerated, dMListItem.Generated);
            Assert.AreEqual(valueForSimpleLookupListID, dMListItem.SimpleLookupListID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = new DMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForValue = TestUtils.GetRandomString();
            dMListItem.Value = (System.String) valueForValue;
            object valueForDisplay = TestUtils.GetRandomString();
            dMListItem.Display = (System.String) valueForDisplay;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMListItem.Generated = (System.Boolean) valueForGenerated;
            object valueForSimpleLookupListID = TestUtils.CreateSavedDMSimpleLookupList().SimpleLookupListID;
            dMListItem.SimpleLookupListID = (System.Guid) valueForSimpleLookupListID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForValue, dMListItem.GetPropertyValue("Value"));
            Assert.AreEqual(valueForDisplay, dMListItem.GetPropertyValue("Display"));
            Assert.AreEqual(valueForGenerated, dMListItem.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForSimpleLookupListID, dMListItem.GetPropertyValue("SimpleLookupListID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = new DMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForValue = TestUtils.GetRandomString();            
            dMListItem.SetPropertyValue("Value", valueForValue);
            object valueForDisplay = TestUtils.GetRandomString();            
            dMListItem.SetPropertyValue("Display", valueForDisplay);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMListItem.SetPropertyValue("Generated", valueForGenerated);
            object valueForSimpleLookupListID = TestUtils.CreateSavedDMSimpleLookupList().SimpleLookupListID;            
            dMListItem.SetPropertyValue("SimpleLookupListID", valueForSimpleLookupListID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForValue, dMListItem.Value);
            Assert.AreEqual(valueForDisplay, dMListItem.Display);
            Assert.AreEqual(valueForGenerated, dMListItem.Generated);
            Assert.AreEqual(valueForSimpleLookupListID, dMListItem.SimpleLookupListID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMListItem dMListItem = TestUtils.CreateSavedDMListItem();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMListItem.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMListItem retrievedDMListItem =
                    Broker.GetBusinessObject<DMListItem>(dMListItem.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMListItem dMListItem = TestUtils.CreateUnsavedValidDMListItem();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMListItem.ListItemID = null;
            dMListItem.Value = null;
            dMListItem.Display = null;
            dMListItem.Generated = null;
            dMListItem.SimpleLookupListID = null;
            
            try
            {
                dMListItem.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'List Item I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Value' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Display' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Simple Lookup List I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMListItem>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ListItemID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Value"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Display"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SimpleLookupListID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_SimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMListItem dMListItem = TestUtils.CreateSavedDMListItem();

            FireStarterModeller.BO.DMSimpleLookupList boForRelationshipSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();
            dMListItem.SimpleLookupList = boForRelationshipSimpleLookupList;
            dMListItem.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSimpleLookupList loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSimpleLookupList>(boForRelationshipSimpleLookupList.ID);
            DMListItem loadedDMListItem = Broker.GetBusinessObject<DMListItem>(dMListItem.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSimpleLookupList, loadedDMListItem.SimpleLookupList);
            Assert.AreEqual(loadedRelatedBO, loadedDMListItem.SimpleLookupList);
            Assert.AreEqual(loadedRelatedBO, dMListItem.SimpleLookupList);
        }
        
        
        
        
        
        
        
       
    }
}
