// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMProperty objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMProperty with a random value assigned to every property
        /// </summary>
        public static DMProperty CreateSavedDMProperty()
		{
		    DMProperty dMProperty = CreateUnsavedValidDMProperty();
			dMProperty.Save();
			return dMProperty;
		}

        /// <summary>
        /// Creates a new unsaved DMProperty with a random value assigned to every property
        /// </summary>
		public static DMProperty CreateUnsavedValidDMProperty()
		{
			DMProperty dMProperty = new DMProperty();
			dMProperty.Name = TestUtils.GetRandomString();
			dMProperty.ReadWriteRule = null;
			dMProperty.MappedDBColumnName = TestUtils.GetRandomString();
			dMProperty.Description = TestUtils.GetRandomString();
			dMProperty.Compulsory = TestUtils.GetRandomBoolean();
			dMProperty.AutoIncrementing = TestUtils.GetRandomBoolean();
			dMProperty.Length = TestUtils.GetRandomString();
			dMProperty.KeepValuePrivate = TestUtils.GetRandomBoolean();
			dMProperty.DisplayName = TestUtils.GetRandomString();
			dMProperty.Default = TestUtils.GetRandomString();
			dMProperty.ClassID = TestUtils.CreateSavedDMClass().ClassID;
			dMProperty.Generated = TestUtils.GetRandomBoolean();
			dMProperty.ObjectIdentityID = TestUtils.CreateSavedDMObjectIdentity().ObjectIdentityID;
			dMProperty.LookupListID = TestUtils.CreateSavedDMLookupList().LookupListID;
			dMProperty.PropertyTypeID = TestUtils.CreateSavedDMPropertyType().PropertyTypeID;
			dMProperty.MappedDBColumnID = Guid.NewGuid();
			dMProperty.OrdinalPosition = TestUtils.GetRandomInt();
			return dMProperty;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMProperty where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMProperty CreateUnsavedDefaultDMProperty()
		{
			DMProperty dMProperty = new DMProperty();
			return dMProperty;
		}
    }
    
    // Provides the part of the test class that tests DMProperty objects
    [TestFixture]
    public partial class TestDMProperty : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMPropertyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMProperty dMProperty = new DMProperty();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMProperty.ProperyID);
            Assert.IsInstanceOfType(dMProperty.Props["ProperyID"].PropertyType, dMProperty.ProperyID);
                        Assert.IsNull(dMProperty.Name);
                        Assert.IsNotNull(dMProperty.ReadWriteRule);
            Assert.IsInstanceOfType(dMProperty.Props["ReadWriteRule"].PropertyType, dMProperty.ReadWriteRule);
                        Assert.IsNull(dMProperty.MappedDBColumnName);
                        Assert.IsNull(dMProperty.Description);
                        Assert.IsNotNull(dMProperty.Compulsory);
            Assert.IsInstanceOfType(dMProperty.Props["Compulsory"].PropertyType, dMProperty.Compulsory);
                        Assert.IsNotNull(dMProperty.AutoIncrementing);
            Assert.IsInstanceOfType(dMProperty.Props["AutoIncrementing"].PropertyType, dMProperty.AutoIncrementing);
                        Assert.IsNull(dMProperty.Length);
                        Assert.IsNotNull(dMProperty.KeepValuePrivate);
            Assert.IsInstanceOfType(dMProperty.Props["KeepValuePrivate"].PropertyType, dMProperty.KeepValuePrivate);
                        Assert.IsNull(dMProperty.DisplayName);
                        Assert.IsNull(dMProperty.Default);
                        Assert.IsNull(dMProperty.ClassID);
                        Assert.IsNotNull(dMProperty.Generated);
            Assert.IsInstanceOfType(dMProperty.Props["Generated"].PropertyType, dMProperty.Generated);
                        Assert.IsNull(dMProperty.ObjectIdentityID);
                        Assert.IsNull(dMProperty.LookupListID);
                        Assert.IsNull(dMProperty.PropertyTypeID);
                        Assert.IsNull(dMProperty.MappedDBColumnID);
                        Assert.IsNull(dMProperty.OrdinalPosition);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateUnsavedValidDMProperty();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMProperty.Status.IsNew);
            BusinessObjectCollection<DMProperty> col = new BusinessObjectCollection<DMProperty>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMProperty.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMProperty.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            //---------------Execute Test ----------------------
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMProperty.ProperyID, loadedDMProperty.ProperyID);
                        Assert.AreEqual(dMProperty.Name, loadedDMProperty.Name);
                        Assert.AreEqual(dMProperty.ReadWriteRule, loadedDMProperty.ReadWriteRule);
                        Assert.AreEqual(dMProperty.MappedDBColumnName, loadedDMProperty.MappedDBColumnName);
                        Assert.AreEqual(dMProperty.Description, loadedDMProperty.Description);
                        Assert.AreEqual(dMProperty.Compulsory, loadedDMProperty.Compulsory);
                        Assert.AreEqual(dMProperty.AutoIncrementing, loadedDMProperty.AutoIncrementing);
                        Assert.AreEqual(dMProperty.Length, loadedDMProperty.Length);
                        Assert.AreEqual(dMProperty.KeepValuePrivate, loadedDMProperty.KeepValuePrivate);
                        Assert.AreEqual(dMProperty.DisplayName, loadedDMProperty.DisplayName);
                        Assert.AreEqual(dMProperty.Default, loadedDMProperty.Default);
                        Assert.AreEqual(dMProperty.ClassID, loadedDMProperty.ClassID);
                        Assert.AreEqual(dMProperty.Generated, loadedDMProperty.Generated);
                        Assert.AreEqual(dMProperty.ObjectIdentityID, loadedDMProperty.ObjectIdentityID);
                        Assert.AreEqual(dMProperty.LookupListID, loadedDMProperty.LookupListID);
                        Assert.AreEqual(dMProperty.PropertyTypeID, loadedDMProperty.PropertyTypeID);
                        Assert.AreEqual(dMProperty.MappedDBColumnID, loadedDMProperty.MappedDBColumnID);
                        Assert.AreEqual(dMProperty.OrdinalPosition, loadedDMProperty.OrdinalPosition);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMProperty.Delete();
            dMProperty.Save();
            //---------------Test Result -----------------------
            try
            {
                DMProperty retrievedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMProperty", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMProperty.Name = (System.String) valueForName;
            object valueForReadWriteRule = null;
            dMProperty.ReadWriteRule = (Habanero.Base.PropReadWriteRule) valueForReadWriteRule;
            object valueForMappedDBColumnName = TestUtils.GetRandomString();
            dMProperty.MappedDBColumnName = (System.String) valueForMappedDBColumnName;
            object valueForDescription = TestUtils.GetRandomString();
            dMProperty.Description = (System.String) valueForDescription;
            object valueForCompulsory = TestUtils.GetRandomBoolean();
            dMProperty.Compulsory = (System.Boolean) valueForCompulsory;
            object valueForAutoIncrementing = TestUtils.GetRandomBoolean();
            dMProperty.AutoIncrementing = (System.Boolean) valueForAutoIncrementing;
            object valueForLength = TestUtils.GetRandomString();
            dMProperty.Length = (System.String) valueForLength;
            object valueForKeepValuePrivate = TestUtils.GetRandomBoolean();
            dMProperty.KeepValuePrivate = (System.Boolean) valueForKeepValuePrivate;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMProperty.DisplayName = (System.String) valueForDisplayName;
            object valueForDefault = TestUtils.GetRandomString();
            dMProperty.Default = (System.String) valueForDefault;
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMProperty.ClassID = (System.Guid) valueForClassID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMProperty.Generated = (System.Boolean) valueForGenerated;
            object valueForObjectIdentityID = TestUtils.CreateSavedDMObjectIdentity().ObjectIdentityID;
            dMProperty.ObjectIdentityID = (System.Guid) valueForObjectIdentityID;
            object valueForLookupListID = TestUtils.CreateSavedDMLookupList().LookupListID;
            dMProperty.LookupListID = (System.Guid) valueForLookupListID;
            object valueForPropertyTypeID = TestUtils.CreateSavedDMPropertyType().PropertyTypeID;
            dMProperty.PropertyTypeID = (System.Guid) valueForPropertyTypeID;
            object valueForMappedDBColumnID = Guid.NewGuid();
            dMProperty.MappedDBColumnID = (System.Guid) valueForMappedDBColumnID;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dMProperty.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            dMProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMProperty retrievedDMProperty =
                    Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            
            Assert.AreEqual(valueForName, retrievedDMProperty.Name);
            Assert.AreEqual(valueForReadWriteRule, retrievedDMProperty.ReadWriteRule);
            Assert.AreEqual(valueForMappedDBColumnName, retrievedDMProperty.MappedDBColumnName);
            Assert.AreEqual(valueForDescription, retrievedDMProperty.Description);
            Assert.AreEqual(valueForCompulsory, retrievedDMProperty.Compulsory);
            Assert.AreEqual(valueForAutoIncrementing, retrievedDMProperty.AutoIncrementing);
            Assert.AreEqual(valueForLength, retrievedDMProperty.Length);
            Assert.AreEqual(valueForKeepValuePrivate, retrievedDMProperty.KeepValuePrivate);
            Assert.AreEqual(valueForDisplayName, retrievedDMProperty.DisplayName);
            Assert.AreEqual(valueForDefault, retrievedDMProperty.Default);
            Assert.AreEqual(valueForClassID, retrievedDMProperty.ClassID);
            Assert.AreEqual(valueForGenerated, retrievedDMProperty.Generated);
            Assert.AreEqual(valueForObjectIdentityID, retrievedDMProperty.ObjectIdentityID);
            Assert.AreEqual(valueForLookupListID, retrievedDMProperty.LookupListID);
            Assert.AreEqual(valueForPropertyTypeID, retrievedDMProperty.PropertyTypeID);
            Assert.AreEqual(valueForMappedDBColumnID, retrievedDMProperty.MappedDBColumnID);
            Assert.AreEqual(valueForOrdinalPosition, retrievedDMProperty.OrdinalPosition);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = new DMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMProperty.Name = (System.String) valueForName;
            object valueForReadWriteRule = null;
            dMProperty.ReadWriteRule = (Habanero.Base.PropReadWriteRule) valueForReadWriteRule;
            object valueForMappedDBColumnName = TestUtils.GetRandomString();
            dMProperty.MappedDBColumnName = (System.String) valueForMappedDBColumnName;
            object valueForDescription = TestUtils.GetRandomString();
            dMProperty.Description = (System.String) valueForDescription;
            object valueForCompulsory = TestUtils.GetRandomBoolean();
            dMProperty.Compulsory = (System.Boolean) valueForCompulsory;
            object valueForAutoIncrementing = TestUtils.GetRandomBoolean();
            dMProperty.AutoIncrementing = (System.Boolean) valueForAutoIncrementing;
            object valueForLength = TestUtils.GetRandomString();
            dMProperty.Length = (System.String) valueForLength;
            object valueForKeepValuePrivate = TestUtils.GetRandomBoolean();
            dMProperty.KeepValuePrivate = (System.Boolean) valueForKeepValuePrivate;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMProperty.DisplayName = (System.String) valueForDisplayName;
            object valueForDefault = TestUtils.GetRandomString();
            dMProperty.Default = (System.String) valueForDefault;
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMProperty.ClassID = (System.Guid) valueForClassID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMProperty.Generated = (System.Boolean) valueForGenerated;
            object valueForObjectIdentityID = TestUtils.CreateSavedDMObjectIdentity().ObjectIdentityID;
            dMProperty.ObjectIdentityID = (System.Guid) valueForObjectIdentityID;
            object valueForLookupListID = TestUtils.CreateSavedDMLookupList().LookupListID;
            dMProperty.LookupListID = (System.Guid) valueForLookupListID;
            object valueForPropertyTypeID = TestUtils.CreateSavedDMPropertyType().PropertyTypeID;
            dMProperty.PropertyTypeID = (System.Guid) valueForPropertyTypeID;
            object valueForMappedDBColumnID = Guid.NewGuid();
            dMProperty.MappedDBColumnID = (System.Guid) valueForMappedDBColumnID;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dMProperty.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMProperty.Name);
            Assert.AreEqual(valueForReadWriteRule, dMProperty.ReadWriteRule);
            Assert.AreEqual(valueForMappedDBColumnName, dMProperty.MappedDBColumnName);
            Assert.AreEqual(valueForDescription, dMProperty.Description);
            Assert.AreEqual(valueForCompulsory, dMProperty.Compulsory);
            Assert.AreEqual(valueForAutoIncrementing, dMProperty.AutoIncrementing);
            Assert.AreEqual(valueForLength, dMProperty.Length);
            Assert.AreEqual(valueForKeepValuePrivate, dMProperty.KeepValuePrivate);
            Assert.AreEqual(valueForDisplayName, dMProperty.DisplayName);
            Assert.AreEqual(valueForDefault, dMProperty.Default);
            Assert.AreEqual(valueForClassID, dMProperty.ClassID);
            Assert.AreEqual(valueForGenerated, dMProperty.Generated);
            Assert.AreEqual(valueForObjectIdentityID, dMProperty.ObjectIdentityID);
            Assert.AreEqual(valueForLookupListID, dMProperty.LookupListID);
            Assert.AreEqual(valueForPropertyTypeID, dMProperty.PropertyTypeID);
            Assert.AreEqual(valueForMappedDBColumnID, dMProperty.MappedDBColumnID);
            Assert.AreEqual(valueForOrdinalPosition, dMProperty.OrdinalPosition);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = new DMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMProperty.Name = (System.String) valueForName;
            object valueForReadWriteRule = null;
            dMProperty.ReadWriteRule = (Habanero.Base.PropReadWriteRule) valueForReadWriteRule;
            object valueForMappedDBColumnName = TestUtils.GetRandomString();
            dMProperty.MappedDBColumnName = (System.String) valueForMappedDBColumnName;
            object valueForDescription = TestUtils.GetRandomString();
            dMProperty.Description = (System.String) valueForDescription;
            object valueForCompulsory = TestUtils.GetRandomBoolean();
            dMProperty.Compulsory = (System.Boolean) valueForCompulsory;
            object valueForAutoIncrementing = TestUtils.GetRandomBoolean();
            dMProperty.AutoIncrementing = (System.Boolean) valueForAutoIncrementing;
            object valueForLength = TestUtils.GetRandomString();
            dMProperty.Length = (System.String) valueForLength;
            object valueForKeepValuePrivate = TestUtils.GetRandomBoolean();
            dMProperty.KeepValuePrivate = (System.Boolean) valueForKeepValuePrivate;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMProperty.DisplayName = (System.String) valueForDisplayName;
            object valueForDefault = TestUtils.GetRandomString();
            dMProperty.Default = (System.String) valueForDefault;
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMProperty.ClassID = (System.Guid) valueForClassID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMProperty.Generated = (System.Boolean) valueForGenerated;
            object valueForObjectIdentityID = TestUtils.CreateSavedDMObjectIdentity().ObjectIdentityID;
            dMProperty.ObjectIdentityID = (System.Guid) valueForObjectIdentityID;
            object valueForLookupListID = TestUtils.CreateSavedDMLookupList().LookupListID;
            dMProperty.LookupListID = (System.Guid) valueForLookupListID;
            object valueForPropertyTypeID = TestUtils.CreateSavedDMPropertyType().PropertyTypeID;
            dMProperty.PropertyTypeID = (System.Guid) valueForPropertyTypeID;
            object valueForMappedDBColumnID = Guid.NewGuid();
            dMProperty.MappedDBColumnID = (System.Guid) valueForMappedDBColumnID;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dMProperty.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMProperty.GetPropertyValue("Name"));
            Assert.AreEqual(valueForReadWriteRule, dMProperty.GetPropertyValue("ReadWriteRule"));
            Assert.AreEqual(valueForMappedDBColumnName, dMProperty.GetPropertyValue("MappedDBColumnName"));
            Assert.AreEqual(valueForDescription, dMProperty.GetPropertyValue("Description"));
            Assert.AreEqual(valueForCompulsory, dMProperty.GetPropertyValue("Compulsory"));
            Assert.AreEqual(valueForAutoIncrementing, dMProperty.GetPropertyValue("AutoIncrementing"));
            Assert.AreEqual(valueForLength, dMProperty.GetPropertyValue("Length"));
            Assert.AreEqual(valueForKeepValuePrivate, dMProperty.GetPropertyValue("KeepValuePrivate"));
            Assert.AreEqual(valueForDisplayName, dMProperty.GetPropertyValue("DisplayName"));
            Assert.AreEqual(valueForDefault, dMProperty.GetPropertyValue("Default"));
            Assert.AreEqual(valueForClassID, dMProperty.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForGenerated, dMProperty.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForObjectIdentityID, dMProperty.GetPropertyValue("ObjectIdentityID"));
            Assert.AreEqual(valueForLookupListID, dMProperty.GetPropertyValue("LookupListID"));
            Assert.AreEqual(valueForPropertyTypeID, dMProperty.GetPropertyValue("PropertyTypeID"));
            Assert.AreEqual(valueForMappedDBColumnID, dMProperty.GetPropertyValue("MappedDBColumnID"));
            Assert.AreEqual(valueForOrdinalPosition, dMProperty.GetPropertyValue("OrdinalPosition"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = new DMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("Name", valueForName);
            object valueForReadWriteRule = null;            
            dMProperty.SetPropertyValue("ReadWriteRule", valueForReadWriteRule);
            object valueForMappedDBColumnName = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("MappedDBColumnName", valueForMappedDBColumnName);
            object valueForDescription = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("Description", valueForDescription);
            object valueForCompulsory = TestUtils.GetRandomBoolean();            
            dMProperty.SetPropertyValue("Compulsory", valueForCompulsory);
            object valueForAutoIncrementing = TestUtils.GetRandomBoolean();            
            dMProperty.SetPropertyValue("AutoIncrementing", valueForAutoIncrementing);
            object valueForLength = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("Length", valueForLength);
            object valueForKeepValuePrivate = TestUtils.GetRandomBoolean();            
            dMProperty.SetPropertyValue("KeepValuePrivate", valueForKeepValuePrivate);
            object valueForDisplayName = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("DisplayName", valueForDisplayName);
            object valueForDefault = TestUtils.GetRandomString();            
            dMProperty.SetPropertyValue("Default", valueForDefault);
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;            
            dMProperty.SetPropertyValue("ClassID", valueForClassID);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMProperty.SetPropertyValue("Generated", valueForGenerated);
            object valueForObjectIdentityID = TestUtils.CreateSavedDMObjectIdentity().ObjectIdentityID;            
            dMProperty.SetPropertyValue("ObjectIdentityID", valueForObjectIdentityID);
            object valueForLookupListID = TestUtils.CreateSavedDMLookupList().LookupListID;            
            dMProperty.SetPropertyValue("LookupListID", valueForLookupListID);
            object valueForPropertyTypeID = TestUtils.CreateSavedDMPropertyType().PropertyTypeID;            
            dMProperty.SetPropertyValue("PropertyTypeID", valueForPropertyTypeID);
            object valueForMappedDBColumnID = Guid.NewGuid();            
            dMProperty.SetPropertyValue("MappedDBColumnID", valueForMappedDBColumnID);
            object valueForOrdinalPosition = TestUtils.GetRandomInt();            
            dMProperty.SetPropertyValue("OrdinalPosition", valueForOrdinalPosition);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMProperty.Name);
            Assert.AreEqual(valueForReadWriteRule, dMProperty.ReadWriteRule);
            Assert.AreEqual(valueForMappedDBColumnName, dMProperty.MappedDBColumnName);
            Assert.AreEqual(valueForDescription, dMProperty.Description);
            Assert.AreEqual(valueForCompulsory, dMProperty.Compulsory);
            Assert.AreEqual(valueForAutoIncrementing, dMProperty.AutoIncrementing);
            Assert.AreEqual(valueForLength, dMProperty.Length);
            Assert.AreEqual(valueForKeepValuePrivate, dMProperty.KeepValuePrivate);
            Assert.AreEqual(valueForDisplayName, dMProperty.DisplayName);
            Assert.AreEqual(valueForDefault, dMProperty.Default);
            Assert.AreEqual(valueForClassID, dMProperty.ClassID);
            Assert.AreEqual(valueForGenerated, dMProperty.Generated);
            Assert.AreEqual(valueForObjectIdentityID, dMProperty.ObjectIdentityID);
            Assert.AreEqual(valueForLookupListID, dMProperty.LookupListID);
            Assert.AreEqual(valueForPropertyTypeID, dMProperty.PropertyTypeID);
            Assert.AreEqual(valueForMappedDBColumnID, dMProperty.MappedDBColumnID);
            Assert.AreEqual(valueForOrdinalPosition, dMProperty.OrdinalPosition);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMProperty.ReadWriteRule = null;
            dMProperty.MappedDBColumnName = null;
            dMProperty.Description = null;
            dMProperty.Compulsory = null;
            dMProperty.AutoIncrementing = null;
            dMProperty.Length = null;
            dMProperty.KeepValuePrivate = null;
            dMProperty.DisplayName = null;
            dMProperty.Default = null;
            dMProperty.ObjectIdentityID = null;
            dMProperty.LookupListID = null;
            dMProperty.MappedDBColumnID = null;
            dMProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMProperty retrievedDMProperty =
                    Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            
            Assert.IsNull(retrievedDMProperty.ReadWriteRule);
            Assert.IsNull(retrievedDMProperty.MappedDBColumnName);
            Assert.IsNull(retrievedDMProperty.Description);
            Assert.IsNull(retrievedDMProperty.Compulsory);
            Assert.IsNull(retrievedDMProperty.AutoIncrementing);
            Assert.IsNull(retrievedDMProperty.Length);
            Assert.IsNull(retrievedDMProperty.KeepValuePrivate);
            Assert.IsNull(retrievedDMProperty.DisplayName);
            Assert.IsNull(retrievedDMProperty.Default);
            Assert.IsNull(retrievedDMProperty.ObjectIdentityID);
            Assert.IsNull(retrievedDMProperty.LookupListID);
            Assert.IsNull(retrievedDMProperty.MappedDBColumnID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateUnsavedValidDMProperty();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMProperty.ProperyID = null;
            dMProperty.Name = null;
            dMProperty.ClassID = null;
            dMProperty.Generated = null;
            dMProperty.PropertyTypeID = null;
            dMProperty.OrdinalPosition = null;
            
            try
            {
                dMProperty.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Propery ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Class I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Property Type' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Ordinal Position' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMProperty>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteOnce",classDef.PropDefColIncludingInheritance["ProperyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ReadWriteRule"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedDBColumnName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Description"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Compulsory"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AutoIncrementing"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Length"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["KeepValuePrivate"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DisplayName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Default"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ObjectIdentityID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedDBColumnID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["OrdinalPosition"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMClass boForRelationshipClass = TestUtils.CreateSavedDMClass();
            dMProperty.Class = boForRelationshipClass;
            dMProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipClass.ID);
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedDMProperty.Class);
            Assert.AreEqual(loadedRelatedBO, loadedDMProperty.Class);
            Assert.AreEqual(loadedRelatedBO, dMProperty.Class);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_LookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMLookupList boForRelationshipLookupList = TestUtils.CreateSavedDMLookupList();
            dMProperty.LookupList = boForRelationshipLookupList;
            dMProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMLookupList loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMLookupList>(boForRelationshipLookupList.ID);
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipLookupList, loadedDMProperty.LookupList);
            Assert.AreEqual(loadedRelatedBO, loadedDMProperty.LookupList);
            Assert.AreEqual(loadedRelatedBO, dMProperty.LookupList);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMObjectIdentity boForRelationshipObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();
            dMProperty.ObjectIdentity = boForRelationshipObjectIdentity;
            dMProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMObjectIdentity loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMObjectIdentity>(boForRelationshipObjectIdentity.ID);
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipObjectIdentity, loadedDMProperty.ObjectIdentity);
            Assert.AreEqual(loadedRelatedBO, loadedDMProperty.ObjectIdentity);
            Assert.AreEqual(loadedRelatedBO, dMProperty.ObjectIdentity);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_PropertyType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMPropertyType boForRelationshipPropertyType = TestUtils.CreateSavedDMPropertyType();
            dMProperty.PropertyType = boForRelationshipPropertyType;
            dMProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMPropertyType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMPropertyType>(boForRelationshipPropertyType.ID);
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipPropertyType, loadedDMProperty.PropertyType);
            Assert.AreEqual(loadedRelatedBO, loadedDMProperty.PropertyType);
            Assert.AreEqual(loadedRelatedBO, dMProperty.PropertyType);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_PropRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMPropRule boForRelationshipPropRules = TestUtils.CreateUnsavedValidDMPropRule();
            boForRelationshipPropRules.PropertyID = dMProperty.ProperyID;
            boForRelationshipPropRules.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMProperty.PropRules.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMPropRule loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMPropRule>(boForRelationshipPropRules.ID);
            DMProperty loadedDMProperty = Broker.GetBusinessObject<DMProperty>(dMProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMProperty.PropRules.Count);
            Assert.AreEqual(boForRelationshipPropRules, loadedDMProperty.PropRules[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMProperty.PropRules[0]);
            Assert.AreEqual(loadedRelatedBO, dMProperty.PropRules[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_PropRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMProperty dMProperty = TestUtils.CreateSavedDMProperty();

            FireStarterModeller.BO.DMPropRule boForRelationshipPropRules = TestUtils.CreateUnsavedValidDMPropRule();
            boForRelationshipPropRules.PropertyID = dMProperty.ProperyID;
            boForRelationshipPropRules.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMProperty.PropRules.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMProperty>().RelationshipDefCol["PropRules"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMProperty.Delete();
                dMProperty.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'PropRules' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
