// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMPropertyType objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMPropertyType with a random value assigned to every property
        /// </summary>
        public static DMPropertyType CreateSavedDMPropertyType()
		{
		    DMPropertyType dMPropertyType = CreateUnsavedValidDMPropertyType();
			dMPropertyType.Save();
			return dMPropertyType;
		}

        /// <summary>
        /// Creates a new unsaved DMPropertyType with a random value assigned to every property
        /// </summary>
		public static DMPropertyType CreateUnsavedValidDMPropertyType()
		{
			DMPropertyType dMPropertyType = new DMPropertyType();
			dMPropertyType.AssemblyName = TestUtils.GetRandomString();
			dMPropertyType.TypeName = TestUtils.GetRandomString();
			dMPropertyType.ProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
			return dMPropertyType;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMPropertyType where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMPropertyType CreateUnsavedDefaultDMPropertyType()
		{
			DMPropertyType dMPropertyType = new DMPropertyType();
			return dMPropertyType;
		}
    }
    
    // Provides the part of the test class that tests DMPropertyType objects
    [TestFixture]
    public partial class TestDMPropertyType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMPropertyTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMPropertyType dMPropertyType = new DMPropertyType();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMPropertyType.PropertyTypeID);
            Assert.IsInstanceOfType(dMPropertyType.Props["PropertyTypeID"].PropertyType, dMPropertyType.PropertyTypeID);
                        Assert.IsNotNull(dMPropertyType.AssemblyName);
            Assert.IsInstanceOfType(dMPropertyType.Props["AssemblyName"].PropertyType, dMPropertyType.AssemblyName);
                        Assert.IsNull(dMPropertyType.TypeName);
                        Assert.IsNull(dMPropertyType.ProjectID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMPropertyType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = TestUtils.CreateUnsavedValidDMPropertyType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMPropertyType.Status.IsNew);
            BusinessObjectCollection<DMPropertyType> col = new BusinessObjectCollection<DMPropertyType>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMPropertyType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMPropertyType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMPropertyType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = TestUtils.CreateSavedDMPropertyType();

            //---------------Execute Test ----------------------
            DMPropertyType loadedDMPropertyType = Broker.GetBusinessObject<DMPropertyType>(dMPropertyType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMPropertyType.PropertyTypeID, loadedDMPropertyType.PropertyTypeID);
                        Assert.AreEqual(dMPropertyType.AssemblyName, loadedDMPropertyType.AssemblyName);
                        Assert.AreEqual(dMPropertyType.TypeName, loadedDMPropertyType.TypeName);
                        Assert.AreEqual(dMPropertyType.ProjectID, loadedDMPropertyType.ProjectID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMPropertyType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = TestUtils.CreateSavedDMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropertyType.Delete();
            dMPropertyType.Save();
            //---------------Test Result -----------------------
            try
            {
                DMPropertyType retrievedDMPropertyType = Broker.GetBusinessObject<DMPropertyType>(dMPropertyType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMPropertyType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMPropertyType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = TestUtils.CreateSavedDMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            dMPropertyType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            dMPropertyType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMPropertyType.ProjectID = (System.Guid) valueForProjectID;
            dMPropertyType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropertyType retrievedDMPropertyType =
                    Broker.GetBusinessObject<DMPropertyType>(dMPropertyType.ID);
            
            Assert.AreEqual(valueForAssemblyName, retrievedDMPropertyType.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedDMPropertyType.TypeName);
            Assert.AreEqual(valueForProjectID, retrievedDMPropertyType.ProjectID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = new DMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            dMPropertyType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            dMPropertyType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMPropertyType.ProjectID = (System.Guid) valueForProjectID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, dMPropertyType.AssemblyName);
            Assert.AreEqual(valueForTypeName, dMPropertyType.TypeName);
            Assert.AreEqual(valueForProjectID, dMPropertyType.ProjectID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = new DMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            dMPropertyType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            dMPropertyType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMPropertyType.ProjectID = (System.Guid) valueForProjectID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, dMPropertyType.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, dMPropertyType.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForProjectID, dMPropertyType.GetPropertyValue("ProjectID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = new DMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();            
            dMPropertyType.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtils.GetRandomString();            
            dMPropertyType.SetPropertyValue("TypeName", valueForTypeName);
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;            
            dMPropertyType.SetPropertyValue("ProjectID", valueForProjectID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, dMPropertyType.AssemblyName);
            Assert.AreEqual(valueForTypeName, dMPropertyType.TypeName);
            Assert.AreEqual(valueForProjectID, dMPropertyType.ProjectID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropertyType dMPropertyType = TestUtils.CreateSavedDMPropertyType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropertyType.ProjectID = null;
            dMPropertyType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropertyType retrievedDMPropertyType =
                    Broker.GetBusinessObject<DMPropertyType>(dMPropertyType.ID);
            
            Assert.IsNull(retrievedDMPropertyType.ProjectID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropertyType dMPropertyType = TestUtils.CreateUnsavedValidDMPropertyType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropertyType.PropertyTypeID = null;
            dMPropertyType.AssemblyName = null;
            dMPropertyType.TypeName = null;
            
            try
            {
                dMPropertyType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Property Type I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Assembly Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Type Name' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMPropertyType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ProjectID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropertyType dMPropertyType = TestUtils.CreateSavedDMPropertyType();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution = TestUtils.CreateSavedDMSolution();
            dMPropertyType.Solution = boForRelationshipSolution;
            dMPropertyType.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSolution loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution.ID);
            DMPropertyType loadedDMPropertyType = Broker.GetBusinessObject<DMPropertyType>(dMPropertyType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedDMPropertyType.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedDMPropertyType.Solution);
            Assert.AreEqual(loadedRelatedBO, dMPropertyType.Solution);
        }
        
        
        
        
        
        
        
       
    }
}
