// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMSimpleLookupList objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMSimpleLookupList with a random value assigned to every property
        /// </summary>
        public static DMSimpleLookupList CreateSavedDMSimpleLookupList()
		{
		    DMSimpleLookupList dMSimpleLookupList = CreateUnsavedValidDMSimpleLookupList();
			dMSimpleLookupList.Save();
			return dMSimpleLookupList;
		}

        /// <summary>
        /// Creates a new unsaved DMSimpleLookupList with a random value assigned to every property
        /// </summary>
		public static DMSimpleLookupList CreateUnsavedValidDMSimpleLookupList()
		{
			DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();
			dMSimpleLookupList.Generated = TestUtils.GetRandomBoolean();
			return dMSimpleLookupList;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMSimpleLookupList where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMSimpleLookupList CreateUnsavedDefaultDMSimpleLookupList()
		{
			DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();
			return dMSimpleLookupList;
		}
    }
    
    // Provides the part of the test class that tests DMSimpleLookupList objects
    [TestFixture]
    public partial class TestDMSimpleLookupList : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSimpleLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMSimpleLookupList.SimpleLookupListID);
            Assert.IsInstanceOfType(dMSimpleLookupList.Props["SimpleLookupListID"].PropertyType, dMSimpleLookupList.SimpleLookupListID);
                        Assert.IsNotNull(dMSimpleLookupList.LookupListID);
            Assert.IsInstanceOfType(dMSimpleLookupList.Props["LookupListID"].PropertyType, dMSimpleLookupList.LookupListID);
                        Assert.IsNotNull(dMSimpleLookupList.Generated);
            Assert.IsInstanceOfType(dMSimpleLookupList.Props["Generated"].PropertyType, dMSimpleLookupList.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateUnsavedValidDMSimpleLookupList();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSimpleLookupList.Status.IsNew);
            BusinessObjectCollection<DMSimpleLookupList> col = new BusinessObjectCollection<DMSimpleLookupList>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMSimpleLookupList.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSimpleLookupList.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();

            //---------------Execute Test ----------------------
            DMSimpleLookupList loadedDMSimpleLookupList = Broker.GetBusinessObject<DMSimpleLookupList>(dMSimpleLookupList.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSimpleLookupList.SimpleLookupListID, loadedDMSimpleLookupList.SimpleLookupListID);
                        Assert.AreEqual(dMSimpleLookupList.LookupListID, loadedDMSimpleLookupList.LookupListID);
                        Assert.AreEqual(dMSimpleLookupList.Generated, loadedDMSimpleLookupList.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSimpleLookupList.Delete();
            dMSimpleLookupList.Save();
            //---------------Test Result -----------------------
            try
            {
                DMSimpleLookupList retrievedDMSimpleLookupList = Broker.GetBusinessObject<DMSimpleLookupList>(dMSimpleLookupList.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSimpleLookupList", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSimpleLookupList.Generated = (System.Boolean) valueForGenerated;
            dMSimpleLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSimpleLookupList retrievedDMSimpleLookupList =
                    Broker.GetBusinessObject<DMSimpleLookupList>(dMSimpleLookupList.ID);
            
            Assert.AreEqual(valueForGenerated, retrievedDMSimpleLookupList.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSimpleLookupList.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerated, dMSimpleLookupList.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = new DMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSimpleLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSimpleLookupList retrievedDMSimpleLookupList =
                    Broker.GetBusinessObject<DMSimpleLookupList>(dMSimpleLookupList.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateUnsavedValidDMSimpleLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSimpleLookupList.SimpleLookupListID = null;
            dMSimpleLookupList.LookupListID = null;
            dMSimpleLookupList.Generated = null;
            
            try
            {
                dMSimpleLookupList.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Simple Lookup List I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Lookup List I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSimpleLookupList>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SimpleLookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ListItems()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();

            FireStarterModeller.BO.DMListItem boForRelationshipListItems = TestUtils.CreateUnsavedValidDMListItem();
            boForRelationshipListItems.SimpleLookupListID = dMSimpleLookupList.SimpleLookupListID;
            boForRelationshipListItems.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSimpleLookupList.ListItems.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMListItem loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMListItem>(boForRelationshipListItems.ID);
            DMSimpleLookupList loadedDMSimpleLookupList = Broker.GetBusinessObject<DMSimpleLookupList>(dMSimpleLookupList.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSimpleLookupList.ListItems.Count);
            Assert.AreEqual(boForRelationshipListItems, loadedDMSimpleLookupList.ListItems[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSimpleLookupList.ListItems[0]);
            Assert.AreEqual(loadedRelatedBO, dMSimpleLookupList.ListItems[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ListItems()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateSavedDMSimpleLookupList();

            FireStarterModeller.BO.DMListItem boForRelationshipListItems = TestUtils.CreateUnsavedValidDMListItem();
            boForRelationshipListItems.SimpleLookupListID = dMSimpleLookupList.SimpleLookupListID;
            boForRelationshipListItems.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSimpleLookupList.ListItems.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSimpleLookupList>().RelationshipDefCol["ListItems"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMSimpleLookupList.Delete();
                dMSimpleLookupList.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'ListItems' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
        [Test]
        public void Test_Inheritance_SuperClassDef_Exists()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = ClassDef.Get<DMSimpleLookupList>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.IsNotNull(superClassDef);
        }

        [Test]  
        public void Test_Inheritance_SuperClassDef_PropertiesCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = ClassDef.Get<DMSimpleLookupList>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.AreEqual("DMLookupList", superClassDef.ClassName);
            Assert.AreEqual("FireStarterModeller.BO", superClassDef.AssemblyName);
            Assert.IsNull(superClassDef.ID);
        }
		
        [Test]
        public void Test_Inheritance_SuperClassDef_RelatedClassIsCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            ClassDef classDef = ClassDef.Get<DMSimpleLookupList>();
            SuperClassDef superClassDef = classDef.SuperClassDef;
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ClassDef relatedClassDef = ClassDef.ClassDefs[superClassDef.AssemblyName, superClassDef.ClassName];
            //---------------Test Result -----------------------
            Assert.IsNotNull(relatedClassDef);
                        IPropDef relatedPrimaryKeyDef = relatedClassDef.PrimaryKeyDef[0];
            Assert.IsNotNull(relatedPrimaryKeyDef);
            IPropDef propDef = classDef.PropDefColIncludingInheritance[relatedPrimaryKeyDef.PropertyName];
            Assert.IsNotNull(propDef, "Where no child ID match has been specified, the child must have a property with the same name and type as the parent ID");
            Assert.AreEqual(propDef.PropertyType, relatedPrimaryKeyDef.PropertyType);
        }
        
		
        [Test]
        public void Test_Inheritance_CodeClass_InheritsCorrectly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSimpleLookupList dMSimpleLookupList = TestUtils.CreateUnsavedValidDMSimpleLookupList();
            //---------------Test Result -----------------------
            Assert.IsInstanceOfType(typeof(FireStarterModeller.BO.DMLookupList), dMSimpleLookupList);
        }        
    }
}
