// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMSuperClass objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMSuperClass with a random value assigned to every property
        /// </summary>
        public static DMSuperClass CreateSavedDMSuperClass()
		{
		    DMSuperClass dMSuperClass = CreateUnsavedValidDMSuperClass();
			dMSuperClass.Save();
			return dMSuperClass;
		}

        /// <summary>
        /// Creates a new unsaved DMSuperClass with a random value assigned to every property
        /// </summary>
		public static DMSuperClass CreateUnsavedValidDMSuperClass()
		{
			DMSuperClass dMSuperClass = new DMSuperClass();
			dMSuperClass.SuperClassClassID = TestUtils.CreateSavedDMClass().ClassID;
			dMSuperClass.Identity = TestUtils.GetRandomString();
			dMSuperClass.Discriminator = TestUtils.GetRandomString();
			dMSuperClass.Generated = TestUtils.GetRandomBoolean();
			dMSuperClass.InheritanceType = null;
			return dMSuperClass;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMSuperClass where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMSuperClass CreateUnsavedDefaultDMSuperClass()
		{
			DMSuperClass dMSuperClass = new DMSuperClass();
			return dMSuperClass;
		}
    }
    
    // Provides the part of the test class that tests DMSuperClass objects
    [TestFixture]
    public partial class TestDMSuperClass : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSuperClassWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSuperClass dMSuperClass = new DMSuperClass();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMSuperClass.SuperClassID);
            Assert.IsInstanceOfType(dMSuperClass.Props["SuperClassID"].PropertyType, dMSuperClass.SuperClassID);
                        Assert.IsNull(dMSuperClass.SuperClassClassID);
                        Assert.IsNull(dMSuperClass.Identity);
                        Assert.IsNull(dMSuperClass.Discriminator);
                        Assert.IsNotNull(dMSuperClass.Generated);
            Assert.IsInstanceOfType(dMSuperClass.Props["Generated"].PropertyType, dMSuperClass.Generated);
                        Assert.IsNotNull(dMSuperClass.InheritanceType);
            Assert.IsInstanceOfType(dMSuperClass.Props["InheritanceType"].PropertyType, dMSuperClass.InheritanceType);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = TestUtils.CreateUnsavedValidDMSuperClass();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSuperClass.Status.IsNew);
            BusinessObjectCollection<DMSuperClass> col = new BusinessObjectCollection<DMSuperClass>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMSuperClass.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSuperClass.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();

            //---------------Execute Test ----------------------
            DMSuperClass loadedDMSuperClass = Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSuperClass.SuperClassID, loadedDMSuperClass.SuperClassID);
                        Assert.AreEqual(dMSuperClass.SuperClassClassID, loadedDMSuperClass.SuperClassClassID);
                        Assert.AreEqual(dMSuperClass.Identity, loadedDMSuperClass.Identity);
                        Assert.AreEqual(dMSuperClass.Discriminator, loadedDMSuperClass.Discriminator);
                        Assert.AreEqual(dMSuperClass.Generated, loadedDMSuperClass.Generated);
                        Assert.AreEqual(dMSuperClass.InheritanceType, loadedDMSuperClass.InheritanceType);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSuperClass.Delete();
            dMSuperClass.Save();
            //---------------Test Result -----------------------
            try
            {
                DMSuperClass retrievedDMSuperClass = Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSuperClass", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSuperClassClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMSuperClass.SuperClassClassID = (System.Guid) valueForSuperClassClassID;
            object valueForIdentity = TestUtils.GetRandomString();
            dMSuperClass.Identity = (System.String) valueForIdentity;
            object valueForDiscriminator = TestUtils.GetRandomString();
            dMSuperClass.Discriminator = (System.String) valueForDiscriminator;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSuperClass.Generated = (System.Boolean) valueForGenerated;
            object valueForInheritanceType = null;
            dMSuperClass.InheritanceType = (Habanero.BO.Habanero.BO.ClassDefinition.ORMapping) valueForInheritanceType;
            dMSuperClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSuperClass retrievedDMSuperClass =
                    Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);
            
            Assert.AreEqual(valueForSuperClassClassID, retrievedDMSuperClass.SuperClassClassID);
            Assert.AreEqual(valueForIdentity, retrievedDMSuperClass.Identity);
            Assert.AreEqual(valueForDiscriminator, retrievedDMSuperClass.Discriminator);
            Assert.AreEqual(valueForGenerated, retrievedDMSuperClass.Generated);
            Assert.AreEqual(valueForInheritanceType, retrievedDMSuperClass.InheritanceType);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = new DMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSuperClassClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMSuperClass.SuperClassClassID = (System.Guid) valueForSuperClassClassID;
            object valueForIdentity = TestUtils.GetRandomString();
            dMSuperClass.Identity = (System.String) valueForIdentity;
            object valueForDiscriminator = TestUtils.GetRandomString();
            dMSuperClass.Discriminator = (System.String) valueForDiscriminator;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSuperClass.Generated = (System.Boolean) valueForGenerated;
            object valueForInheritanceType = null;
            dMSuperClass.InheritanceType = (Habanero.BO.Habanero.BO.ClassDefinition.ORMapping) valueForInheritanceType;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSuperClassClassID, dMSuperClass.SuperClassClassID);
            Assert.AreEqual(valueForIdentity, dMSuperClass.Identity);
            Assert.AreEqual(valueForDiscriminator, dMSuperClass.Discriminator);
            Assert.AreEqual(valueForGenerated, dMSuperClass.Generated);
            Assert.AreEqual(valueForInheritanceType, dMSuperClass.InheritanceType);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = new DMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSuperClassClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMSuperClass.SuperClassClassID = (System.Guid) valueForSuperClassClassID;
            object valueForIdentity = TestUtils.GetRandomString();
            dMSuperClass.Identity = (System.String) valueForIdentity;
            object valueForDiscriminator = TestUtils.GetRandomString();
            dMSuperClass.Discriminator = (System.String) valueForDiscriminator;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSuperClass.Generated = (System.Boolean) valueForGenerated;
            object valueForInheritanceType = null;
            dMSuperClass.InheritanceType = (Habanero.BO.Habanero.BO.ClassDefinition.ORMapping) valueForInheritanceType;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSuperClassClassID, dMSuperClass.GetPropertyValue("SuperClassClassID"));
            Assert.AreEqual(valueForIdentity, dMSuperClass.GetPropertyValue("Identity"));
            Assert.AreEqual(valueForDiscriminator, dMSuperClass.GetPropertyValue("Discriminator"));
            Assert.AreEqual(valueForGenerated, dMSuperClass.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForInheritanceType, dMSuperClass.GetPropertyValue("InheritanceType"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = new DMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSuperClassClassID = TestUtils.CreateSavedDMClass().ClassID;            
            dMSuperClass.SetPropertyValue("SuperClassClassID", valueForSuperClassClassID);
            object valueForIdentity = TestUtils.GetRandomString();            
            dMSuperClass.SetPropertyValue("Identity", valueForIdentity);
            object valueForDiscriminator = TestUtils.GetRandomString();            
            dMSuperClass.SetPropertyValue("Discriminator", valueForDiscriminator);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMSuperClass.SetPropertyValue("Generated", valueForGenerated);
            object valueForInheritanceType = null;            
            dMSuperClass.SetPropertyValue("InheritanceType", valueForInheritanceType);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSuperClassClassID, dMSuperClass.SuperClassClassID);
            Assert.AreEqual(valueForIdentity, dMSuperClass.Identity);
            Assert.AreEqual(valueForDiscriminator, dMSuperClass.Discriminator);
            Assert.AreEqual(valueForGenerated, dMSuperClass.Generated);
            Assert.AreEqual(valueForInheritanceType, dMSuperClass.InheritanceType);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSuperClass.Identity = null;
            dMSuperClass.Discriminator = null;
            dMSuperClass.InheritanceType = null;
            dMSuperClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSuperClass retrievedDMSuperClass =
                    Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);
            
            Assert.IsNull(retrievedDMSuperClass.Identity);
            Assert.IsNull(retrievedDMSuperClass.Discriminator);
            Assert.IsNull(retrievedDMSuperClass.InheritanceType);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSuperClass dMSuperClass = TestUtils.CreateUnsavedValidDMSuperClass();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSuperClass.SuperClassClassID = null;
            dMSuperClass.Generated = null;
            
            try
            {
                dMSuperClass.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Super Class Class' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSuperClass>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SuperClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SuperClassClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Identity"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Discriminator"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["InheritanceType"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();

            FireStarterModeller.BO.DMClass boForRelationshipClass = TestUtils.CreateSavedDMClass();
            dMSuperClass.Class = boForRelationshipClass;
            dMSuperClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipClass.ID);
            DMSuperClass loadedDMSuperClass = Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedDMSuperClass.Class);
            Assert.AreEqual(loadedRelatedBO, loadedDMSuperClass.Class);
            Assert.AreEqual(loadedRelatedBO, dMSuperClass.Class);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_SuperClassClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSuperClass dMSuperClass = TestUtils.CreateSavedDMSuperClass();

            FireStarterModeller.BO.DMClass boForRelationshipSuperClassClass = TestUtils.CreateSavedDMClass();
            dMSuperClass.SuperClassClass = boForRelationshipSuperClassClass;
            dMSuperClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipSuperClassClass.ID);
            DMSuperClass loadedDMSuperClass = Broker.GetBusinessObject<DMSuperClass>(dMSuperClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSuperClassClass, loadedDMSuperClass.SuperClassClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMSuperClass.SuperClassClass);
            Assert.AreEqual(loadedRelatedBO, dMSuperClass.SuperClassClass);
        }
        
        
        
        
        
        
        
       
    }
}
