// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMUniqueConstraintProperty objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMUniqueConstraintProperty with a random value assigned to every property
        /// </summary>
        public static DMUniqueConstraintProperty CreateSavedDMUniqueConstraintProperty()
		{
		    DMUniqueConstraintProperty dMUniqueConstraintProperty = CreateUnsavedValidDMUniqueConstraintProperty();
			dMUniqueConstraintProperty.Save();
			return dMUniqueConstraintProperty;
		}

        /// <summary>
        /// Creates a new unsaved DMUniqueConstraintProperty with a random value assigned to every property
        /// </summary>
		public static DMUniqueConstraintProperty CreateUnsavedValidDMUniqueConstraintProperty()
		{
			DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();
			dMUniqueConstraintProperty.PropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
			dMUniqueConstraintProperty.UniqueConstraintID = TestUtils.CreateSavedDMUniqueConstraint().UniqueConstraintID;
			return dMUniqueConstraintProperty;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMUniqueConstraintProperty where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMUniqueConstraintProperty CreateUnsavedDefaultDMUniqueConstraintProperty()
		{
			DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();
			return dMUniqueConstraintProperty;
		}
    }
    
    // Provides the part of the test class that tests DMUniqueConstraintProperty objects
    [TestFixture]
    public partial class TestDMUniqueConstraintProperty : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMUniqueConstraintPropertyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMUniqueConstraintProperty.UniqueConstraintPropertyID);
            Assert.IsInstanceOfType(dMUniqueConstraintProperty.Props["UniqueConstraintPropertyID"].PropertyType, dMUniqueConstraintProperty.UniqueConstraintPropertyID);
                        Assert.IsNull(dMUniqueConstraintProperty.PropertyID);
                        Assert.IsNull(dMUniqueConstraintProperty.UniqueConstraintID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMUniqueConstraintProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateUnsavedValidDMUniqueConstraintProperty();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMUniqueConstraintProperty.Status.IsNew);
            BusinessObjectCollection<DMUniqueConstraintProperty> col = new BusinessObjectCollection<DMUniqueConstraintProperty>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMUniqueConstraintProperty.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMUniqueConstraintProperty.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMUniqueConstraintProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();

            //---------------Execute Test ----------------------
            DMUniqueConstraintProperty loadedDMUniqueConstraintProperty = Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMUniqueConstraintProperty.UniqueConstraintPropertyID, loadedDMUniqueConstraintProperty.UniqueConstraintPropertyID);
                        Assert.AreEqual(dMUniqueConstraintProperty.PropertyID, loadedDMUniqueConstraintProperty.PropertyID);
                        Assert.AreEqual(dMUniqueConstraintProperty.UniqueConstraintID, loadedDMUniqueConstraintProperty.UniqueConstraintID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMUniqueConstraintProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraintProperty.Delete();
            dMUniqueConstraintProperty.Save();
            //---------------Test Result -----------------------
            try
            {
                DMUniqueConstraintProperty retrievedDMUniqueConstraintProperty = Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMUniqueConstraintProperty", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMUniqueConstraintProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMUniqueConstraintProperty.PropertyID = (System.Guid) valueForPropertyID;
            object valueForUniqueConstraintID = TestUtils.CreateSavedDMUniqueConstraint().UniqueConstraintID;
            dMUniqueConstraintProperty.UniqueConstraintID = (System.Guid) valueForUniqueConstraintID;
            dMUniqueConstraintProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMUniqueConstraintProperty retrievedDMUniqueConstraintProperty =
                    Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);
            
            Assert.AreEqual(valueForPropertyID, retrievedDMUniqueConstraintProperty.PropertyID);
            Assert.AreEqual(valueForUniqueConstraintID, retrievedDMUniqueConstraintProperty.UniqueConstraintID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMUniqueConstraintProperty.PropertyID = (System.Guid) valueForPropertyID;
            object valueForUniqueConstraintID = TestUtils.CreateSavedDMUniqueConstraint().UniqueConstraintID;
            dMUniqueConstraintProperty.UniqueConstraintID = (System.Guid) valueForUniqueConstraintID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPropertyID, dMUniqueConstraintProperty.PropertyID);
            Assert.AreEqual(valueForUniqueConstraintID, dMUniqueConstraintProperty.UniqueConstraintID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMUniqueConstraintProperty.PropertyID = (System.Guid) valueForPropertyID;
            object valueForUniqueConstraintID = TestUtils.CreateSavedDMUniqueConstraint().UniqueConstraintID;
            dMUniqueConstraintProperty.UniqueConstraintID = (System.Guid) valueForUniqueConstraintID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPropertyID, dMUniqueConstraintProperty.GetPropertyValue("PropertyID"));
            Assert.AreEqual(valueForUniqueConstraintID, dMUniqueConstraintProperty.GetPropertyValue("UniqueConstraintID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = new DMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;            
            dMUniqueConstraintProperty.SetPropertyValue("PropertyID", valueForPropertyID);
            object valueForUniqueConstraintID = TestUtils.CreateSavedDMUniqueConstraint().UniqueConstraintID;            
            dMUniqueConstraintProperty.SetPropertyValue("UniqueConstraintID", valueForUniqueConstraintID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPropertyID, dMUniqueConstraintProperty.PropertyID);
            Assert.AreEqual(valueForUniqueConstraintID, dMUniqueConstraintProperty.UniqueConstraintID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraintProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMUniqueConstraintProperty retrievedDMUniqueConstraintProperty =
                    Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateUnsavedValidDMUniqueConstraintProperty();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraintProperty.UniqueConstraintPropertyID = null;
            dMUniqueConstraintProperty.PropertyID = null;
            dMUniqueConstraintProperty.UniqueConstraintID = null;
            
            try
            {
                dMUniqueConstraintProperty.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Unique Constraint Property I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Property' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Unique Constraint I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMUniqueConstraintProperty>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UniqueConstraintPropertyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UniqueConstraintID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Property()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();

            FireStarterModeller.BO.DMProperty boForRelationshipProperty = TestUtils.CreateSavedDMProperty();
            dMUniqueConstraintProperty.Property = boForRelationshipProperty;
            dMUniqueConstraintProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperty.ID);
            DMUniqueConstraintProperty loadedDMUniqueConstraintProperty = Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipProperty, loadedDMUniqueConstraintProperty.Property);
            Assert.AreEqual(loadedRelatedBO, loadedDMUniqueConstraintProperty.Property);
            Assert.AreEqual(loadedRelatedBO, dMUniqueConstraintProperty.Property);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UniqueConstraint()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraintProperty dMUniqueConstraintProperty = TestUtils.CreateSavedDMUniqueConstraintProperty();

            FireStarterModeller.BO.DMUniqueConstraint boForRelationshipUniqueConstraint = TestUtils.CreateSavedDMUniqueConstraint();
            dMUniqueConstraintProperty.UniqueConstraint = boForRelationshipUniqueConstraint;
            dMUniqueConstraintProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMUniqueConstraint loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMUniqueConstraint>(boForRelationshipUniqueConstraint.ID);
            DMUniqueConstraintProperty loadedDMUniqueConstraintProperty = Broker.GetBusinessObject<DMUniqueConstraintProperty>(dMUniqueConstraintProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUniqueConstraint, loadedDMUniqueConstraintProperty.UniqueConstraint);
            Assert.AreEqual(loadedRelatedBO, loadedDMUniqueConstraintProperty.UniqueConstraint);
            Assert.AreEqual(loadedRelatedBO, dMUniqueConstraintProperty.UniqueConstraint);
        }
        
        
        
        
        
        
        
       
    }
}
