// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UIColumn objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UIColumn with a random value assigned to every property
        /// </summary>
        public static UIColumn CreateSavedUIColumn()
		{
		    UIColumn uIColumn = CreateUnsavedValidUIColumn();
			uIColumn.Save();
			return uIColumn;
		}

        /// <summary>
        /// Creates a new unsaved UIColumn with a random value assigned to every property
        /// </summary>
		public static UIColumn CreateUnsavedValidUIColumn()
		{
			UIColumn uIColumn = new UIColumn();
			uIColumn.Heading = TestUtils.GetRandomString();
			uIColumn.Property = TestUtils.GetRandomString();
			uIColumn.UIGridColumnControlTypeID = TestUtils.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
			uIColumn.Editable = TestUtils.GetRandomBoolean();
			uIColumn.Width = (decimal)TestUtils.GetRandomInt();
			uIColumn.Alignment = TestUtils.GetRandomString();
			uIColumn.Generated = TestUtils.GetRandomBoolean();
			uIColumn.UIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
			return uIColumn;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIColumn where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIColumn CreateUnsavedDefaultUIColumn()
		{
			UIColumn uIColumn = new UIColumn();
			return uIColumn;
		}
    }
    
    // Provides the part of the test class that tests UIColumn objects
    [TestFixture]
    public partial class TestUIColumn : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIColumn uIColumn = new UIColumn();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIColumn.UIColumnID);
            Assert.IsInstanceOfType(uIColumn.Props["UIColumnID"].PropertyType, uIColumn.UIColumnID);
                        Assert.IsNull(uIColumn.Heading);
                        Assert.IsNull(uIColumn.Property);
                        Assert.IsNull(uIColumn.UIGridColumnControlTypeID);
                        Assert.IsNotNull(uIColumn.Editable);
            Assert.IsInstanceOfType(uIColumn.Props["Editable"].PropertyType, uIColumn.Editable);
                        Assert.IsNotNull(uIColumn.Width);
            Assert.IsInstanceOfType(uIColumn.Props["Width"].PropertyType, uIColumn.Width);
                        Assert.IsNotNull(uIColumn.Alignment);
            Assert.IsInstanceOfType(uIColumn.Props["Alignment"].PropertyType, uIColumn.Alignment);
                        Assert.IsNotNull(uIColumn.Generated);
            Assert.IsInstanceOfType(uIColumn.Props["Generated"].PropertyType, uIColumn.Generated);
                        Assert.IsNull(uIColumn.UIGridID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateUnsavedValidUIColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIColumn.Status.IsNew);
            BusinessObjectCollection<UIColumn> col = new BusinessObjectCollection<UIColumn>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();

            //---------------Execute Test ----------------------
            UIColumn loadedUIColumn = Broker.GetBusinessObject<UIColumn>(uIColumn.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIColumn.UIColumnID, loadedUIColumn.UIColumnID);
                        Assert.AreEqual(uIColumn.Heading, loadedUIColumn.Heading);
                        Assert.AreEqual(uIColumn.Property, loadedUIColumn.Property);
                        Assert.AreEqual(uIColumn.UIGridColumnControlTypeID, loadedUIColumn.UIGridColumnControlTypeID);
                        Assert.AreEqual(uIColumn.Editable, loadedUIColumn.Editable);
                        Assert.AreEqual(uIColumn.Width, loadedUIColumn.Width);
                        Assert.AreEqual(uIColumn.Alignment, loadedUIColumn.Alignment);
                        Assert.AreEqual(uIColumn.Generated, loadedUIColumn.Generated);
                        Assert.AreEqual(uIColumn.UIGridID, loadedUIColumn.UIGridID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumn.Delete();
            uIColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                UIColumn retrievedUIColumn = Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIColumn", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtils.GetRandomString();
            uIColumn.Heading = (System.String) valueForHeading;
            object valueForProperty = TestUtils.GetRandomString();
            uIColumn.Property = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtils.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtils.GetRandomBoolean();
            uIColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = (decimal)TestUtils.GetRandomInt();
            uIColumn.Width = (System.Decimal) valueForWidth;
            object valueForAlignment = TestUtils.GetRandomString();
            uIColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIColumn.UIGridID = (System.Guid) valueForUIGridID;
            uIColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIColumn retrievedUIColumn =
                    Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
            
            Assert.AreEqual(valueForHeading, retrievedUIColumn.Heading);
            Assert.AreEqual(valueForProperty, retrievedUIColumn.Property);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, retrievedUIColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, retrievedUIColumn.Editable);
            Assert.AreEqual(valueForWidth, retrievedUIColumn.Width);
            Assert.AreEqual(valueForAlignment, retrievedUIColumn.Alignment);
            Assert.AreEqual(valueForGenerated, retrievedUIColumn.Generated);
            Assert.AreEqual(valueForUIGridID, retrievedUIColumn.UIGridID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = new UIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtils.GetRandomString();
            uIColumn.Heading = (System.String) valueForHeading;
            object valueForProperty = TestUtils.GetRandomString();
            uIColumn.Property = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtils.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtils.GetRandomBoolean();
            uIColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = (decimal)TestUtils.GetRandomInt();
            uIColumn.Width = (System.Decimal) valueForWidth;
            object valueForAlignment = TestUtils.GetRandomString();
            uIColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIColumn.UIGridID = (System.Guid) valueForUIGridID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIColumn.Heading);
            Assert.AreEqual(valueForProperty, uIColumn.Property);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, uIColumn.Editable);
            Assert.AreEqual(valueForWidth, uIColumn.Width);
            Assert.AreEqual(valueForAlignment, uIColumn.Alignment);
            Assert.AreEqual(valueForGenerated, uIColumn.Generated);
            Assert.AreEqual(valueForUIGridID, uIColumn.UIGridID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = new UIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtils.GetRandomString();
            uIColumn.Heading = (System.String) valueForHeading;
            object valueForProperty = TestUtils.GetRandomString();
            uIColumn.Property = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtils.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtils.GetRandomBoolean();
            uIColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = (decimal)TestUtils.GetRandomInt();
            uIColumn.Width = (System.Decimal) valueForWidth;
            object valueForAlignment = TestUtils.GetRandomString();
            uIColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIColumn.UIGridID = (System.Guid) valueForUIGridID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIColumn.GetPropertyValue("Heading"));
            Assert.AreEqual(valueForProperty, uIColumn.GetPropertyValue("Property"));
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIColumn.GetPropertyValue("UIGridColumnControlTypeID"));
            Assert.AreEqual(valueForEditable, uIColumn.GetPropertyValue("Editable"));
            Assert.AreEqual(valueForWidth, uIColumn.GetPropertyValue("Width"));
            Assert.AreEqual(valueForAlignment, uIColumn.GetPropertyValue("Alignment"));
            Assert.AreEqual(valueForGenerated, uIColumn.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIGridID, uIColumn.GetPropertyValue("UIGridID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = new UIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtils.GetRandomString();            
            uIColumn.SetPropertyValue("Heading", valueForHeading);
            object valueForProperty = TestUtils.GetRandomString();            
            uIColumn.SetPropertyValue("Property", valueForProperty);
            object valueForUIGridColumnControlTypeID = TestUtils.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;            
            uIColumn.SetPropertyValue("UIGridColumnControlTypeID", valueForUIGridColumnControlTypeID);
            object valueForEditable = TestUtils.GetRandomBoolean();            
            uIColumn.SetPropertyValue("Editable", valueForEditable);
            object valueForWidth = (decimal)TestUtils.GetRandomInt();            
            uIColumn.SetPropertyValue("Width", valueForWidth);
            object valueForAlignment = TestUtils.GetRandomString();            
            uIColumn.SetPropertyValue("Alignment", valueForAlignment);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            uIColumn.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;            
            uIColumn.SetPropertyValue("UIGridID", valueForUIGridID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIColumn.Heading);
            Assert.AreEqual(valueForProperty, uIColumn.Property);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, uIColumn.Editable);
            Assert.AreEqual(valueForWidth, uIColumn.Width);
            Assert.AreEqual(valueForAlignment, uIColumn.Alignment);
            Assert.AreEqual(valueForGenerated, uIColumn.Generated);
            Assert.AreEqual(valueForUIGridID, uIColumn.UIGridID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumn.Editable = null;
            uIColumn.Width = null;
            uIColumn.Alignment = null;
            uIColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIColumn retrievedUIColumn =
                    Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
            
            Assert.IsNull(retrievedUIColumn.Editable);
            Assert.IsNull(retrievedUIColumn.Width);
            Assert.IsNull(retrievedUIColumn.Alignment);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumn uIColumn = TestUtils.CreateUnsavedValidUIColumn();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumn.UIColumnID = null;
            uIColumn.Heading = null;
            uIColumn.Property = null;
            uIColumn.UIGridColumnControlTypeID = null;
            uIColumn.Generated = null;
            uIColumn.UIGridID = null;
            
            try
            {
                uIColumn.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'U I Column I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Heading' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Property' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Grid Column Type' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'U I Grid I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIColumn>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIColumnID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Heading"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Property"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridColumnControlTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Editable"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Width"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Alignment"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGrid()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();

            FireStarterModeller.BO.UIGridInfo boForRelationshipUIGrid = TestUtils.CreateSavedUIGridInfo();
            uIColumn.UIGrid = boForRelationshipUIGrid;
            uIColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridInfo loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridInfo>(boForRelationshipUIGrid.ID);
            UIColumn loadedUIColumn = Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGrid, loadedUIColumn.UIGrid);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumn.UIGrid);
            Assert.AreEqual(loadedRelatedBO, uIColumn.UIGrid);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();

            FireStarterModeller.BO.UIGridColumnControlType boForRelationshipUIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();
            uIColumn.UIGridColumnControlType = boForRelationshipUIGridColumnControlType;
            uIColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridColumnControlType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridColumnControlType>(boForRelationshipUIGridColumnControlType.ID);
            UIColumn loadedUIColumn = Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridColumnControlType, loadedUIColumn.UIGridColumnControlType);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumn.UIGridColumnControlType);
            Assert.AreEqual(loadedRelatedBO, uIColumn.UIGridColumnControlType);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();

            FireStarterModeller.BO.UIParameter boForRelationshipUIParameters = TestUtils.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIColumnID = uIColumn.UIColumnID;
            boForRelationshipUIParameters.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIColumn.UIParameters.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIParameter loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIParameter>(boForRelationshipUIParameters.ID);
            UIColumn loadedUIColumn = Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIColumn.UIParameters.Count);
            Assert.AreEqual(boForRelationshipUIParameters, loadedUIColumn.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumn.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, uIColumn.UIParameters[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumn uIColumn = TestUtils.CreateSavedUIColumn();

            FireStarterModeller.BO.UIParameter boForRelationshipUIParameters = TestUtils.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIColumnID = uIColumn.UIColumnID;
            boForRelationshipUIParameters.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIColumn.UIParameters.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIColumn>().RelationshipDefCol["UIParameters"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIColumn.Delete();
            uIColumn.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIColumn>(uIColumn.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIColumn"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIParameter>(boForRelationshipUIParameters.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIParameter"));
            }
        }
        
        
        
        
       
    }
}
