// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UIColumnLayout objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UIColumnLayout with a random value assigned to every property
        /// </summary>
        public static UIColumnLayout CreateSavedUIColumnLayout()
		{
		    UIColumnLayout uIColumnLayout = CreateUnsavedValidUIColumnLayout();
			uIColumnLayout.Save();
			return uIColumnLayout;
		}

        /// <summary>
        /// Creates a new unsaved UIColumnLayout with a random value assigned to every property
        /// </summary>
		public static UIColumnLayout CreateUnsavedValidUIColumnLayout()
		{
			UIColumnLayout uIColumnLayout = new UIColumnLayout();
			uIColumnLayout.Width = TestUtils.GetRandomInt();
			uIColumnLayout.Generated = TestUtils.GetRandomBoolean();
			uIColumnLayout.UIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
			uIColumnLayout.UITabID = TestUtils.CreateSavedUITab().UITabID;
			return uIColumnLayout;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIColumnLayout where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIColumnLayout CreateUnsavedDefaultUIColumnLayout()
		{
			UIColumnLayout uIColumnLayout = new UIColumnLayout();
			return uIColumnLayout;
		}
    }
    
    // Provides the part of the test class that tests UIColumnLayout objects
    [TestFixture]
    public partial class TestUIColumnLayout : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIColumnLayoutWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIColumnLayout uIColumnLayout = new UIColumnLayout();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIColumnLayout.UIColumnLayoutID);
            Assert.IsInstanceOfType(uIColumnLayout.Props["UIColumnLayoutID"].PropertyType, uIColumnLayout.UIColumnLayoutID);
                        Assert.IsNotNull(uIColumnLayout.Width);
            Assert.IsInstanceOfType(uIColumnLayout.Props["Width"].PropertyType, uIColumnLayout.Width);
                        Assert.IsNotNull(uIColumnLayout.Generated);
            Assert.IsInstanceOfType(uIColumnLayout.Props["Generated"].PropertyType, uIColumnLayout.Generated);
                        Assert.IsNull(uIColumnLayout.UIFormID);
                        Assert.IsNull(uIColumnLayout.UITabID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIColumnLayout()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateUnsavedValidUIColumnLayout();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIColumnLayout.Status.IsNew);
            BusinessObjectCollection<UIColumnLayout> col = new BusinessObjectCollection<UIColumnLayout>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIColumnLayout.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIColumnLayout.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIColumnLayout()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            //---------------Execute Test ----------------------
            UIColumnLayout loadedUIColumnLayout = Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIColumnLayout.UIColumnLayoutID, loadedUIColumnLayout.UIColumnLayoutID);
                        Assert.AreEqual(uIColumnLayout.Width, loadedUIColumnLayout.Width);
                        Assert.AreEqual(uIColumnLayout.Generated, loadedUIColumnLayout.Generated);
                        Assert.AreEqual(uIColumnLayout.UIFormID, loadedUIColumnLayout.UIFormID);
                        Assert.AreEqual(uIColumnLayout.UITabID, loadedUIColumnLayout.UITabID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIColumnLayout()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumnLayout.Delete();
            uIColumnLayout.Save();
            //---------------Test Result -----------------------
            try
            {
                UIColumnLayout retrievedUIColumnLayout = Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIColumnLayout", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIColumnLayout()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIColumnLayout.Width = (System.Int32) valueForWidth;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumnLayout.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uIColumnLayout.UIFormID = (System.Guid) valueForUIFormID;
            object valueForUITabID = TestUtils.CreateSavedUITab().UITabID;
            uIColumnLayout.UITabID = (System.Guid) valueForUITabID;
            uIColumnLayout.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIColumnLayout retrievedUIColumnLayout =
                    Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
            
            Assert.AreEqual(valueForWidth, retrievedUIColumnLayout.Width);
            Assert.AreEqual(valueForGenerated, retrievedUIColumnLayout.Generated);
            Assert.AreEqual(valueForUIFormID, retrievedUIColumnLayout.UIFormID);
            Assert.AreEqual(valueForUITabID, retrievedUIColumnLayout.UITabID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = new UIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIColumnLayout.Width = (System.Int32) valueForWidth;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumnLayout.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uIColumnLayout.UIFormID = (System.Guid) valueForUIFormID;
            object valueForUITabID = TestUtils.CreateSavedUITab().UITabID;
            uIColumnLayout.UITabID = (System.Guid) valueForUITabID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIColumnLayout.Width);
            Assert.AreEqual(valueForGenerated, uIColumnLayout.Generated);
            Assert.AreEqual(valueForUIFormID, uIColumnLayout.UIFormID);
            Assert.AreEqual(valueForUITabID, uIColumnLayout.UITabID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = new UIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIColumnLayout.Width = (System.Int32) valueForWidth;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIColumnLayout.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uIColumnLayout.UIFormID = (System.Guid) valueForUIFormID;
            object valueForUITabID = TestUtils.CreateSavedUITab().UITabID;
            uIColumnLayout.UITabID = (System.Guid) valueForUITabID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIColumnLayout.GetPropertyValue("Width"));
            Assert.AreEqual(valueForGenerated, uIColumnLayout.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIFormID, uIColumnLayout.GetPropertyValue("UIFormID"));
            Assert.AreEqual(valueForUITabID, uIColumnLayout.GetPropertyValue("UITabID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = new UIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();            
            uIColumnLayout.SetPropertyValue("Width", valueForWidth);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            uIColumnLayout.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;            
            uIColumnLayout.SetPropertyValue("UIFormID", valueForUIFormID);
            object valueForUITabID = TestUtils.CreateSavedUITab().UITabID;            
            uIColumnLayout.SetPropertyValue("UITabID", valueForUITabID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIColumnLayout.Width);
            Assert.AreEqual(valueForGenerated, uIColumnLayout.Generated);
            Assert.AreEqual(valueForUIFormID, uIColumnLayout.UIFormID);
            Assert.AreEqual(valueForUITabID, uIColumnLayout.UITabID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumnLayout.Width = null;
            uIColumnLayout.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIColumnLayout retrievedUIColumnLayout =
                    Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
            
            Assert.IsNull(retrievedUIColumnLayout.Width);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumnLayout uIColumnLayout = TestUtils.CreateUnsavedValidUIColumnLayout();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIColumnLayout.UIColumnLayoutID = null;
            uIColumnLayout.Generated = null;
            uIColumnLayout.UIFormID = null;
            uIColumnLayout.UITabID = null;
            
            try
            {
                uIColumnLayout.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'U I Column Layout I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'U I Form I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'U I Tab I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIColumnLayout>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIColumnLayoutID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Width"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIFormID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UITabID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIForm()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            FireStarterModeller.BO.UIFormInfo boForRelationshipUIForm = TestUtils.CreateSavedUIFormInfo();
            uIColumnLayout.UIForm = boForRelationshipUIForm;
            uIColumnLayout.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIFormInfo loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIFormInfo>(boForRelationshipUIForm.ID);
            UIColumnLayout loadedUIColumnLayout = Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIForm, loadedUIColumnLayout.UIForm);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumnLayout.UIForm);
            Assert.AreEqual(loadedRelatedBO, uIColumnLayout.UIForm);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            FireStarterModeller.BO.UITab boForRelationshipUITab = TestUtils.CreateSavedUITab();
            uIColumnLayout.UITab = boForRelationshipUITab;
            uIColumnLayout.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UITab loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UITab>(boForRelationshipUITab.ID);
            UIColumnLayout loadedUIColumnLayout = Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUITab, loadedUIColumnLayout.UITab);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumnLayout.UITab);
            Assert.AreEqual(loadedRelatedBO, uIColumnLayout.UITab);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            FireStarterModeller.BO.UIField boForRelationshipUIFields = TestUtils.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIColumnLayoutID = uIColumnLayout.UIColumnLayoutID;
            boForRelationshipUIFields.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIColumnLayout.UIFields.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIField loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIField>(boForRelationshipUIFields.ID);
            UIColumnLayout loadedUIColumnLayout = Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIColumnLayout.UIFields.Count);
            Assert.AreEqual(boForRelationshipUIFields, loadedUIColumnLayout.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIColumnLayout.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, uIColumnLayout.UIFields[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            FireStarterModeller.BO.UIField boForRelationshipUIFields = TestUtils.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIColumnLayoutID = uIColumnLayout.UIColumnLayoutID;
            boForRelationshipUIFields.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIColumnLayout.UIFields.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIColumnLayout>().RelationshipDefCol["UIFields"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIColumnLayout.Delete();
            uIColumnLayout.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIColumnLayout"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIField>(boForRelationshipUIFields.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIField"));
            }
        }
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_UITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIColumnLayout uIColumnLayout = TestUtils.CreateSavedUIColumnLayout();

            FireStarterModeller.BO.UITab boForRelationshipUITab = TestUtils.CreateSavedUITab();
            uIColumnLayout.UITab = boForRelationshipUITab;
            uIColumnLayout.Save();

            //---------------Assert Preconditions---------------
            RelationshipDef relationshipDef = ClassDef.Get<UIColumnLayout>().RelationshipDefCol["UITab"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIColumnLayout.Delete();
            uIColumnLayout.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIColumnLayout>(uIColumnLayout.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIColumnLayout"));
            }            
            
            FireStarterModeller.BO.UITab relatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UITab>(boForRelationshipUITab.ID);
            Assert.AreEqual(relatedBO,boForRelationshipUITab);
            
        }
       
    }
}
