using FireStarterModeller.BO;

namespace FireStarterModeller.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMInheritanceRelationship objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    public class TestUtilsDMAssembly
    {
        /// <summary>
        /// Creates a new saved DMAssembly with a random value assigned to every property
        /// </summary>
        public static DMAssembly CreateSavedDMAssembly()
        {
            DMAssembly dMAssembly = CreateUnsavedValidDMAssembly();
            dMAssembly.Save();
            return dMAssembly;
        }

        /// <summary>
        /// Creates a new unsaved DMAssembly with a random value assigned to every property
        /// </summary>
        public static DMAssembly CreateUnsavedValidDMAssembly()
        {
            DMAssembly dMAssembly = new DMAssembly
                                        {
                                            Name = TestUtilsShared.GetRandomString(20,21),
                                            Solution = TestUtilsShared.CreateSavedDMSolution()
                                        };
            return dMAssembly;
        }

        /// <summary>
        /// Creates a new unsaved DMAssembly where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
        public static DMAssembly CreateUnsavedDefaultDMAssembly()
        {
            DMAssembly dMAssembly = new DMAssembly();
            return dMAssembly;
        }
    }
}