using FireStarterModeller.BO;

namespace FireStarterModeller.Test
{
    public partial class TestUtilsDMLookupList
    {
        /// <summary>
        /// Creates a new saved DMLookupList with a random value assigned to every property
        /// </summary>
        public static DMLookupList CreateSavedDMLookupList()
        {
            DMLookupList dMLookupList = CreateUnsavedValidDMLookupList();
            dMLookupList.Save();
            return dMLookupList;
        }

        /// <summary>
        /// Creates a new unsaved DMLookupList with a random value assigned to every property
        /// </summary>
        public static DMLookupList CreateUnsavedValidDMLookupList()
        {
            DMLookupList dMLookupList = new DMLookupList();
            dMLookupList.Generated = TestUtilsShared.GetRandomBoolean();
            return dMLookupList;
        }

        /// <summary>
        /// Creates a new unsaved DMLookupList where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
        public static DMLookupList CreateUnsavedDefaultDMLookupList()
        {
            DMLookupList dMLookupList = new DMLookupList();
            return dMLookupList;
        }
    }
}