﻿using System;
using FireStarterModeller.BO;
using Habanero.Faces.Base;
using Habanero.Faces.Win;

namespace FireStarterModeller.UI.LookupLists
{
    public class NoneLookupListControl : UserControlWin, ILookupListControl
    {
        public IControlFactory ControlFactory { get; private set; }
        public DMProperty Property { get; set; }
        private const string _lookupTypeName = "None";

        public NoneLookupListControl(IControlFactory controlFactory)
        {
            if (controlFactory == null) throw new ArgumentNullException("controlFactory");
            ControlFactory = controlFactory;
            BorderLayoutManager borderLayoutManager = controlFactory.CreateBorderLayoutManager(this);
            borderLayoutManager.AddControl(controlFactory.CreateLabel("Please select a lookup list type."), BorderLayoutManager.Position.Centre);
        }

        public DMLookupList LookupList
        {
            get { return null; }
        }

        public string LookupTypeName
        {
            get
            {
                return _lookupTypeName;
            }
        }
    }
}
