﻿using System.Drawing;
using FireStarterModeller.BO;
using Habanero.UI.Base;
using Habanero.UI.Win;

namespace FireStarterModeller.UI
{
    public class PropertyInfoCollapsiblePanel : PanelWin
    {
        private readonly IControlFactory _controlFactory;
        private readonly PropertyInfosControl _propertyInfosControl;
        private readonly ICollapsiblePanel _collapsiblePanel;
        private DMClass _dmClass;



        public PropertyInfoCollapsiblePanel()
        {
            _controlFactory = GlobalUIRegistry.ControlFactory;
            _collapsiblePanel = _controlFactory.CreateCollapsiblePanel();
            _propertyInfosControl = new PropertyInfosControl(_controlFactory);
            _propertyInfosControl.Height = 200;
            _collapsiblePanel.ContentControl = _propertyInfosControl;
            _collapsiblePanel.Height = _collapsiblePanel.CollapseButton.Height + _propertyInfosControl.Height;
            _collapsiblePanel.Collapsed = true;
            _collapsiblePanel.CollapseButton.Text = "Properties";;
            //collapsiblePanel.CollapseButton.ForeColor = Color.White;
            //((ButtonWin)collapsiblePanel.CollapseButton).TextAlign = ContentAlignment.MiddleLeft;
            BorderLayoutManager layoutManager = _controlFactory.CreateBorderLayoutManager(this);
            layoutManager.AddControl(_collapsiblePanel, BorderLayoutManager.Position.Centre);

        }

        public ICollapsiblePanel CollapsiblePanel
        {
            get { return _collapsiblePanel; }
        }

        public DMClass DMClass
        {
            get
            {
                return _dmClass;
            }
            set
            {
                _dmClass = value;
                _propertyInfosControl.Class = _dmClass;
            }
        }

    }
}
