// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// ------------------------------------------------------------------------------


using System;
using System.Data;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace Firestarter.DB.Schema.BO
{

    public interface IDBDatabase : IMergableBo
    {
        DBTable GetTableInfo(string tableInfoName);
        BusinessObjectCollection<DBTable> Tables { get; }
    }
    [Serializable]
    public partial class DBDatabase : IDBDatabase
    {
        private readonly IDatabaseConnection _databaseConnection;

        public DBDatabase()
        {
        }

        protected internal DBDatabase(ClassDef def) : base(def)
        {
        }

        protected DBDatabase(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            return this.DatabaseName;
        }

        public DBDatabase(IDatabaseConnection databaseConnection)
        {
            if (databaseConnection == null) throw new ArgumentNullException("databaseConnection");
            _databaseConnection = databaseConnection;
            this.DatabaseName = databaseConnection.GetConnection().Database;
        }

        public bool DatabaseExists(out string errors)
        {
            bool success;
            try
            {
                IDbConnection connection = _databaseConnection.GetConnection();
                if (connection != null)
                {
                    connection.Open();
                    connection.Close();
                    success = true;
                }
                else
                {
                    success = false;
                }
                errors = null;
            }
            catch (Exception ex)
            {
                success = false;
                errors = ExceptionUtilities.GetExceptionString(ex, 1, false);
            }
            return success;
        }
/*
        public IDatabaseConnection DatabaseConnection
        {
            get { return _databaseConnection; }
        }*/

        public DBTable GetTableInfo(string tableInfoName)
        {
            return this.Tables.FirstOrDefault(tableInfo => tableInfo.TableNameDB == tableInfoName);
        }

        /// <summary>
        /// Whether this change is approved to be applied to the domain model
        /// </summary>
        public bool PendingChangeApproved
        {
            get { return Approved ?? false; }
            set { Approved = value; }
        }
    }
}