
// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// ------------------------------------------------------------------------------


using System;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace Firestarter.DB.Schema.BO
{
    [Serializable]
    public partial class DBForeignKey :IMergableBo
    {
        public DBForeignKey()
        {
        }

        protected internal DBForeignKey(ClassDef def) : base(def)
        {
        }

        protected DBForeignKey(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        protected DBForeignKey(ConstructForFakes constructForFakes)
            : base(constructForFakes)
        {
        }

        public override string ToString()
        {
            return this.ForeignKeyName;
        }

        public DBForeignKeyColumn GetForeignKeyColumnInfo(string columnName)
        {
            if (string.IsNullOrEmpty(columnName)) return null;
            return ForeignKeyColumns.FirstOrDefault(foreignKeyColumnInfo => foreignKeyColumnInfo.ParentColumnName == columnName);
        }

        public DBForeignKeyColumn AddColumnInfo(DBColumn parentColumn, DBColumn relatedColumn)
        {
            if (parentColumn == null) throw new ArgumentNullException("parentColumn");
            DBForeignKeyColumn primaryKeyColumn = this.GetForeignKeyColumnInfo(parentColumn.ColumnName);
            if (primaryKeyColumn != null) return primaryKeyColumn;
            primaryKeyColumn = new DBForeignKeyColumn 
                                   { ParentColumn = parentColumn, RelatedColumn = relatedColumn};
            this.ForeignKeyColumns.Add(primaryKeyColumn);
            return primaryKeyColumn;
        }

        /// <summary>
        /// Whether this change is approved to be applied to the domain model
        /// </summary>
        public bool PendingChangeApproved
        {
            get { return Approved ?? false; }
            set { Approved = value; }
        }
        /// <summary>
        /// Returns the Table Name of the <see cref="RelatedTable"/>
        /// </summary>
        public virtual string RelatedTableName
        {
            get { return this.RelatedTable == null ? "" : this.RelatedTable.TableNameDB; }
        }

    }

}