
// ------------------------------------------------------------------------------

// This class was auto-generated for use with the Habanero Enterprise Framework.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace Firestarter.DB.Schema.BO
{
    [Serializable]
    public partial class DBKey: IMergableBo
    {
        public DBKey()
        {
        }

        protected internal DBKey(ClassDef def) : base(def)
        {
        }

        protected DBKey(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(this.KeyName))
            {
                return this.KeyID == null ? "-unnamed key-" : Convert.ToString(this.KeyID);
            }
            return  this.KeyName;
        }

        public DBKeyColumn GetKeyColumnInfo(string columnName)
        {
            foreach (DBKeyColumn info in this.KeyColumns)
            {
                if (info.Column.ColumnName == columnName) return info;
            }
            return null;
        }

        public DBColumn GetColumnInfo(string columnName)
        {
            DBKeyColumn dbKeyColumn = GetKeyColumnInfo(columnName);
            return dbKeyColumn != null ? dbKeyColumn.Column : null;
        }

        public DBKeyColumn AddColumnInfo(DBColumn dbColumn)
        {
            if (dbColumn == null) throw new ArgumentNullException("dbColumn");
            DBKeyColumn dbKeyColumn = this.GetKeyColumnInfo(dbColumn.ColumnName);
            if (dbKeyColumn != null)
            {
                if (dbKeyColumn.Column == dbColumn) return dbKeyColumn;
                string name = this.Table == null ? "" : this.Table.TableNameDB;

                string message = string.Format("A dbColumn with name '{0}' could not be added to the " +
                                               "Key Info for the business object '{1}' since it already exists in the business object"
                                               , dbColumn.ColumnName, name);
                throw new HabaneroDeveloperException(message, message);
            }

            dbKeyColumn = new DBKeyColumn { Column = dbColumn };
            this.KeyColumns.Add(dbKeyColumn);
            return dbKeyColumn;
        }

        /// <summary>
        /// Returns a list of column infos associated with this PrimaryKey
        /// </summary>
        public IList<DBColumn> Columns
        {
            get
            {
                List<DBColumn> listColumns = new List<DBColumn>();
                foreach (DBKeyColumn keyColumnInfo in this.KeyColumns)
                {
                    listColumns.Add(keyColumnInfo.Column);
                }
                return listColumns;
            }
        }

        /// <summary>
        /// Whether this change is approved to be applied to the domain model
        /// </summary>
        public bool PendingChangeApproved
        {
            get { return Approved ?? false; }
            set { Approved = value; }
        }
    }
}


