using System;
using Firestarter.DB.Schema.BO;
using FireStarterModeller.BO;
using Habanero.BO;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    /// <summary>
    /// Provides a place to write custom tests for DBDatabase objects.
    /// This file is only written once and can be changed.  The Def file
    /// attached to this as a dependent is rewritten with each regeneration
    /// and contains the standard tests for DBDatabase.
    /// Regenerate this test project whenever there have been changes to the
    /// business objects.
    /// If tests are failing due to a unique setup in your application,
    /// you can either override the Create methods in TestUtils, or you
    /// can add the test to the ignore list below and reimplement it here.
    /// </summary>
    public partial class TestDBDatabase
    {
        [TestFixtureSetUp]
        public void SetupTestFixture()
        {
            //------------------------------------------------------------
            // Use this list to ignore generated tests that are failing
            // due to a unique condition in your application.
            // Remember to reimplement the test here.
            //------------------------------------------------------------
            //_ignoreList.Add("TestMethodName", "Reason for ignoring it");
            base.SetupFixture();
        }
        
        [Test]
        public void Test_ToString()
        {
            //---------------Set up test pack-------------------
            DBDatabase database = TestUtilsDBDatabase.CreateUnsavedValidDBDatabase();
            //---------------Assert Precondition----------------
            Assert.IsNotNull(database.DatabaseName);
//            Assert.IsNotNull(database.Catalog);
//            Assert.IsNotNull(database.Schema);
            //---------------Execute Test ----------------------
            string actualToString = database.ToString();
            //---------------Test Result -----------------------
//            string expectedToString = database.Catalog + " - " + database.Schema + " - " + database.DatabaseName;
            Assert.AreEqual(database.DatabaseName, actualToString);
//            Assert.Fail("Implement ToString() for the Business object and implement this test");
        }
    }
}