// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.Test;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.BO
{
    // ReSharper disable RedundantNameQualifier


    // Provides a part of the TestUtilsBase class that creates sample DBForeignKeyColumn objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDBForeignKeyColumn
    {
        /// <summary>
        /// Creates a new saved DBForeignKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBForeignKeyColumn CreateSavedDBForeignKeyColumn()
        {
            DBForeignKeyColumn dBForeignKeyColumn = CreateUnsavedValidDBForeignKeyColumn();
            dBForeignKeyColumn.Save();
            return dBForeignKeyColumn;
        }

        /// <summary>
        /// Creates a new unsaved DBForeignKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBForeignKeyColumn CreateUnsavedValidDBForeignKeyColumn()
        {
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();
            dBForeignKeyColumn.ForeignKeyID = TestUtilsDBForeignKey.CreateSavedDBForeignKey().ForeignKeyID;
            dBForeignKeyColumn.ParentColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.RelatedColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
//			dBForeignKeyColumn.PendingChangeType = null;
            dBForeignKeyColumn.Approved = TestUtilsShared.GetRandomBoolean();
            return dBForeignKeyColumn;
        }
	    
        /// <summary>
        /// Creates a new unsaved DBForeignKeyColumn where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
        public static DBForeignKeyColumn CreateUnsavedDefaultDBForeignKeyColumn()
        {
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();
            return dBForeignKeyColumn;
        }
    }
    
    // Provides the part of the test class that tests DBForeignKeyColumn objects
    [TestFixture]
    public partial class TestDBForeignKeyColumn : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBForeignKeyColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();

            //---------------Test Result -----------------------
            Assert.IsNotNull(dBForeignKeyColumn.ForeignKeyColumnID);
            Assert.IsInstanceOf(dBForeignKeyColumn.Props["ForeignKeyColumnID"].PropertyType, dBForeignKeyColumn.ForeignKeyColumnID);
            Assert.IsNull(dBForeignKeyColumn.ForeignKeyID);
            Assert.IsNull(dBForeignKeyColumn.ParentColumnID);
            Assert.IsNull(dBForeignKeyColumn.RelatedColumnID);
            Assert.IsNotNull(dBForeignKeyColumn.PendingChangeType);
            Assert.IsInstanceOf(dBForeignKeyColumn.Props["PendingChangeType"].PropertyType, dBForeignKeyColumn.PendingChangeType);
            Assert.IsNotNull(dBForeignKeyColumn.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBForeignKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateUnsavedValidDBForeignKeyColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBForeignKeyColumn.Status.IsNew);
            BusinessObjectCollection<DBForeignKeyColumn> col = new BusinessObjectCollection<DBForeignKeyColumn>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBForeignKeyColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBForeignKeyColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBForeignKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();

            //---------------Execute Test ----------------------
            DBForeignKeyColumn loadedDBForeignKeyColumn = Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dBForeignKeyColumn.ForeignKeyColumnID, loadedDBForeignKeyColumn.ForeignKeyColumnID);
            Assert.AreEqual(dBForeignKeyColumn.ForeignKeyID, loadedDBForeignKeyColumn.ForeignKeyID);
            Assert.AreEqual(dBForeignKeyColumn.ParentColumnID, loadedDBForeignKeyColumn.ParentColumnID);
            Assert.AreEqual(dBForeignKeyColumn.RelatedColumnID, loadedDBForeignKeyColumn.RelatedColumnID);
            Assert.AreEqual(dBForeignKeyColumn.PendingChangeType, loadedDBForeignKeyColumn.PendingChangeType);
            Assert.AreEqual(dBForeignKeyColumn.Approved, loadedDBForeignKeyColumn.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBForeignKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBForeignKeyColumn.MarkForDelete();
            dBForeignKeyColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBForeignKeyColumn", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBForeignKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForForeignKeyID = TestUtilsDBForeignKey.CreateSavedDBForeignKey().ForeignKeyID;
            dBForeignKeyColumn.ForeignKeyID = (System.Guid) valueForForeignKeyID;
            object valueForParentColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.ParentColumnID = (System.Guid) valueForParentColumnID;
            object valueForRelatedColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.RelatedColumnID = (System.Guid) valueForRelatedColumnID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBForeignKeyColumn.Approved = (System.Boolean) valueForApproved;
            dBForeignKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBForeignKeyColumn retrievedDBForeignKeyColumn =
                Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
            
            Assert.AreEqual(valueForForeignKeyID, retrievedDBForeignKeyColumn.ForeignKeyID);
            Assert.AreEqual(valueForParentColumnID, retrievedDBForeignKeyColumn.ParentColumnID);
            Assert.AreEqual(valueForRelatedColumnID, retrievedDBForeignKeyColumn.RelatedColumnID);
            Assert.AreEqual(valueForApproved, retrievedDBForeignKeyColumn.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForForeignKeyID = TestUtilsDBForeignKey.CreateSavedDBForeignKey().ForeignKeyID;
            dBForeignKeyColumn.ForeignKeyID = (System.Guid) valueForForeignKeyID;
            object valueForParentColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.ParentColumnID = (System.Guid) valueForParentColumnID;
            object valueForRelatedColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.RelatedColumnID = (System.Guid) valueForRelatedColumnID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBForeignKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForForeignKeyID, dBForeignKeyColumn.ForeignKeyID);
            Assert.AreEqual(valueForParentColumnID, dBForeignKeyColumn.ParentColumnID);
            Assert.AreEqual(valueForRelatedColumnID, dBForeignKeyColumn.RelatedColumnID);
            Assert.AreEqual(valueForApproved, dBForeignKeyColumn.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForForeignKeyID = TestUtilsDBForeignKey.CreateSavedDBForeignKey().ForeignKeyID;
            dBForeignKeyColumn.ForeignKeyID = (System.Guid) valueForForeignKeyID;
            object valueForParentColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.ParentColumnID = (System.Guid) valueForParentColumnID;
            object valueForRelatedColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBForeignKeyColumn.RelatedColumnID = (System.Guid) valueForRelatedColumnID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBForeignKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForForeignKeyID, dBForeignKeyColumn.GetPropertyValue("ForeignKeyID"));
            Assert.AreEqual(valueForParentColumnID, dBForeignKeyColumn.GetPropertyValue("ParentColumnID"));
            Assert.AreEqual(valueForRelatedColumnID, dBForeignKeyColumn.GetPropertyValue("RelatedColumnID"));
            Assert.AreEqual(valueForApproved, dBForeignKeyColumn.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = new DBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForForeignKeyID = TestUtilsDBForeignKey.CreateSavedDBForeignKey().ForeignKeyID;            
            dBForeignKeyColumn.SetPropertyValue("ForeignKeyID", valueForForeignKeyID);
            object valueForParentColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;            
            dBForeignKeyColumn.SetPropertyValue("ParentColumnID", valueForParentColumnID);
            object valueForRelatedColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;            
            dBForeignKeyColumn.SetPropertyValue("RelatedColumnID", valueForRelatedColumnID);
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            dBForeignKeyColumn.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForForeignKeyID, dBForeignKeyColumn.ForeignKeyID);
            Assert.AreEqual(valueForParentColumnID, dBForeignKeyColumn.ParentColumnID);
            Assert.AreEqual(valueForRelatedColumnID, dBForeignKeyColumn.RelatedColumnID);
            Assert.AreEqual(valueForApproved, dBForeignKeyColumn.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBForeignKeyColumn.ForeignKeyID = null;
            dBForeignKeyColumn.ParentColumnID = null;
            dBForeignKeyColumn.RelatedColumnID = null;
//            dBForeignKeyColumn.PendingChangeType = null;
            dBForeignKeyColumn.Approved = null;
            dBForeignKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBForeignKeyColumn retrievedDBForeignKeyColumn =
                Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
            
            Assert.IsNull(retrievedDBForeignKeyColumn.ForeignKeyID);
            Assert.IsNull(retrievedDBForeignKeyColumn.ParentColumnID);
            Assert.IsNull(retrievedDBForeignKeyColumn.RelatedColumnID);
            Assert.IsNull(retrievedDBForeignKeyColumn.Approved);
        }
        
        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            // There are no compulsory properties
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBForeignKeyColumn>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["ForeignKeyColumnID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite", classDef.PropDefColIncludingInheritance["ForeignKeyID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ParentColumnID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelatedColumnID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
                
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ForeignKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();

            DBForeignKey boForRelationshipForeignKey = TestUtilsDBForeignKey.CreateSavedDBForeignKey();
            dBForeignKeyColumn.ForeignKey = boForRelationshipForeignKey;
            dBForeignKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBForeignKey loadedRelatedBO = Broker.GetBusinessObject<DBForeignKey>(boForRelationshipForeignKey.ID);
            DBForeignKeyColumn loadedDBForeignKeyColumn = Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipForeignKey, loadedDBForeignKeyColumn.ForeignKey);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKeyColumn.ForeignKey);
            Assert.AreEqual(loadedRelatedBO, dBForeignKeyColumn.ForeignKey);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ParentColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();

            DBColumn boForRelationshipParentColumn = TestUtilsDBColumn.CreateSavedDBColumn();
            dBForeignKeyColumn.ParentColumn = boForRelationshipParentColumn;
            dBForeignKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBColumn loadedRelatedBO = Broker.GetBusinessObject<DBColumn>(boForRelationshipParentColumn.ID);
            DBForeignKeyColumn loadedDBForeignKeyColumn = Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipParentColumn, loadedDBForeignKeyColumn.ParentColumn);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKeyColumn.ParentColumn);
            Assert.AreEqual(loadedRelatedBO, dBForeignKeyColumn.ParentColumn);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_RelatedColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBForeignKeyColumn dBForeignKeyColumn = TestUtilsDBForeignKeyColumn.CreateSavedDBForeignKeyColumn();

            DBColumn boForRelationshipRelatedColumn = TestUtilsDBColumn.CreateSavedDBColumn();
            dBForeignKeyColumn.RelatedColumn = boForRelationshipRelatedColumn;
            dBForeignKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBColumn loadedRelatedBO = Broker.GetBusinessObject<DBColumn>(boForRelationshipRelatedColumn.ID);
            DBForeignKeyColumn loadedDBForeignKeyColumn = Broker.GetBusinessObject<DBForeignKeyColumn>(dBForeignKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelatedColumn, loadedDBForeignKeyColumn.RelatedColumn);
            Assert.AreEqual(loadedRelatedBO, loadedDBForeignKeyColumn.RelatedColumn);
            Assert.AreEqual(loadedRelatedBO, dBForeignKeyColumn.RelatedColumn);
        }

    }
    // ReSharper restore RedundantNameQualifier
}


