// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.Test;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample DBKeyColumn objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDBKeyColumn
    {
        /// <summary>
        /// Creates a new saved DBKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBKeyColumn CreateSavedDBKeyColumn()
        {
            DBKeyColumn dBKeyColumn = CreateUnsavedValidDBKeyColumn();
            dBKeyColumn.Save();
            return dBKeyColumn;
        }

        /// <summary>
        /// Creates a new unsaved DBKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBKeyColumn CreateUnsavedValidDBKeyColumn()
        {
            DBKeyColumn dBKeyColumn = new DBKeyColumn();
            dBKeyColumn.ColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBKeyColumn.KeyID = TestUtilsDBKey.CreateSavedDBKey().KeyID;
//			dBKeyColumn.PendingChangeType = null;
            dBKeyColumn.Approved = TestUtilsShared.GetRandomBoolean();
            return dBKeyColumn;
        }
	    
        /// <summary>
        /// Creates a new unsaved DBKeyColumn where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
        public static DBKeyColumn CreateUnsavedDefaultDBKeyColumn()
        {
            DBKeyColumn dBKeyColumn = new DBKeyColumn();
            return dBKeyColumn;
        }
    }

    // Provides the part of the test class that tests DBKeyColumn objects
    [TestFixture]
    public partial class TestDBKeyColumn : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBKeyColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBKeyColumn dBKeyColumn = new DBKeyColumn();

            //---------------Test Result -----------------------
            Assert.IsNull(dBKeyColumn.ColumnID);
            Assert.IsNull(dBKeyColumn.KeyID);
            Assert.IsNotNull(dBKeyColumn.PendingChangeType);
            Assert.IsInstanceOf(dBKeyColumn.Props["PendingChangeType"].PropertyType, dBKeyColumn.PendingChangeType);
            Assert.IsNotNull(dBKeyColumn.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateUnsavedValidDBKeyColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBKeyColumn.Status.IsNew);
            BusinessObjectCollection<DBKeyColumn> col = new BusinessObjectCollection<DBKeyColumn>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBKeyColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBKeyColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();

            //---------------Execute Test ----------------------
            DBKeyColumn loadedDBKeyColumn = Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dBKeyColumn.ColumnID, loadedDBKeyColumn.ColumnID);
            Assert.AreEqual(dBKeyColumn.KeyID, loadedDBKeyColumn.KeyID);
            Assert.AreEqual(dBKeyColumn.PendingChangeType, loadedDBKeyColumn.PendingChangeType);
            Assert.AreEqual(dBKeyColumn.Approved, loadedDBKeyColumn.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBKeyColumn.MarkForDelete();
            dBKeyColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                DBKeyColumn retrievedDBKeyColumn = Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBKeyColumn", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBKeyColumn.ColumnID = (System.Guid) valueForColumnID;
            object valueForKeyID = TestUtilsDBKey.CreateSavedDBKey().KeyID;
            dBKeyColumn.KeyID = (System.Guid) valueForKeyID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBKeyColumn.Approved = (System.Boolean) valueForApproved;
            dBKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBKeyColumn retrievedDBKeyColumn =
                Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);
            
            Assert.AreEqual(valueForColumnID, retrievedDBKeyColumn.ColumnID);
            Assert.AreEqual(valueForKeyID, retrievedDBKeyColumn.KeyID);
            Assert.AreEqual(valueForApproved, retrievedDBKeyColumn.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = new DBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBKeyColumn.ColumnID = (System.Guid) valueForColumnID;
            object valueForKeyID = TestUtilsDBKey.CreateSavedDBKey().KeyID;
            dBKeyColumn.KeyID = (System.Guid) valueForKeyID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnID, dBKeyColumn.ColumnID);
            Assert.AreEqual(valueForKeyID, dBKeyColumn.KeyID);
            Assert.AreEqual(valueForApproved, dBKeyColumn.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = new DBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBKeyColumn.ColumnID = (System.Guid) valueForColumnID;
            object valueForKeyID = TestUtilsDBKey.CreateSavedDBKey().KeyID;
            dBKeyColumn.KeyID = (System.Guid) valueForKeyID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnID, dBKeyColumn.GetPropertyValue("ColumnID"));
            Assert.AreEqual(valueForKeyID, dBKeyColumn.GetPropertyValue("KeyID"));
            Assert.AreEqual(valueForApproved, dBKeyColumn.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = new DBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;            
            dBKeyColumn.SetPropertyValue("ColumnID", valueForColumnID);
            object valueForKeyID = TestUtilsDBKey.CreateSavedDBKey().KeyID;            
            dBKeyColumn.SetPropertyValue("KeyID", valueForKeyID);
            
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            dBKeyColumn.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnID, dBKeyColumn.ColumnID);
            Assert.AreEqual(valueForKeyID, dBKeyColumn.KeyID);
            Assert.AreEqual(valueForApproved, dBKeyColumn.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
//            dBKeyColumn.PendingChangeType = null;
            dBKeyColumn.Approved = null;
            dBKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBKeyColumn retrievedDBKeyColumn =
                Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);
            
            Assert.IsNull(retrievedDBKeyColumn.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateUnsavedValidDBKeyColumn();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBKeyColumn.ColumnID = null;
            dBKeyColumn.KeyID = null;
            
            try
            {
                dBKeyColumn.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
                //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Column ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Key ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBKeyColumn>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ColumnID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["KeyID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();
            
            //---------------Execute Test ----------------------
            DBKeyColumn dBKeyColumnDuplicate = TestUtilsDBKeyColumn.CreateUnsavedValidDBKeyColumn();
            dBKeyColumnDuplicate.ColumnID = dBKeyColumn.ColumnID;
            dBKeyColumnDuplicate.KeyID = dBKeyColumn.KeyID;
            try
            {
                dBKeyColumnDuplicate.Save();
                Assert.Fail("Should raise err");
            }
                //---------------Test Result -----------------------
            catch (BusObjDuplicateConcurrencyControlException ex)
            {
                StringAssert.Contains("A 'DB Key Column' already exists with the same identifier:", ex.Message);
            }
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Column()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();

            DBColumn boForRelationshipColumn = TestUtilsDBColumn.CreateSavedDBColumn();
            dBKeyColumn.Column = boForRelationshipColumn;
            dBKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBColumn loadedRelatedBO = Broker.GetBusinessObject<DBColumn>(boForRelationshipColumn.ID);
            DBKeyColumn loadedDBKeyColumn = Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipColumn, loadedDBKeyColumn.Column);
            Assert.AreEqual(loadedRelatedBO, loadedDBKeyColumn.Column);
            Assert.AreEqual(loadedRelatedBO, dBKeyColumn.Column);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Key()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBKeyColumn dBKeyColumn = TestUtilsDBKeyColumn.CreateSavedDBKeyColumn();

            DBKey boForRelationshipKey = TestUtilsDBKey.CreateSavedDBKey();
            dBKeyColumn.Key = boForRelationshipKey;
            dBKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBKey loadedRelatedBO = Broker.GetBusinessObject<DBKey>(boForRelationshipKey.ID);
            DBKeyColumn loadedDBKeyColumn = Broker.GetBusinessObject<DBKeyColumn>(dBKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipKey, loadedDBKeyColumn.Key);
            Assert.AreEqual(loadedRelatedBO, loadedDBKeyColumn.Key);
            Assert.AreEqual(loadedRelatedBO, dBKeyColumn.Key);
        }
        
        
        
        
        
        
        
       
    }
}


