// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.Test;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;
namespace Firestarter.DB.Schema.Test.BO
{
    // ReSharper disable RedundantNameQualifier

    // Provides a part of the TestUtilsBase class that creates sample DBPrimaryKeyColumn objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDBPrimaryKeyColumn
    {
        /// <summary>
        /// Creates a new saved DBPrimaryKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBPrimaryKeyColumn CreateSavedDBPrimaryKeyColumn()
        {
            DBPrimaryKeyColumn dBPrimaryKeyColumn = CreateUnsavedValidDBPrimaryKeyColumn();
            dBPrimaryKeyColumn.Save();
            return dBPrimaryKeyColumn;
        }

        /// <summary>
        /// Creates a new unsaved DBPrimaryKeyColumn with a random value assigned to every property
        /// </summary>
        public static DBPrimaryKeyColumn CreateUnsavedValidDBPrimaryKeyColumn()
        {
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();
            dBPrimaryKeyColumn.PrimaryKeyID = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey().PrimaryKeyID;
            dBPrimaryKeyColumn.ColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
//			dBPrimaryKeyColumn.PendingChangeType = null;
            dBPrimaryKeyColumn.Approved = TestUtilsShared.GetRandomBoolean();
            return dBPrimaryKeyColumn;
        }
	    
        /// <summary>
        /// Creates a new unsaved DBPrimaryKeyColumn where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
        public static DBPrimaryKeyColumn CreateUnsavedDefaultDBPrimaryKeyColumn()
        {
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();
            return dBPrimaryKeyColumn;
        }
    }
    
    // Provides the part of the test class that tests DBPrimaryKeyColumn objects
    [TestFixture]
    public partial class TestDBPrimaryKeyColumn : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBPrimaryKeyColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();

            //---------------Test Result -----------------------
            Assert.IsNull(dBPrimaryKeyColumn.PrimaryKeyID);
            Assert.IsNull(dBPrimaryKeyColumn.ColumnID);
            Assert.IsNotNull(dBPrimaryKeyColumn.PendingChangeType);
            Assert.IsInstanceOf(dBPrimaryKeyColumn.Props["PendingChangeType"].PropertyType, dBPrimaryKeyColumn.PendingChangeType);
            Assert.IsNotNull(dBPrimaryKeyColumn.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBPrimaryKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateUnsavedValidDBPrimaryKeyColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBPrimaryKeyColumn.Status.IsNew);
            BusinessObjectCollection<DBPrimaryKeyColumn> col = new BusinessObjectCollection<DBPrimaryKeyColumn>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBPrimaryKeyColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBPrimaryKeyColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBPrimaryKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();

            //---------------Execute Test ----------------------
            DBPrimaryKeyColumn loadedDBPrimaryKeyColumn = Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dBPrimaryKeyColumn.PrimaryKeyID, loadedDBPrimaryKeyColumn.PrimaryKeyID);
            Assert.AreEqual(dBPrimaryKeyColumn.ColumnID, loadedDBPrimaryKeyColumn.ColumnID);
            Assert.AreEqual(dBPrimaryKeyColumn.PendingChangeType, loadedDBPrimaryKeyColumn.PendingChangeType);
            Assert.AreEqual(dBPrimaryKeyColumn.Approved, loadedDBPrimaryKeyColumn.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBPrimaryKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBPrimaryKeyColumn.MarkForDelete();
            dBPrimaryKeyColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBPrimaryKeyColumn", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBPrimaryKeyColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPrimaryKeyID = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey().PrimaryKeyID;
            dBPrimaryKeyColumn.PrimaryKeyID = (System.Guid) valueForPrimaryKeyID;
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBPrimaryKeyColumn.ColumnID = (System.Guid) valueForColumnID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBPrimaryKeyColumn.Approved = (System.Boolean) valueForApproved;
            dBPrimaryKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBPrimaryKeyColumn retrievedDBPrimaryKeyColumn =
                Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);
            
            Assert.AreEqual(valueForPrimaryKeyID, retrievedDBPrimaryKeyColumn.PrimaryKeyID);
            Assert.AreEqual(valueForColumnID, retrievedDBPrimaryKeyColumn.ColumnID);
            Assert.AreEqual(valueForApproved, retrievedDBPrimaryKeyColumn.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPrimaryKeyID = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey().PrimaryKeyID;
            dBPrimaryKeyColumn.PrimaryKeyID = (System.Guid) valueForPrimaryKeyID;
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBPrimaryKeyColumn.ColumnID = (System.Guid) valueForColumnID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBPrimaryKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPrimaryKeyID, dBPrimaryKeyColumn.PrimaryKeyID);
            Assert.AreEqual(valueForColumnID, dBPrimaryKeyColumn.ColumnID);
            Assert.AreEqual(valueForApproved, dBPrimaryKeyColumn.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPrimaryKeyID = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey().PrimaryKeyID;
            dBPrimaryKeyColumn.PrimaryKeyID = (System.Guid) valueForPrimaryKeyID;
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;
            dBPrimaryKeyColumn.ColumnID = (System.Guid) valueForColumnID;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBPrimaryKeyColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPrimaryKeyID, dBPrimaryKeyColumn.GetPropertyValue("PrimaryKeyID"));
            Assert.AreEqual(valueForColumnID, dBPrimaryKeyColumn.GetPropertyValue("ColumnID"));
            Assert.AreEqual(valueForApproved, dBPrimaryKeyColumn.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = new DBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPrimaryKeyID = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey().PrimaryKeyID;            
            dBPrimaryKeyColumn.SetPropertyValue("PrimaryKeyID", valueForPrimaryKeyID);
            object valueForColumnID = TestUtilsDBColumn.CreateSavedDBColumn().ColumnID;            
            dBPrimaryKeyColumn.SetPropertyValue("ColumnID", valueForColumnID);
            
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            dBPrimaryKeyColumn.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPrimaryKeyID, dBPrimaryKeyColumn.PrimaryKeyID);
            Assert.AreEqual(valueForColumnID, dBPrimaryKeyColumn.ColumnID);
            Assert.AreEqual(valueForApproved, dBPrimaryKeyColumn.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
//            dBPrimaryKeyColumn.PendingChangeType = null;
            dBPrimaryKeyColumn.Approved = null;
            dBPrimaryKeyColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBPrimaryKeyColumn retrievedDBPrimaryKeyColumn =
                Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);
            
            Assert.IsNull(retrievedDBPrimaryKeyColumn.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateUnsavedValidDBPrimaryKeyColumn();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBPrimaryKeyColumn.PrimaryKeyID = null;
            dBPrimaryKeyColumn.ColumnID = null;
            
            try
            {
                dBPrimaryKeyColumn.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
                //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Primary Key ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Column ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBPrimaryKeyColumn>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PrimaryKeyID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ColumnID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();
            
            //---------------Execute Test ----------------------
            DBPrimaryKeyColumn dBPrimaryKeyColumnDuplicate = TestUtilsDBPrimaryKeyColumn.CreateUnsavedValidDBPrimaryKeyColumn();
            dBPrimaryKeyColumnDuplicate.ColumnID = dBPrimaryKeyColumn.ColumnID;
            dBPrimaryKeyColumnDuplicate.PrimaryKeyID = dBPrimaryKeyColumn.PrimaryKeyID;
            try
            {
                dBPrimaryKeyColumnDuplicate.Save();
                Assert.Fail("Should raise err");
            }
                //---------------Test Result -----------------------
            catch (BusObjDuplicateConcurrencyControlException ex)
            {
                StringAssert.Contains("A 'DB Primary Key Column' already exists with the same identifier:", ex.Message);
            }
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Column()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();

            DBColumn boForRelationshipColumn = TestUtilsDBColumn.CreateSavedDBColumn();
            dBPrimaryKeyColumn.Column = boForRelationshipColumn;
            dBPrimaryKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBColumn loadedRelatedBO = Broker.GetBusinessObject<DBColumn>(boForRelationshipColumn.ID);
            DBPrimaryKeyColumn loadedDBPrimaryKeyColumn = Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipColumn, loadedDBPrimaryKeyColumn.Column);
            Assert.AreEqual(loadedRelatedBO, loadedDBPrimaryKeyColumn.Column);
            Assert.AreEqual(loadedRelatedBO, dBPrimaryKeyColumn.Column);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_PrimaryKeyDB()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBPrimaryKeyColumn dBPrimaryKeyColumn = TestUtilsDBPrimaryKeyColumn.CreateSavedDBPrimaryKeyColumn();

            DBPrimaryKey boForRelationshipPrimaryKeyDB = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey();
            dBPrimaryKeyColumn.PrimaryKeyDB = boForRelationshipPrimaryKeyDB;
            dBPrimaryKeyColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBPrimaryKey loadedRelatedBO = Broker.GetBusinessObject<DBPrimaryKey>(boForRelationshipPrimaryKeyDB.ID);
            DBPrimaryKeyColumn loadedDBPrimaryKeyColumn = Broker.GetBusinessObject<DBPrimaryKeyColumn>(dBPrimaryKeyColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipPrimaryKeyDB, loadedDBPrimaryKeyColumn.PrimaryKeyDB);
            Assert.AreEqual(loadedRelatedBO, loadedDBPrimaryKeyColumn.PrimaryKeyDB);
            Assert.AreEqual(loadedRelatedBO, dBPrimaryKeyColumn.PrimaryKeyDB);
        }

        // ReSharper restore RedundantNameQualifier
     
    }
}


