// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.Test;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample DatabaseConnectionInfo objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests DatabaseConnectionInfo objects
    [TestFixture]
    public partial class TestDatabaseConnectionInfo : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDatabaseConnectionInfoWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DatabaseConnectionInfo databaseConnectionInfo = new DatabaseConnectionInfo();

            //---------------Test Result -----------------------
            Assert.IsNotNull(databaseConnectionInfo.DatabaseConnectionID);
            Assert.IsInstanceOf(databaseConnectionInfo.Props["DatabaseConnectionID"].PropertyType, databaseConnectionInfo.DatabaseConnectionID);
            Assert.IsNull(databaseConnectionInfo.Vendor);
            Assert.IsNull(databaseConnectionInfo.Server);
            Assert.IsNull(databaseConnectionInfo.Port);
            Assert.IsNull(databaseConnectionInfo.Database);
            Assert.IsNull(databaseConnectionInfo.UserName);
            Assert.IsNull(databaseConnectionInfo.Password);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDatabaseConnectionInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateUnsavedValidDatabaseConnectionInfo();

            //---------------Assert Precondition----------------
            Assert.IsTrue(databaseConnectionInfo.Status.IsNew);
            BusinessObjectCollection<DatabaseConnectionInfo> col = new BusinessObjectCollection<DatabaseConnectionInfo>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            databaseConnectionInfo.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(databaseConnectionInfo.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDatabaseConnectionInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();

            //---------------Execute Test ----------------------
            DatabaseConnectionInfo loadedDatabaseConnectionInfo = Broker.GetBusinessObject<DatabaseConnectionInfo>(databaseConnectionInfo.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(databaseConnectionInfo.DatabaseConnectionID, loadedDatabaseConnectionInfo.DatabaseConnectionID);
            Assert.AreEqual(databaseConnectionInfo.Vendor, loadedDatabaseConnectionInfo.Vendor);
            Assert.AreEqual(databaseConnectionInfo.Server, loadedDatabaseConnectionInfo.Server);
            Assert.AreEqual(databaseConnectionInfo.Port, loadedDatabaseConnectionInfo.Port);
            Assert.AreEqual(databaseConnectionInfo.Database, loadedDatabaseConnectionInfo.Database);
            Assert.AreEqual(databaseConnectionInfo.UserName, loadedDatabaseConnectionInfo.UserName);
            Assert.AreEqual(databaseConnectionInfo.Password, loadedDatabaseConnectionInfo.Password);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDatabaseConnectionInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            databaseConnectionInfo.MarkForDelete();
            databaseConnectionInfo.Save();
            //---------------Test Result -----------------------
            try
            {
                DatabaseConnectionInfo retrievedDatabaseConnectionInfo = Broker.GetBusinessObject<DatabaseConnectionInfo>(databaseConnectionInfo.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DatabaseConnectionInfo", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDatabaseConnectionInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForVendor = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Vendor = (System.String) valueForVendor;
            object valueForServer = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Server = (System.String) valueForServer;
            object valueForPort = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Port = (System.String) valueForPort;
            object valueForDatabase = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Database = (System.String) valueForDatabase;
            object valueForUserName = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.UserName = (System.String) valueForUserName;
            object valueForPassword = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Password = (System.String) valueForPassword;
            databaseConnectionInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DatabaseConnectionInfo retrievedDatabaseConnectionInfo =
                Broker.GetBusinessObject<DatabaseConnectionInfo>(databaseConnectionInfo.ID);
            
            Assert.AreEqual(valueForVendor, retrievedDatabaseConnectionInfo.Vendor);
            Assert.AreEqual(valueForServer, retrievedDatabaseConnectionInfo.Server);
            Assert.AreEqual(valueForPort, retrievedDatabaseConnectionInfo.Port);
            Assert.AreEqual(valueForDatabase, retrievedDatabaseConnectionInfo.Database);
            Assert.AreEqual(valueForUserName, retrievedDatabaseConnectionInfo.UserName);
            Assert.AreEqual(valueForPassword, retrievedDatabaseConnectionInfo.Password);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = new DatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForVendor = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Vendor = (System.String) valueForVendor;
            object valueForServer = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Server = (System.String) valueForServer;
            object valueForPort = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Port = (System.String) valueForPort;
            object valueForDatabase = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Database = (System.String) valueForDatabase;
            object valueForUserName = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.UserName = (System.String) valueForUserName;
            object valueForPassword = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Password = (System.String) valueForPassword;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForVendor, databaseConnectionInfo.Vendor);
            Assert.AreEqual(valueForServer, databaseConnectionInfo.Server);
            Assert.AreEqual(valueForPort, databaseConnectionInfo.Port);
            Assert.AreEqual(valueForDatabase, databaseConnectionInfo.Database);
            Assert.AreEqual(valueForUserName, databaseConnectionInfo.UserName);
            Assert.AreEqual(valueForPassword, databaseConnectionInfo.Password);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = new DatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForVendor = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Vendor = (System.String) valueForVendor;
            object valueForServer = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Server = (System.String) valueForServer;
            object valueForPort = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Port = (System.String) valueForPort;
            object valueForDatabase = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Database = (System.String) valueForDatabase;
            object valueForUserName = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.UserName = (System.String) valueForUserName;
            object valueForPassword = TestUtilsShared.GetRandomString();
            databaseConnectionInfo.Password = (System.String) valueForPassword;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForVendor, databaseConnectionInfo.GetPropertyValue("Vendor"));
            Assert.AreEqual(valueForServer, databaseConnectionInfo.GetPropertyValue("Server"));
            Assert.AreEqual(valueForPort, databaseConnectionInfo.GetPropertyValue("Port"));
            Assert.AreEqual(valueForDatabase, databaseConnectionInfo.GetPropertyValue("Database"));
            Assert.AreEqual(valueForUserName, databaseConnectionInfo.GetPropertyValue("UserName"));
            Assert.AreEqual(valueForPassword, databaseConnectionInfo.GetPropertyValue("Password"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = new DatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForVendor = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("Vendor", valueForVendor);
            object valueForServer = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("Server", valueForServer);
            object valueForPort = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("Port", valueForPort);
            object valueForDatabase = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("Database", valueForDatabase);
            object valueForUserName = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("UserName", valueForUserName);
            object valueForPassword = TestUtilsShared.GetRandomString();            
            databaseConnectionInfo.SetPropertyValue("Password", valueForPassword);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForVendor, databaseConnectionInfo.Vendor);
            Assert.AreEqual(valueForServer, databaseConnectionInfo.Server);
            Assert.AreEqual(valueForPort, databaseConnectionInfo.Port);
            Assert.AreEqual(valueForDatabase, databaseConnectionInfo.Database);
            Assert.AreEqual(valueForUserName, databaseConnectionInfo.UserName);
            Assert.AreEqual(valueForPassword, databaseConnectionInfo.Password);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            databaseConnectionInfo.Server = null;
            databaseConnectionInfo.Port = null;
            databaseConnectionInfo.Database = null;
            databaseConnectionInfo.UserName = null;
            databaseConnectionInfo.Password = null;
            databaseConnectionInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DatabaseConnectionInfo retrievedDatabaseConnectionInfo =
                Broker.GetBusinessObject<DatabaseConnectionInfo>(databaseConnectionInfo.ID);
            
            Assert.IsNull(retrievedDatabaseConnectionInfo.Server);
            Assert.IsNull(retrievedDatabaseConnectionInfo.Port);
            Assert.IsNull(retrievedDatabaseConnectionInfo.Database);
            Assert.IsNull(retrievedDatabaseConnectionInfo.UserName);
            Assert.IsNull(retrievedDatabaseConnectionInfo.Password);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateUnsavedValidDatabaseConnectionInfo();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            databaseConnectionInfo.DatabaseConnectionID = null;
            databaseConnectionInfo.Vendor = null;
            
            try
            {
                databaseConnectionInfo.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
                //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Database Connection ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Vendor' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DatabaseConnectionInfo>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["DatabaseConnectionID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Vendor"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Server"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Port"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Database"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UserName"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Password"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ReverseEngineeringsUsingThisConnection()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();

            ReverseEngineering boForRelationshipReverseEngineeringsUsingThisConnection = TestUtilsReverseEngineering.CreateUnsavedValidReverseEngineering();
            boForRelationshipReverseEngineeringsUsingThisConnection.DatabaseConnectionID = databaseConnectionInfo.DatabaseConnectionID;
            boForRelationshipReverseEngineeringsUsingThisConnection.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, databaseConnectionInfo.ReverseEngineeringsUsingThisConnection.Count);
            //---------------Execute Test ----------------------
            ReverseEngineering loadedRelatedBO = Broker.GetBusinessObject<ReverseEngineering>(boForRelationshipReverseEngineeringsUsingThisConnection.ID);
            DatabaseConnectionInfo loadedDatabaseConnectionInfo = Broker.GetBusinessObject<DatabaseConnectionInfo>(databaseConnectionInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDatabaseConnectionInfo.ReverseEngineeringsUsingThisConnection.Count);
            Assert.AreEqual(boForRelationshipReverseEngineeringsUsingThisConnection, loadedDatabaseConnectionInfo.ReverseEngineeringsUsingThisConnection[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDatabaseConnectionInfo.ReverseEngineeringsUsingThisConnection[0]);
            Assert.AreEqual(loadedRelatedBO, databaseConnectionInfo.ReverseEngineeringsUsingThisConnection[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ReverseEngineeringsUsingThisConnection()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();

            ReverseEngineering boForRelationshipReverseEngineeringsUsingThisConnection = TestUtilsReverseEngineering.CreateUnsavedValidReverseEngineering();
            boForRelationshipReverseEngineeringsUsingThisConnection.DatabaseConnectionID = databaseConnectionInfo.DatabaseConnectionID;
            boForRelationshipReverseEngineeringsUsingThisConnection.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, databaseConnectionInfo.ReverseEngineeringsUsingThisConnection.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DatabaseConnectionInfo>().RelationshipDefCol["ReverseEngineeringsUsingThisConnection"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                databaseConnectionInfo.MarkForDelete();
                databaseConnectionInfo.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
        }
        
        
        
        
        
       
    }
}


