// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.Test;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample ReverseEngineeringSettings objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests ReverseEngineeringSettings objects
    [TestFixture]
    public partial class TestReverseEngineeringSettings : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateReverseEngineeringSettingsWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ReverseEngineeringSettings reverseEngineeringSettings = new ReverseEngineeringSettings();

            //---------------Test Result -----------------------
            Assert.IsNotNull(reverseEngineeringSettings.ReverseEngineeringSettingsID);
            Assert.IsInstanceOf(reverseEngineeringSettings.Props["ReverseEngineeringSettingsID"].PropertyType, reverseEngineeringSettings.ReverseEngineeringSettingsID);
            Assert.IsNotNull(reverseEngineeringSettings.ImportTables);
            Assert.IsInstanceOf(reverseEngineeringSettings.Props["ImportTables"].PropertyType, reverseEngineeringSettings.ImportTables);
            Assert.IsNull(reverseEngineeringSettings.ImportViews);
            Assert.IsNull(reverseEngineeringSettings.TableNameFilter);
            Assert.IsNull(reverseEngineeringSettings.ViewNameFilter);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveReverseEngineeringSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateUnsavedValidReverseEngineeringSettings();

            //---------------Assert Precondition----------------
            Assert.IsTrue(reverseEngineeringSettings.Status.IsNew);
            BusinessObjectCollection<ReverseEngineeringSettings> col = new BusinessObjectCollection<ReverseEngineeringSettings>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            reverseEngineeringSettings.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(reverseEngineeringSettings.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadReverseEngineeringSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateSavedReverseEngineeringSettings();

            //---------------Execute Test ----------------------
            ReverseEngineeringSettings loadedReverseEngineeringSettings = Broker.GetBusinessObject<ReverseEngineeringSettings>(reverseEngineeringSettings.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(reverseEngineeringSettings.ReverseEngineeringSettingsID, loadedReverseEngineeringSettings.ReverseEngineeringSettingsID);
            Assert.AreEqual(reverseEngineeringSettings.ImportTables, loadedReverseEngineeringSettings.ImportTables);
            Assert.AreEqual(reverseEngineeringSettings.ImportViews, loadedReverseEngineeringSettings.ImportViews);
            Assert.AreEqual(reverseEngineeringSettings.TableNameFilter, loadedReverseEngineeringSettings.TableNameFilter);
            Assert.AreEqual(reverseEngineeringSettings.ViewNameFilter, loadedReverseEngineeringSettings.ViewNameFilter);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteReverseEngineeringSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateSavedReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            reverseEngineeringSettings.MarkForDelete();
            reverseEngineeringSettings.Save();
            //---------------Test Result -----------------------
            try
            {
                ReverseEngineeringSettings retrievedReverseEngineeringSettings = Broker.GetBusinessObject<ReverseEngineeringSettings>(reverseEngineeringSettings.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: ReverseEngineeringSettings", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateReverseEngineeringSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateSavedReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForImportTables = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportTables = (System.Boolean) valueForImportTables;
            object valueForImportViews = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportViews = (System.Boolean) valueForImportViews;
            object valueForTableNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.TableNameFilter = (System.String) valueForTableNameFilter;
            object valueForViewNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.ViewNameFilter = (System.String) valueForViewNameFilter;
            reverseEngineeringSettings.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ReverseEngineeringSettings retrievedReverseEngineeringSettings =
                Broker.GetBusinessObject<ReverseEngineeringSettings>(reverseEngineeringSettings.ID);
            
            Assert.AreEqual(valueForImportTables, retrievedReverseEngineeringSettings.ImportTables);
            Assert.AreEqual(valueForImportViews, retrievedReverseEngineeringSettings.ImportViews);
            Assert.AreEqual(valueForTableNameFilter, retrievedReverseEngineeringSettings.TableNameFilter);
            Assert.AreEqual(valueForViewNameFilter, retrievedReverseEngineeringSettings.ViewNameFilter);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = new ReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForImportTables = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportTables = (System.Boolean) valueForImportTables;
            object valueForImportViews = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportViews = (System.Boolean) valueForImportViews;
            object valueForTableNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.TableNameFilter = (System.String) valueForTableNameFilter;
            object valueForViewNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.ViewNameFilter = (System.String) valueForViewNameFilter;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForImportTables, reverseEngineeringSettings.ImportTables);
            Assert.AreEqual(valueForImportViews, reverseEngineeringSettings.ImportViews);
            Assert.AreEqual(valueForTableNameFilter, reverseEngineeringSettings.TableNameFilter);
            Assert.AreEqual(valueForViewNameFilter, reverseEngineeringSettings.ViewNameFilter);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = new ReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForImportTables = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportTables = (System.Boolean) valueForImportTables;
            object valueForImportViews = TestUtilsShared.GetRandomBoolean();
            reverseEngineeringSettings.ImportViews = (System.Boolean) valueForImportViews;
            object valueForTableNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.TableNameFilter = (System.String) valueForTableNameFilter;
            object valueForViewNameFilter = TestUtilsShared.GetRandomString();
            reverseEngineeringSettings.ViewNameFilter = (System.String) valueForViewNameFilter;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForImportTables, reverseEngineeringSettings.GetPropertyValue("ImportTables"));
            Assert.AreEqual(valueForImportViews, reverseEngineeringSettings.GetPropertyValue("ImportViews"));
            Assert.AreEqual(valueForTableNameFilter, reverseEngineeringSettings.GetPropertyValue("TableNameFilter"));
            Assert.AreEqual(valueForViewNameFilter, reverseEngineeringSettings.GetPropertyValue("ViewNameFilter"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = new ReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForImportTables = TestUtilsShared.GetRandomBoolean();            
            reverseEngineeringSettings.SetPropertyValue("ImportTables", valueForImportTables);
            object valueForImportViews = TestUtilsShared.GetRandomBoolean();            
            reverseEngineeringSettings.SetPropertyValue("ImportViews", valueForImportViews);
            object valueForTableNameFilter = TestUtilsShared.GetRandomString();            
            reverseEngineeringSettings.SetPropertyValue("TableNameFilter", valueForTableNameFilter);
            object valueForViewNameFilter = TestUtilsShared.GetRandomString();            
            reverseEngineeringSettings.SetPropertyValue("ViewNameFilter", valueForViewNameFilter);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForImportTables, reverseEngineeringSettings.ImportTables);
            Assert.AreEqual(valueForImportViews, reverseEngineeringSettings.ImportViews);
            Assert.AreEqual(valueForTableNameFilter, reverseEngineeringSettings.TableNameFilter);
            Assert.AreEqual(valueForViewNameFilter, reverseEngineeringSettings.ViewNameFilter);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateSavedReverseEngineeringSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            reverseEngineeringSettings.ImportTables = null;
            reverseEngineeringSettings.ImportViews = null;
            reverseEngineeringSettings.TableNameFilter = null;
            reverseEngineeringSettings.ViewNameFilter = null;
            reverseEngineeringSettings.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ReverseEngineeringSettings retrievedReverseEngineeringSettings =
                Broker.GetBusinessObject<ReverseEngineeringSettings>(reverseEngineeringSettings.ID);
            
            Assert.IsNull(retrievedReverseEngineeringSettings.ImportTables);
            Assert.IsNull(retrievedReverseEngineeringSettings.ImportViews);
            Assert.IsNull(retrievedReverseEngineeringSettings.TableNameFilter);
            Assert.IsNull(retrievedReverseEngineeringSettings.ViewNameFilter);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            // There are no compulsory properties
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<ReverseEngineeringSettings>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["ReverseEngineeringSettingsID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ImportTables"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ImportViews"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNameFilter"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ViewNameFilter"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineeringSettings reverseEngineeringSettings = TestUtilsReverseEngineeringSettings.CreateSavedReverseEngineeringSettings();

            ReverseEngineering boForRelationshipReverseEngineering = TestUtilsReverseEngineering.CreateSavedReverseEngineering();
            reverseEngineeringSettings.ReverseEngineering = boForRelationshipReverseEngineering;
            reverseEngineeringSettings.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            ReverseEngineering loadedRelatedBO = Broker.GetBusinessObject<ReverseEngineering>(boForRelationshipReverseEngineering.ID);
            ReverseEngineeringSettings loadedReverseEngineeringSettings = Broker.GetBusinessObject<ReverseEngineeringSettings>(reverseEngineeringSettings.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipReverseEngineering, loadedReverseEngineeringSettings.ReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, loadedReverseEngineeringSettings.ReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, reverseEngineeringSettings.ReverseEngineering);
        }
        
        
        
        
        
        
        
       
    }
}


