using System;
using System.Data;
using Firestarter.DB.Schema.BO;
using Firestarter.DB.Schema.Logic;
using FireStarterModeller.BO;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.Logic
{
    [TestFixture]
    public class TestDBReverseEng_GetSchema_SQLServer : TestDBReverseEng_GetSchema
    {
        [TestFixtureSetUp]
        public override void SetupFixture()
        {
            base.SetupFixture();
        }

        [SetUp]
        public override void SetupTest()
        {
            //if (_idbConnection != null)
            //{
            //    _idbConnection.Close();
            //    _idbConnection.Dispose();
            //}
            _testUtilsUtilsDb = CreateSchemaTestDbUtil();
            Console.WriteLine("Creating Test database for SQL Server");
            _testUtilsUtilsDb.CreateTestDatabase();
            _idbConnection = _testUtilsUtilsDb.CreateTestDBConnection();
        }

        protected override TestUtilsDB CreateSchemaTestDbUtil()
        {
            return new TestUtilsDB_SqlServer();
        }


        protected override CreateTableSqlBuilder GetSqlBuilderCreateTable(string tableName)
        {
            return new CreateTableSqlBuilder_SqlServer(tableName);
        }

        protected override void DropTable(DBTable referencedDBTable, IDbConnection connection)
        {
            //                        base.DropTable(referencedDBTable, connection);
        }

        protected override DBSchemaExtractor GetDbSchemaExtractor(IDbConnection idbConnection)
        {
            return new DBSchemaExtractorSQLServer(idbConnection);
        }
    }
}