using System;
using System.Collections.Generic;
using System.Text;
using Firestarter.DB.Schema.BO;
using FireStarterModeller.BO;
using Habanero.DB;
using NUnit.Framework;

namespace Firestarter.DB.Schema.Test.Logic
{


    [TestFixture]
    public class TestDatabaseConnectionInfo: TestBase
    {
        [Test]
        public void Test_CreateDatabaseConfig()
        {
            //---------------Set up test pack-------------------
            DatabaseConnectionInfo databaseConnectionInfo = new DatabaseConnectionInfo
            {
                Vendor = TestUtils.GetRandomString(),
                Server = TestUtils.GetRandomString(),
                Database = TestUtils.GetRandomString(),
                UserName = TestUtils.GetRandomString(),
                Password = TestUtils.GetRandomString()
            };
            //-------------Assert Preconditions -------------

            //---------------Execute Test ----------------------
            DatabaseConfig databaseConfig = databaseConnectionInfo.CreateDatabaseConfig();
            //---------------Test Result -----------------------
            Assert.IsNotNull(databaseConfig);
            Assert.AreEqual(databaseConnectionInfo.Vendor, databaseConfig.Vendor);
            Assert.AreEqual(databaseConnectionInfo.Server, databaseConfig.Server);
            Assert.AreEqual(databaseConnectionInfo.Database, databaseConfig.Database);
            Assert.AreEqual(databaseConnectionInfo.UserName, databaseConfig.UserName);
            Assert.AreEqual(databaseConnectionInfo.Password, databaseConfig.Password);
        }
    }
}
