// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using FireStarterModeller.Test.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMClass objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    
    // Provides the part of the test class that tests DMClass objects
    [TestFixture]
    public partial class TestDMClass : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        [Ignore("Changing how this works")] 
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMClassWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMClass dMClass = new DMClass();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMClass.ClassID);
            Assert.IsInstanceOf(dMClass.Props["ClassID"].PropertyType, dMClass.ClassID);
                        Assert.IsNull(dMClass.ClassNameBO);
                        Assert.IsNull(dMClass.MappedTableName);
                        Assert.IsNull(dMClass.AssemblyID);
                        Assert.IsNull(dMClass.DisplayName);
                        Assert.IsNotNull(dMClass.Generated);
            Assert.IsInstanceOf(dMClass.Props["Generated"].PropertyType, dMClass.Generated);
//                        Assert.IsNull(dMClass.SuperClassID);
                        Assert.IsNull(dMClass.MappedTableID);
                        Assert.IsNull(dMClass.ClassDescription);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateUnsavedValidDMClass();
            DMProperty dmProperty = TestUtilsShared.CreateUnsavedValidDMProperty(dMClass);
            dMClass.CreateObjectIdentity(dmProperty);
            //---------------Assert Precondition----------------
            Assert.IsTrue(dMClass.Status.IsNew);
            BusinessObjectCollection<DMClass> col = new BusinessObjectCollection<DMClass>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMClass.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMClass.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            //---------------Execute Test ----------------------
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMClass.ClassID, loadedDMClass.ClassID);
                        Assert.AreEqual(dMClass.ClassNameBO, loadedDMClass.ClassNameBO);
                        Assert.AreEqual(dMClass.MappedTableName, loadedDMClass.MappedTableName);
                        Assert.AreEqual(dMClass.AssemblyID, loadedDMClass.AssemblyID);
                        Assert.AreEqual(dMClass.DisplayName, loadedDMClass.DisplayName);
                        Assert.AreEqual(dMClass.Generated, loadedDMClass.Generated);
//                        Assert.AreEqual(dMClass.SuperClassID, loadedDMClass.SuperClassID);
                        Assert.AreEqual(dMClass.MappedTableID, loadedDMClass.MappedTableID);
                        Assert.AreEqual(dMClass.ClassDescription, loadedDMClass.ClassDescription);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.MarkForDelete();
            dMClass.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMClass", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtilsShared.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtilsShared.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtilsShared.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
//            object valueForSuperClassID = TestUtilsDMInheritanceRelationship.CreateSavedDMInheritanceRelationship().SuperClassID;
//            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtilsDBTable.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForClassDescription = TestUtilsShared.GetRandomString() + " " + TestUtilsShared.GetRandomString();
            dMClass.ClassDescription = (System.String) valueForClassDescription;
            dMClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMClass retrievedDMClass =
                    Broker.GetBusinessObject<DMClass>(dMClass.ID);
            
            Assert.AreEqual(valueForClassNameBO, retrievedDMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, retrievedDMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, retrievedDMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, retrievedDMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, retrievedDMClass.Generated);
//            Assert.AreEqual(valueForSuperClassID, retrievedDMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, retrievedDMClass.MappedTableID);
            Assert.AreEqual(valueForClassDescription, retrievedDMClass.ClassDescription);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtilsShared.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtilsShared.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtilsShared.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
//            object valueForSuperClassID = TestUtilsDMInheritanceRelationship.CreateSavedDMInheritanceRelationship().SuperClassID;
//            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtilsDBTable.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForClassDescription = TestUtilsShared.GetRandomString();
            dMClass.ClassDescription = (System.String) valueForClassDescription;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, dMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, dMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, dMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, dMClass.Generated);
//            Assert.AreEqual(valueForSuperClassID, dMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, dMClass.MappedTableID);
            Assert.AreEqual(valueForClassDescription, dMClass.ClassDescription);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtilsShared.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtilsShared.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtilsShared.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
//            object valueForSuperClassID = TestUtilsDMInheritanceRelationship.CreateSavedDMInheritanceRelationship().SuperClassID;
//            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtilsDBTable.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForClassDescription = TestUtilsShared.GetRandomString();
            dMClass.ClassDescription = (System.String) valueForClassDescription;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.GetPropertyValue("ClassNameBO"));
            Assert.AreEqual(valueForMappedTableName, dMClass.GetPropertyValue("MappedTableName"));
            Assert.AreEqual(valueForAssemblyID, dMClass.GetPropertyValue("AssemblyID"));
            Assert.AreEqual(valueForDisplayName, dMClass.GetPropertyValue("DisplayName"));
            Assert.AreEqual(valueForGenerated, dMClass.GetPropertyValue("Generated"));
//            Assert.AreEqual(valueForSuperClassID, dMClass.GetPropertyValue("SuperClassID"));
            Assert.AreEqual(valueForMappedTableID, dMClass.GetPropertyValue("MappedTableID"));
            Assert.AreEqual(valueForClassDescription, dMClass.GetPropertyValue("ClassDescription"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtilsShared.GetRandomString(1,100);            
            dMClass.SetPropertyValue("ClassNameBO", valueForClassNameBO);
            object valueForMappedTableName = TestUtilsShared.GetRandomString();            
            dMClass.SetPropertyValue("MappedTableName", valueForMappedTableName);
            object valueForAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;            
            dMClass.SetPropertyValue("AssemblyID", valueForAssemblyID);
            object valueForDisplayName = TestUtilsShared.GetRandomString();            
            dMClass.SetPropertyValue("DisplayName", valueForDisplayName);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMClass.SetPropertyValue("Generated", valueForGenerated);
            //object valueForSuperClassID = TestUtilsDMInheritanceRelationship.CreateSavedDMInheritanceRelationship().SuperClassID;            
            //dMClass.SetPropertyValue("SuperClassID", valueForSuperClassID);
            object valueForMappedTableID = TestUtilsDBTable.CreateSavedDBTable().TableID;            
            dMClass.SetPropertyValue("MappedTableID", valueForMappedTableID);
            object valueForClassDescription = TestUtilsShared.GetRandomString();            
            dMClass.SetPropertyValue("ClassDescription", valueForClassDescription);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, dMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, dMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, dMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, dMClass.Generated);
//            Assert.AreEqual(valueForSuperClassID, dMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, dMClass.MappedTableID);
            Assert.AreEqual(valueForClassDescription, dMClass.ClassDescription);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.DisplayName = null;
            dMClass.Generated = null;
//            dMClass.SuperClassID = null;
            dMClass.MappedTableID = null;
            dMClass.ClassDescription = null;
            dMClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMClass retrievedDMClass =
                    Broker.GetBusinessObject<DMClass>(dMClass.ID);
            
            Assert.IsNull(retrievedDMClass.DisplayName);
            Assert.IsNull(retrievedDMClass.Generated);
//            Assert.IsNull(retrievedDMClass.SuperClassID);
            Assert.IsNull(retrievedDMClass.MappedTableID);
            Assert.IsNull(retrievedDMClass.ClassDescription);
        }

        [Ignore(" Temp Removed due to different Display Name for LGTA Brett 09 Mar 2009")] //TODO :
        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateUnsavedValidDMClass();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.ClassNameBO = null;
            dMClass.MappedTableName = null;
            dMClass.AssemblyID = null;
            
            try
            {
                dMClass.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Class Name BO' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Mapped Table Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Assembly' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMClass>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassNameBO"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedTableName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DisplayName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedTableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassDescription"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Assembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMAssembly boForRelationshipAssembly = TestUtilsDMAssembly.CreateSavedDMAssembly();
            dMClass.Assembly = boForRelationshipAssembly;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMAssembly loadedRelatedBO = Broker.GetBusinessObject<DMAssembly>(boForRelationshipAssembly.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipAssembly, loadedDMClass.Assembly);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.Assembly);
            Assert.AreEqual(loadedRelatedBO, dMClass.Assembly);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_MappedTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DBTable boForRelationshipMappedTable = TestUtilsDBTable.CreateSavedDBTable();
            dMClass.MappedTable = boForRelationshipMappedTable;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBTable loadedRelatedBO = Broker.GetBusinessObject<DBTable>(boForRelationshipMappedTable.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipMappedTable, loadedDMClass.MappedTable);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.MappedTable);
            Assert.AreEqual(loadedRelatedBO, dMClass.MappedTable);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateUnsavedValidDMClass();

            DMObjectIdentity boForRelationshipObjectIdentity = TestUtilsDMObjectIdentity.CreateUnsavedValidDMObjectIdentity_NoDMClass();

            dMClass.ObjectIdentity = boForRelationshipObjectIdentity;
            boForRelationshipObjectIdentity.Properties.Add(TestUtilsShared.CreateUnsavedValidDMProperty(dMClass));
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMObjectIdentity loadedRelatedBO = Broker.GetBusinessObject<DMObjectIdentity>(boForRelationshipObjectIdentity.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreSame(boForRelationshipObjectIdentity, loadedDMClass.ObjectIdentity);
            Assert.AreSame(loadedRelatedBO, loadedDMClass.ObjectIdentity);
            Assert.AreSame(loadedRelatedBO, dMClass.ObjectIdentity);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_SuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMInheritanceRelationship boForRelationshipSuperClass = TestUtilsDMInheritanceRelationship.CreateSavedDMInheritanceRelationship();
            dMClass.InheritanceSuperClassRelationship = boForRelationshipSuperClass;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMInheritanceRelationship loadedRelatedBO = Broker.GetBusinessObject<DMInheritanceRelationship>(boForRelationshipSuperClass.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSuperClass, loadedDMClass.InheritanceSuperClassRelationship);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.InheritanceSuperClassRelationship);
            Assert.AreEqual(loadedRelatedBO, dMClass.InheritanceSuperClassRelationship);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMProperty boForRelationshipProperties = TestUtilsShared.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ClassID = dMClass.ClassID;
            boForRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.Properties.Count);
            //---------------Execute Test ----------------------
            DMProperty loadedRelatedBO = Broker.GetBusinessObject<DMProperty>(boForRelationshipProperties.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.Properties.Count);
            Assert.Contains(boForRelationshipProperties, loadedDMClass.Properties);
            Assert.Contains(loadedRelatedBO, loadedDMClass.Properties);
            Assert.Contains(loadedRelatedBO, dMClass.Properties);
        }
        //[Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        //public void Test_LoadThroughMultipleRelationship_RelatedRelationships()
        //{
        //    CheckIfTestShouldBeIgnored();
        //    //---------------Set up test pack-------------------
        //    BORegistry.DataAccessor = new DataAccessorInMemory();
        //    DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

        //    DMRelationship boForRelationshipRelatedRelationships = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();
        //    boForRelationshipRelatedRelationships.RelatedClassID = dMClass.ClassID;
        //    boForRelationshipRelatedRelationships.Save();

        //    BusinessObjectManager.Instance.ClearLoadedObjects();
        //    GC.Collect();
        //    TestUtils.WaitForGC();
        //    //---------------Assert Preconditions---------------
        //    Assert.AreEqual(1, dMClass.RelatedRelationships.Count);
        //    //---------------Execute Test ----------------------
        //    DMRelationship loadedRelatedBO = Broker.GetBusinessObject<DMRelationship>(boForRelationshipRelatedRelationships.ID);
        //    DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
        //    //---------------Test Result -----------------------
        //    Assert.AreEqual(1, loadedDMClass.RelatedRelationships.Count);
        //    Assert.AreEqual(boForRelationshipRelatedRelationships, loadedDMClass.RelatedRelationships[0]);
        //    Assert.AreEqual(loadedRelatedBO, loadedDMClass.RelatedRelationships[0]);
        //    Assert.AreEqual(loadedRelatedBO, dMClass.RelatedRelationships[0]);
        //}
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelationshipsDM()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();
            DMRelationship boForRelationshipRelationshipsDM = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();
            boForRelationshipRelationshipsDM.OwnerClass = dMClass;
            boForRelationshipRelationshipsDM.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelationshipsDM.Count);
            //---------------Execute Test ----------------------
            DMRelationship loadedRelatedBO = Broker.GetBusinessObject<DMRelationship>(boForRelationshipRelationshipsDM.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.RelationshipsDM.Count);
            Assert.AreEqual(boForRelationshipRelationshipsDM, loadedDMClass.RelationshipsDM[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.RelationshipsDM[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.RelationshipsDM[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_SubClasses()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMInheritanceRelationship boForRelationshipSubClasses = TestUtilsDMInheritanceRelationship.CreateUnsavedValidDMInheritanceRelationship();
            boForRelationshipSubClasses.SuperClassID = dMClass.ClassID;
            boForRelationshipSubClasses.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.SubClassRelationships.Count);
            //---------------Execute Test ----------------------
            DMInheritanceRelationship loadedRelatedBO = Broker.GetBusinessObject<DMInheritanceRelationship>(boForRelationshipSubClasses.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.SubClassRelationships.Count);
            Assert.AreEqual(boForRelationshipSubClasses, loadedDMClass.SubClassRelationships[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.SubClassRelationships[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.SubClassRelationships[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIViews()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            UIView boForRelationshipUIViews = TestUtilsUIView.CreateUnsavedValidUIView();
            boForRelationshipUIViews.ClassID = dMClass.ClassID;
            boForRelationshipUIViews.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UIViews.Count);
            //---------------Execute Test ----------------------
            UIView loadedRelatedBO = Broker.GetBusinessObject<UIView>(boForRelationshipUIViews.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.UIViews.Count);
            Assert.AreEqual(boForRelationshipUIViews, loadedDMClass.UIViews[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.UIViews[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.UIViews[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UniqueConstraints()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMUniqueConstraint boForRelationshipUniqueConstraints = TestUtilsDMUniqueConstraint.CreateUnsavedValidDMUniqueConstraint();
            boForRelationshipUniqueConstraints.ClassID = dMClass.ClassID;
            boForRelationshipUniqueConstraints.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UniqueConstraints.Count);
            //---------------Execute Test ----------------------
            DMUniqueConstraint loadedRelatedBO = Broker.GetBusinessObject<DMUniqueConstraint>(boForRelationshipUniqueConstraints.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.UniqueConstraints.Count);
            Assert.AreSame(boForRelationshipUniqueConstraints, loadedDMClass.UniqueConstraints[0]);
            Assert.AreSame(loadedRelatedBO, loadedDMClass.UniqueConstraints[0]);
            Assert.AreSame(loadedRelatedBO, dMClass.UniqueConstraints[0]);
        }
        
        //[Test]  // Checks that deletion is prevented when a child exists
        //public void Test_MultipleRelationshipDeletion_PreventDelete_RelatedRelationships()
        //{
        //    CheckIfTestShouldBeIgnored();
        //    //---------------Set up test pack-------------------
        //    DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

        //    DMRelationship boForRelationshipRelatedRelationships = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();
        //    boForRelationshipRelatedRelationships.RelatedClassID = dMClass.ClassID;
        //    boForRelationshipRelatedRelationships.Save();

        //    //---------------Assert Preconditions---------------
        //    Assert.AreEqual(1, dMClass.RelatedRelationships.Count);
        //    IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["RelatedRelationships"];
        //    Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
        //    //---------------Execute Test ----------------------
        //    try
        //    {
        //        dMClass.MarkForDelete();
        //        Assert.Fail("expected Err");
        //    }
        //        //---------------Test Result -----------------------
        //    catch (Exception ex)
        //    {
        //        StringAssert.Contains("as the IsDeletable is set to false for the object", ex.Message);
        //        StringAssert.Contains("since it is related to 1 Business Objects via the RelatedRelationships relationship", ex.Message);
        //    }
        //    //    dMClass.Save();
        //    ////---------------Test Result -----------------------
        //    //    Assert.IsTrue(boForRelationshipRelatedRelationships.Status.IsNew);
        //    //    Assert.IsTrue(boForRelationshipRelatedRelationships.Status.IsDeleted);
        //}


        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_RelationshipsDM()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMRelationship boForRelationshipRelationshipsDM = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();
            boForRelationshipRelationshipsDM.OwnerClass = dMClass;
            boForRelationshipRelationshipsDM.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelationshipsDM.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["RelationshipsDM"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------

                dMClass.MarkForDelete();
                dMClass.Save();

            //---------------Test Result -----------------------
                Assert.IsTrue(boForRelationshipRelationshipsDM.Status.IsNew);
                Assert.IsTrue(boForRelationshipRelationshipsDM.Status.IsDeleted);
        }

        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_SubClasses()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMInheritanceRelationship boForRelationshipSubClasses = TestUtilsDMInheritanceRelationship.CreateUnsavedValidDMInheritanceRelationship();
            boForRelationshipSubClasses.SuperClassID = dMClass.ClassID;
            boForRelationshipSubClasses.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.SubClassRelationships.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["SubClassRelationships"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                dMClass.MarkForDelete();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            StringAssert.Contains("since it is related to 1 Business Objects via the SubClassRelationships relationship", expectedException.Message);
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UniqueConstraints()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMUniqueConstraint boForRelationshipUniqueConstraints = TestUtilsDMUniqueConstraint.CreateUnsavedValidDMUniqueConstraint();
            boForRelationshipUniqueConstraints.ClassID = dMClass.ClassID;
            boForRelationshipUniqueConstraints.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UniqueConstraints.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["UniqueConstraints"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------

                dMClass.MarkForDelete();
                dMClass.Save();

            //---------------Test Result -----------------------
                Assert.IsTrue(boForRelationshipUniqueConstraints.Status.IsNew);
                Assert.IsTrue(boForRelationshipUniqueConstraints.Status.IsDeleted);

        }
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            DMProperty boForRelationshipProperties = TestUtilsShared.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ClassID = dMClass.ClassID;
            boForRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.Properties.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["Properties"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMClass.MarkForDelete();
            dMClass.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMClass"));
            }            
            
            try
            {
                Broker.GetBusinessObject<DMProperty>(boForRelationshipProperties.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMProperty"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIViews()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtilsShared.CreateSavedDMClass();

            UIView boForRelationshipUIViews = TestUtilsUIView.CreateUnsavedValidUIView();
            boForRelationshipUIViews.ClassID = dMClass.ClassID;
            boForRelationshipUIViews.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UIViews.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["UIViews"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMClass.MarkForDelete();
            dMClass.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMClass"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIView>(boForRelationshipUIViews.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIView"));
            }
        }
        // ReSharper restore RedundantNameQualifier

    }
}
