// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample DMLookupListDatabase objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests DMLookupListDatabase objects
    [TestFixture]
    public partial class TestDMLookupListDatabase : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMDatabaseLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListDatabase dMLookupListDatabase = new DMLookupListDatabase();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMLookupListDatabase.DatabaseLookupListID);
            Assert.IsInstanceOf(dMLookupListDatabase.Props["DatabaseLookupListID"].PropertyType, dMLookupListDatabase.DatabaseLookupListID);
                        Assert.IsNull(dMLookupListDatabase.Sql);
                        Assert.IsNotNull(dMLookupListDatabase.TimeOut);
            Assert.IsInstanceOf(dMLookupListDatabase.Props["TimeOut"].PropertyType, dMLookupListDatabase.TimeOut);
                        Assert.IsNull(dMLookupListDatabase.LookupClassName);
                        Assert.IsNull(dMLookupListDatabase.Assembly);
                        Assert.IsNotNull(dMLookupListDatabase.LookupListID);
            Assert.IsInstanceOf(dMLookupListDatabase.Props["LookupListID"].PropertyType, dMLookupListDatabase.LookupListID);
                        Assert.IsNotNull(dMLookupListDatabase.Generated);
            Assert.IsInstanceOf(dMLookupListDatabase.Props["Generated"].PropertyType, dMLookupListDatabase.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateUnsavedValidDMDatabaseLookupList();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMLookupListDatabase.Status.IsNew);
            BusinessObjectCollection<DMLookupListDatabase> col = new BusinessObjectCollection<DMLookupListDatabase>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMLookupListDatabase.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMLookupListDatabase.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateSavedDMDatabaseLookupList();

            //---------------Execute Test ----------------------
            DMLookupListDatabase loadedDMLookupListDatabase = Broker.GetBusinessObject<DMLookupListDatabase>(dMLookupListDatabase.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMLookupListDatabase.DatabaseLookupListID, loadedDMLookupListDatabase.DatabaseLookupListID);
                        Assert.AreEqual(dMLookupListDatabase.Sql, loadedDMLookupListDatabase.Sql);
                        Assert.AreEqual(dMLookupListDatabase.TimeOut, loadedDMLookupListDatabase.TimeOut);
                        Assert.AreEqual(dMLookupListDatabase.LookupClassName, loadedDMLookupListDatabase.LookupClassName);
                        Assert.AreEqual(dMLookupListDatabase.Assembly, loadedDMLookupListDatabase.Assembly);
                        Assert.AreEqual(dMLookupListDatabase.LookupListID, loadedDMLookupListDatabase.LookupListID);
                        Assert.AreEqual(dMLookupListDatabase.Generated, loadedDMLookupListDatabase.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListDatabase.MarkForDelete();
            dMLookupListDatabase.Save();
            //---------------Test Result -----------------------
            try
            {
                DMLookupListDatabase retrievedDMLookupListDatabase = Broker.GetBusinessObject<DMLookupListDatabase>(dMLookupListDatabase.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMLookupListDatabase", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMDatabaseLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtilsShared.GetRandomInt();
            dMLookupListDatabase.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupListDatabase.Generated = (System.Boolean) valueForGenerated;
            dMLookupListDatabase.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupListDatabase retrievedDMLookupListDatabase =
                    Broker.GetBusinessObject<DMLookupListDatabase>(dMLookupListDatabase.ID);
            
            Assert.AreEqual(valueForSql, retrievedDMLookupListDatabase.Sql);
            Assert.AreEqual(valueForTimeOut, retrievedDMLookupListDatabase.TimeOut);
            Assert.AreEqual(valueForLookupClassName, retrievedDMLookupListDatabase.LookupClassName);
            Assert.AreEqual(valueForAssembly, retrievedDMLookupListDatabase.Assembly);
            Assert.AreEqual(valueForGenerated, retrievedDMLookupListDatabase.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = new DMLookupListDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtilsShared.GetRandomInt();
            dMLookupListDatabase.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupListDatabase.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMLookupListDatabase.Sql);
            Assert.AreEqual(valueForTimeOut, dMLookupListDatabase.TimeOut);
            Assert.AreEqual(valueForLookupClassName, dMLookupListDatabase.LookupClassName);
            Assert.AreEqual(valueForAssembly, dMLookupListDatabase.Assembly);
            Assert.AreEqual(valueForGenerated, dMLookupListDatabase.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = new DMLookupListDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Sql = (System.String) valueForSql;
            object valueForTimeOut = (decimal)TestUtilsShared.GetRandomInt();
            dMLookupListDatabase.TimeOut = (System.Decimal) valueForTimeOut;
            object valueForLookupClassName = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.LookupClassName = (System.String) valueForLookupClassName;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMLookupListDatabase.Assembly = (System.String) valueForAssembly;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMLookupListDatabase.GetPropertyValue("Sql"));
            Assert.AreEqual(valueForTimeOut, dMLookupListDatabase.GetPropertyValue("TimeOut"));
            Assert.AreEqual(valueForLookupClassName, dMLookupListDatabase.GetPropertyValue("LookupClassName"));
            Assert.AreEqual(valueForAssembly, dMLookupListDatabase.GetPropertyValue("Assembly"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = new DMLookupListDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSql = TestUtilsShared.GetRandomString();            
            dMLookupListDatabase.SetPropertyValue("Sql", valueForSql);
            object valueForTimeOut = (decimal)TestUtilsShared.GetRandomInt();            
            dMLookupListDatabase.SetPropertyValue("TimeOut", valueForTimeOut);
            object valueForLookupClassName = TestUtilsShared.GetRandomString();            
            dMLookupListDatabase.SetPropertyValue("LookupClassName", valueForLookupClassName);
            object valueForAssembly = TestUtilsShared.GetRandomString();            
            dMLookupListDatabase.SetPropertyValue("Assembly", valueForAssembly);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSql, dMLookupListDatabase.Sql);
            Assert.AreEqual(valueForTimeOut, dMLookupListDatabase.TimeOut);
            Assert.AreEqual(valueForLookupClassName, dMLookupListDatabase.LookupClassName);
            Assert.AreEqual(valueForAssembly, dMLookupListDatabase.Assembly);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateSavedDMDatabaseLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListDatabase.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupListDatabase retrievedDMLookupListDatabase =
                    Broker.GetBusinessObject<DMLookupListDatabase>(dMLookupListDatabase.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateUnsavedValidDMDatabaseLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListDatabase.DatabaseLookupListID = null;
            dMLookupListDatabase.Sql = null;
            dMLookupListDatabase.TimeOut = null;
            dMLookupListDatabase.LookupClassName = null;
            dMLookupListDatabase.Assembly = null;
            dMLookupListDatabase.LookupListID = null;
            dMLookupListDatabase.Generated = null;
            
            try
            {
                dMLookupListDatabase.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Database Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Sql' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Time Out' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Lookup Class Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Assembly' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMLookupListDatabase>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["DatabaseLookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Sql"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TimeOut"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LookupClassName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Assembly"].ReadWriteRule.ToString());
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        
        
        
        
        
        
       
        [Test]
        public void Test_Inheritance_SuperClassDef_Exists()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ISuperClassDef superClassDef = ClassDef.Get<DMLookupListDatabase>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.IsNotNull(superClassDef);
        }

        [Test]  
        public void Test_Inheritance_SuperClassDef_PropertiesCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = (SuperClassDef) ClassDef.Get<DMLookupListDatabase>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.AreEqual("DMLookupList", superClassDef.ClassName);
            Assert.AreEqual("FireStarterModeller.BO", superClassDef.AssemblyName);
            Assert.IsNull(superClassDef.ID);
        }
		
        [Test]
        public void Test_Inheritance_SuperClassDef_RelatedClassIsCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            ClassDef classDef = ClassDef.Get<DMLookupListDatabase>();
            ISuperClassDef superClassDef = classDef.SuperClassDef;
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            IClassDef relatedClassDef = ClassDef.ClassDefs[superClassDef.AssemblyName, superClassDef.ClassName];
            //---------------Test Result -----------------------
            Assert.IsNotNull(relatedClassDef);
            PropDef relatedPrimaryKeyDef = (PropDef) relatedClassDef.PrimaryKeyDef[0];
            Assert.IsNotNull(relatedPrimaryKeyDef);
            PropDef propDef = (PropDef) classDef.PropDefColIncludingInheritance[relatedPrimaryKeyDef.PropertyName];
            Assert.IsNotNull(propDef, "Where no child ID match has been specified, the child must have a property with the same name and type as the parent ID");
            Assert.AreEqual(propDef.PropertyType, relatedPrimaryKeyDef.PropertyType);
        }
        
		
        [Test]
        public void Test_Inheritance_CodeClass_InheritsCorrectly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListDatabase dMLookupListDatabase = TestUtilsDMDatabaseLookupList.CreateUnsavedValidDMDatabaseLookupList();
            //---------------Test Result -----------------------
            Assert.IsInstanceOf(typeof(DMLookupList), dMLookupListDatabase);
        }        
    }
}
