// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
  
    
    // Provides the part of the test class that tests DMLookupList objects
    [TestFixture]
    public partial class TestDMLookupList : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupList dMLookupList = new DMLookupList();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMLookupList.LookupListID);
            Assert.IsInstanceOf(dMLookupList.Props["LookupListID"].PropertyType, dMLookupList.LookupListID);
                        Assert.IsNotNull(dMLookupList.Generated);
            Assert.IsInstanceOf(dMLookupList.Props["Generated"].PropertyType, dMLookupList.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateUnsavedValidDMLookupList();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMLookupList.Status.IsNew);
            BusinessObjectCollection<DMLookupList> col = new BusinessObjectCollection<DMLookupList>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMLookupList.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMLookupList.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateSavedDMLookupList();

            //---------------Execute Test ----------------------
            DMLookupList loadedDMLookupList = Broker.GetBusinessObject<DMLookupList>(dMLookupList.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMLookupList.LookupListID, loadedDMLookupList.LookupListID);
                        Assert.AreEqual(dMLookupList.Generated, loadedDMLookupList.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateSavedDMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupList.MarkForDelete();
            dMLookupList.Save();
            //---------------Test Result -----------------------
            try
            {
                DMLookupList retrievedDMLookupList = Broker.GetBusinessObject<DMLookupList>(dMLookupList.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMLookupList", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateSavedDMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupList.Generated = (System.Boolean) valueForGenerated;
            dMLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupList retrievedDMLookupList =
                    Broker.GetBusinessObject<DMLookupList>(dMLookupList.ID);
            
            Assert.AreEqual(valueForGenerated, retrievedDMLookupList.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = new DMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupList.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerated, dMLookupList.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = new DMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupList.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerated, dMLookupList.GetPropertyValue("Generated"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = new DMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMLookupList.SetPropertyValue("Generated", valueForGenerated);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerated, dMLookupList.Generated);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateSavedDMLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupList.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupList retrievedDMLookupList =
                    Broker.GetBusinessObject<DMLookupList>(dMLookupList.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMLookupList dMLookupList = TestUtilsDMLookupList.CreateUnsavedValidDMLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupList.LookupListID = null;
            dMLookupList.Generated = null;
            
            try
            {
                dMLookupList.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMLookupList>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        
        
        
       
    }
}
