using System;
using FireStarterModeller.BO;
using Habanero.BO;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    /// <summary>
    /// Provides a place to write custom tests for DMLookupListDatabase objects.
    /// This file is only written once and can be changed.  The Def file
    /// attached to this as a dependent is rewritten with each regeneration
    /// and contains the standard tests for DMLookupListDatabase.
    /// Regenerate this test project whenever there have been changes to the
    /// business objects.
    /// If tests are failing due to a unique setup in your application,
    /// you can either override the Create methods in TestUtils, or you
    /// can add the test to the ignore list below and reimplement it here.
    /// </summary>
    public partial class TestDMLookupListDatabase
    {
        [TestFixtureSetUp]
        public void SetupTestFixture()
        {
            //------------------------------------------------------------
            // Use this list to ignore generated tests that are failing
            // due to a unique condition in your application.
            // Remember to reimplement the test here.
            //------------------------------------------------------------
            //_ignoreList.Add("TestMethodName", "Reason for ignoring it");
            base.SetupFixture();
        }
        
        [Test]
        public void Test_ToString()
        {
            //---------------Set up test pack-------------------
            DMLookupListDatabase lookupListDatabase = new DMLookupListDatabase();
            //---------------Assert Precondition----------------
            
            //---------------Execute Test ----------------------
            string toString = lookupListDatabase.ToString();
            //---------------Test Result -----------------------
            Assert.AreEqual(lookupListDatabase.DatabaseLookupListID.ToString(), toString);
        }
    }
}