// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using FireStarterModeller.Logic;
using FireStarterModeller.Test.BO.Fakes;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;
using Rhino.Mocks;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMRelationship objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDMRelationship
    {
        /// <summary>
        /// Creates a new saved DMRelationship with a random value assigned to every property
        /// </summary>
        public static DMRelationship CreateSavedDMRelationship()
		{
		    DMRelationship dMRelationship = CreateUnsavedValidDMRelationship();
			dMRelationship.Save();
			return dMRelationship;
		}

        /// <summary>
        /// Creates a new unsaved DMRelationship with a random value assigned to every property
        /// </summary>
		public static DMRelationship CreateUnsavedValidDMRelationship()
		{
            DMRelationship dMRelationship = new DMRelationship();
			UpdateRelationshipValues(dMRelationship);
			UpdateRelationshipValues(dMRelationship.ReverseRelationship);
            DMRelationshipProperty relationshipProperty =  TestUtilsDMRelationshipProperty.CreateUnsavedValidDMRelationshipProperty_WNullRelationship();
            relationshipProperty.Relationship = dMRelationship;
            relationshipProperty.ReverseRelationshipProperty.Relationship = dMRelationship.ReverseRelationship;
            return dMRelationship;
		}

        public static void UpdateRelationshipValues(IDMRelationship dMRelationship)
        {
            DMRelationship relationship = (DMRelationship) dMRelationship;
            relationship.OwnerClass = TestUtilsShared.CreateSavedDMClass();
            relationship.RelationshipName = TestUtilsShared.GetRandomString();
//			dMRelationship.Cardinality = null;
            relationship.RelatedClass = TestUtilsShared.CreateSavedDMClass();
//            dMRelationship.OrderBy = TestUtilsShared.GetRandomString();
            relationship.DeleteAction = DeleteParentAction.DoNothing;
            relationship.Generated = false;
            relationship.RelationshipType = RelationshipType.Association;
            relationship.MappedForeignKeyID = Guid.NewGuid();
        }

        /// <summary>
        /// Creates a new unsaved DMRelationship where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMRelationship CreateUnsavedDefaultDMRelationship()
		{
			DMRelationship dMRelationship = new DMRelationship();
			return dMRelationship;
		}

        public static DMRelationship CreateDMRelationshipAsOneToMany(DMClass parentClass, DMClass childClass)
        {
            DMRelationship multipleRelationship = parentClass.RelationshipsDM.CreateBusinessObject();
            multipleRelationship.Cardinality = Cardinality.Multiple;
            multipleRelationship.RelatedClass = childClass;

            DMRelationship singleRelationship = (DMRelationship) multipleRelationship.ReverseRelationship;
            singleRelationship.Cardinality = Cardinality.Single;

            BusinessObjectCollection<DMProperty> oidProperties = parentClass.ObjectIdentity.Properties;
            if (oidProperties[0].PropertyType.PropertyTypeName == "Guid")
            {
                DMProperty dmProperty = TestUtilsDMProperty.CreateDMProperty(childClass, String.Format("{0}ID", parentClass.ClassNameBO), "System", "Guid");
                DMRelationshipProperty relationshipProperty = singleRelationship.RelationshipProperties.CreateBusinessObject();
                relationshipProperty.OwnerProperty = dmProperty;
                relationshipProperty.RelatedProperty = oidProperties[0];
            }
            else
            {
                foreach (DMProperty oidProperty in oidProperties)
                {
                    DMProperty dmProperty = TestUtilsDMProperty.CreateDMProperty(childClass, String.Format("{0}FK", oidProperty.PropertyName), 
                        oidProperty.PropertyType.AssemblyName, oidProperty.PropertyType.PropertyTypeName);
                    DMRelationshipProperty relationshipProperty = singleRelationship.RelationshipProperties.CreateBusinessObject();
                    relationshipProperty.OwnerProperty = dmProperty;
                    relationshipProperty.RelatedProperty = oidProperty;
                }
            }

            AutoGenerateRelationshipName(multipleRelationship);
            AutoGenerateRelationshipName(singleRelationship);

            return multipleRelationship;
        }

        private static void AutoGenerateRelationshipName(DMRelationship relationship)
        {
            RelationshipNameGenerator relationshipNameGenerator = new RelationshipNameGenerator();
            relationship.RelationshipName = relationshipNameGenerator.CreateRelationshipName(relationship);
        }

        public static DMRelationship CreateDMRelationshipOnProps(DMProperty pkProp, DMProperty fkProp)
        {
            IDMClass parentClass = pkProp.Class;
            IDMClass childClass = fkProp.Class;

            DMRelationship multipleRelationship = parentClass.RelationshipsDM.CreateBusinessObject();
            multipleRelationship.Cardinality = Cardinality.Multiple;
            multipleRelationship.RelatedClass = childClass;

            DMRelationship singleRelationship = (DMRelationship)multipleRelationship.ReverseRelationship;
            singleRelationship.Cardinality = Cardinality.Single;

            DMRelationshipProperty relationshipProperty = singleRelationship.RelationshipProperties.CreateBusinessObject();
            relationshipProperty.OwnerProperty = fkProp;
            relationshipProperty.RelatedProperty = pkProp;

            AutoGenerateRelationshipName(multipleRelationship);
            AutoGenerateRelationshipName(singleRelationship);

            return multipleRelationship;
        }
    }
    
    // Provides the part of the test class that tests DMRelationship objects
    [TestFixture]
    public partial class TestDMRelationship : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMRelationshipWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMRelationship dMRelationship = new DMRelationship();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMRelationship.RelationshipID);
            Assert.IsInstanceOf(dMRelationship.Props["RelationshipID"].PropertyType, dMRelationship.RelationshipID);
                        Assert.IsNull(dMRelationship.ClassID);
                        Assert.IsNull(dMRelationship.RelationshipName);
                        Assert.IsNotNull(dMRelationship.Cardinality);
            Assert.IsInstanceOf(dMRelationship.Props["Cardinality"].PropertyType, dMRelationship.Cardinality);
                        Assert.AreEqual(0, dMRelationship.DMSortOrder.DMSortProperties.Count);
                        Assert.IsNotNull(dMRelationship.DeleteAction);
            Assert.IsInstanceOf(dMRelationship.Props["DeleteAction"].PropertyType, dMRelationship.DeleteAction);
                        Assert.IsNotNull(dMRelationship.Generated);
            Assert.IsInstanceOf(dMRelationship.Props["Generated"].PropertyType, dMRelationship.Generated);
                        Assert.IsNotNull(dMRelationship.RelationshipType);
                        Assert.IsNull(dMRelationship.MappedForeignKeyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMRelationship.Status.IsNew);
            BusinessObjectCollection<DMRelationship> col = new BusinessObjectCollection<DMRelationship>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMRelationship.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMRelationship.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();

            //---------------Execute Test ----------------------
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dMRelationship.RelationshipID, loadedDMRelationship.RelationshipID);
            Assert.AreEqual(dMRelationship.RelationshipName, loadedDMRelationship.RelationshipName);
            Assert.AreEqual(dMRelationship.Cardinality, loadedDMRelationship.Cardinality);
            Assert.AreEqual(dMRelationship.DeleteAction, loadedDMRelationship.DeleteAction);
            Assert.AreEqual(dMRelationship.Generated, loadedDMRelationship.Generated);
            Assert.AreEqual(dMRelationship.RelationshipType, loadedDMRelationship.RelationshipType);
            Assert.AreEqual(dMRelationship.MappedForeignKeyID, loadedDMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationship.MarkForDelete();
            dMRelationship.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMRelationship", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForRelationshipName = TestUtilsShared.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
//            object valueForRelatedClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
//            dMRelationship.RelatedClassID = (System.Guid) valueForRelatedClassID;
//            object valueForKeepReference = TestUtilsShared.GetRandomBoolean();
//            object valueForOrderBy = TestUtilsShared.GetRandomString();
//            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            const DeleteParentAction valueForDeleteAction = DeleteParentAction.Prevent;
            dMRelationship.DeleteAction =  valueForDeleteAction;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            dMRelationship.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMRelationship retrievedDMRelationship =
                    Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            
            Assert.AreEqual(valueForRelationshipName, retrievedDMRelationship.RelationshipName);
//            Assert.AreEqual(valueForRelatedClassID, retrievedDMRelationship.RelatedClassID);
//            Assert.AreEqual(valueForOrderBy, retrievedDMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, retrievedDMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, retrievedDMRelationship.Generated);
            Assert.AreEqual(valueForMappedForeignKeyID, retrievedDMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            System.Guid? valueForOwnerClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMRelationship.ClassID = valueForOwnerClassID;
            object valueForRelationshipName = TestUtilsShared.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
            object valueForKeepReference = TestUtilsShared.GetRandomBoolean();
//            object valueForOrderBy = TestUtilsShared.GetRandomString();
//            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            const DeleteParentAction valueForDeleteAction = DeleteParentAction.DereferenceRelated;
            dMRelationship.DeleteAction = valueForDeleteAction;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForOwnerClassID, dMRelationship.ClassID);
            Assert.AreEqual(valueForRelationshipName, dMRelationship.RelationshipName);
//            Assert.AreEqual(valueForOrderBy, dMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, dMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, dMRelationship.Generated);
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMRelationship.ClassID = (System.Guid) valueForClassID;
            object valueForRelationshipName = TestUtilsShared.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
            object valueForKeepReference = TestUtilsShared.GetRandomBoolean();
//            object valueForOrderBy = TestUtilsShared.GetRandomString();
//            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            DeleteParentAction valueForDeleteAction = DeleteParentAction.DereferenceRelated;
            dMRelationship.DeleteAction = valueForDeleteAction;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMRelationship.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForRelationshipName, dMRelationship.GetPropertyValue("RelationshipName"));
//            Assert.AreEqual(valueForOrderBy, dMRelationship.GetPropertyValue("OrderBy"));
            Assert.AreEqual(valueForDeleteAction, dMRelationship.GetPropertyValue("DeleteAction"));
            Assert.AreEqual(valueForGenerated, dMRelationship.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.GetPropertyValue("MappedForeignKeyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;            
            dMRelationship.SetPropertyValue("ClassID", valueForClassID);
            object valueForRelationshipName = TestUtilsShared.GetRandomString();            
            dMRelationship.SetPropertyValue("RelationshipName", valueForRelationshipName);
            object valueForKeepReference = TestUtilsShared.GetRandomBoolean();            
//            object valueForOrderBy = TestUtilsShared.GetRandomString();            
//            dMRelationship.SetPropertyValue("OrderBy", valueForOrderBy);
            DeleteParentAction valueForDeleteAction = DeleteParentAction.DoNothing;         
            dMRelationship.SetPropertyValue("DeleteAction", valueForDeleteAction);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMRelationship.SetPropertyValue("Generated", valueForGenerated);
            object valueForMappedForeignKeyID = Guid.NewGuid();            
            dMRelationship.SetPropertyValue("MappedForeignKeyID", valueForMappedForeignKeyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMRelationship.ClassID);
            Assert.AreEqual(valueForRelationshipName, dMRelationship.RelationshipName);
//            Assert.AreEqual(valueForOrderBy, dMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, dMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, dMRelationship.Generated);
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
//            dMRelationship.OrderBy = null;
//            dMRelationship.DeleteAction = null;
            dMRelationship.DMSortOrder = null;
//            dMRelationship.RelationshipType = null;
            dMRelationship.MappedForeignKeyID = null;
            dMRelationship.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMRelationship retrievedDMRelationship =
                    Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            
            Assert.IsNull(retrievedDMRelationship.DMSortOrder);
//            Assert.IsNull(retrievedDMRelationship.DeleteAction);
//            Assert.IsNull(retrievedDMRelationship.RelationshipType);
            Assert.IsNull(retrievedDMRelationship.MappedForeignKeyID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationship.ClassID = null;
            dMRelationship.RelationshipName = null;
            dMRelationship.Generated = null;
            
            try
            {
                dMRelationship.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                //StringAssert.Contains("Class' is a compulsory field and has no value", ex.Message);
                //StringAssert.Contains("Relationship Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMRelationship>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["RelationshipID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Cardinality"].ReadWriteRule.ToString());
//			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["OrderBy"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DeleteAction"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedForeignKeyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_OwnerClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();

            DMClass boForRelationshipOwnerClass = (DMClass) dMRelationship.OwnerClass;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMClass loadedRelatedBO = Broker.GetBusinessObject<DMClass>(boForRelationshipOwnerClass.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipOwnerClass, loadedDMRelationship.OwnerClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.OwnerClass);
            Assert.AreEqual(loadedRelatedBO, dMRelationship.OwnerClass);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_RelatedClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();

            DMClass boForRelationshipRelatedClass = (DMClass) dMRelationship.RelatedClass;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMClass loadedRelatedBO = Broker.GetBusinessObject<DMClass>(boForRelationshipRelatedClass.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelatedClass, loadedDMRelationship.RelatedClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.RelatedClass);
            Assert.AreEqual(loadedRelatedBO, dMRelationship.RelatedClass);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelationshipProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();

            DMRelationshipProperty boForRelationshipRelationshipProperties = TestUtilsDMRelationshipProperty.CreateUnsavedValidDMRelationshipProperty();
            boForRelationshipRelationshipProperties.RelationshipID = dMRelationship.RelationshipID;
            boForRelationshipRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            BusinessObjectCollection<DMRelationshipProperty> relationshipProperties = dMRelationship.RelationshipProperties;
            relationshipProperties.Refresh();
            Assert.AreEqual(2, relationshipProperties.Count);
            //---------------Execute Test ----------------------
            DMRelationshipProperty loadedRelatedBO = Broker.GetBusinessObject<DMRelationshipProperty>(boForRelationshipRelationshipProperties.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(2, loadedDMRelationship.RelationshipProperties.Count);
            Assert.AreEqual(boForRelationshipRelationshipProperties, loadedDMRelationship.RelationshipProperties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.RelationshipProperties[0]);
            Assert.AreEqual(loadedRelatedBO, relationshipProperties[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_RelationshipProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtilsDMRelationship.CreateSavedDMRelationship();

            DMRelationshipProperty boForRelationshipRelationshipProperties = TestUtilsDMRelationshipProperty.CreateUnsavedValidDMRelationshipProperty();
            boForRelationshipRelationshipProperties.RelationshipID = dMRelationship.RelationshipID;
            boForRelationshipRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            BusinessObjectCollection<DMRelationshipProperty> relationshipProperties = dMRelationship.RelationshipProperties;
            relationshipProperties.Refresh();
            Assert.AreEqual(2, relationshipProperties.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMRelationship>().RelationshipDefCol["RelationshipProperties"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------

            dMRelationship.MarkForDelete();
            dMRelationship.Save();
            //---------------Test Result -----------------------
            Assert.IsTrue(boForRelationshipRelationshipProperties.Status.IsNew);
            Assert.IsTrue(boForRelationshipRelationshipProperties.Status.IsDeleted);
        }
        // ReSharper restore RedundantNameQualifier       

    }
}
