// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using FireStarterModeller.Logic;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMSolution objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public static class TestUtilsDMSolution
    {
        /// <summary>
        /// Creates a new saved DMSolution with a random value assigned to every property
        /// </summary>
        public static DMSolution CreateSavedDMSolution()
		{
		    DMSolution dMSolution = CreateUnsavedValidDMSolution();
			dMSolution.Save();
			return dMSolution;
		}

        /// <summary>
        /// Creates a new unsaved DMSolution with a random value assigned to every property
        /// </summary>
		public static DMSolution CreateUnsavedValidDMSolution()
		{
            SolutionCreator solutionCreator = new SolutionCreator();
            DMSolution dMSolution = solutionCreator.CreateSolution();
			UpdateWithValidData(dMSolution);
            return dMSolution;
		}

        public static void UpdateWithValidData(DMSolution dMSolution)
        {
            dMSolution.SolutionName = TestUtilsShared.GetRandomString(2,100);
            dMSolution.DefaultAssembly = TestUtilsDMAssembly.CreateSavedDMAssembly();
            dMSolution.HabaneroDllPath = TestUtilsShared.GetRandomString();
            dMSolution.TableNamePrefix = TestUtilsShared.GetRandomString();
            dMSolution.TableNameSuffix = TestUtilsShared.GetRandomString();
            dMSolution.PascalCase = TestUtilsShared.GetRandomBoolean();
            dMSolution.SolutionDirectory = TestUtilsShared.GetRandomString();
            dMSolution.UIProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOProjectName = TestUtilsShared.GetRandomString();
            dMSolution.LogicProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BaseProjectName = TestUtilsShared.GetRandomString();
            dMSolution.Generated = false;
            dMSolution.BOTestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UITestProjectName = TestUtilsShared.GetRandomString();
        }

        /// <summary>
        /// Creates a new unsaved DMSolution where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMSolution CreateUnsavedDefaultDMSolution()
		{
			DMSolution dMSolution = new DMSolution();
			return dMSolution;
		}

        public static DMSolution CreateSavedDMSolutionWithTwoClasses()
        {
            DMSolution solution = CreateSavedDMSolution();
            solution.DefaultAssembly = TestUtilsDMAssembly.CreateSavedDMAssembly();
            TestUtilsDMClass.CreateUnsavedDefaultDMClass(solution);
            TestUtilsDMClass.CreateUnsavedDefaultDMClass(solution);
            return solution;
        }


    }
    
    // Provides the part of the test class that tests DMSolution objects
    [TestFixture]
    public partial class TestDMSolution : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSolutionWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSolution dMSolution = new DMSolution();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMSolution.SolutionID);
            Assert.IsInstanceOf(dMSolution.Props["SolutionID"].PropertyType, dMSolution.SolutionID);
                        Assert.IsNull(dMSolution.SolutionName);
                        Assert.IsNull(dMSolution.DefaultAssemblyID);
                        Assert.IsNull(dMSolution.HabaneroDllPath);
                        Assert.IsNull(dMSolution.TableNamePrefix);
                        Assert.IsNull(dMSolution.TableNameSuffix);
                        Assert.IsNotNull(dMSolution.PascalCase);
            Assert.IsInstanceOf(dMSolution.Props["PascalCase"].PropertyType, dMSolution.PascalCase);
                        Assert.IsNull(dMSolution.SolutionDirectory);
                        Assert.IsNull(dMSolution.UIProjectName);
                        Assert.IsNull(dMSolution.BOProjectName);
                        Assert.IsNull(dMSolution.LogicProjectName);
                        Assert.IsNull(dMSolution.BaseProjectName);
                        Assert.IsNotNull(dMSolution.Generated);
            Assert.IsInstanceOf(dMSolution.Props["Generated"].PropertyType, dMSolution.Generated);
                        Assert.IsNull(dMSolution.BOTestProjectName);
                        Assert.IsNull(dMSolution.UITestProjectName);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            TestUtilsDMSolution.UpdateWithValidData(dMSolution);
            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSolution.Status.IsNew);
            BusinessObjectCollection<DMSolution> col = new BusinessObjectCollection<DMSolution>();
            col.LoadAll();
            Assert.AreEqual(1, col.Count);

            //---------------Execute Test ----------------------
            dMSolution.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSolution.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(2, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            //---------------Execute Test ----------------------
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSolution.SolutionID, loadedDMSolution.SolutionID);
                        Assert.AreEqual(dMSolution.SolutionName, loadedDMSolution.SolutionName);
                        Assert.AreEqual(dMSolution.DefaultAssemblyID, loadedDMSolution.DefaultAssemblyID);
                        Assert.AreEqual(dMSolution.HabaneroDllPath, loadedDMSolution.HabaneroDllPath);
                        Assert.AreEqual(dMSolution.TableNamePrefix, loadedDMSolution.TableNamePrefix);
                        Assert.AreEqual(dMSolution.TableNameSuffix, loadedDMSolution.TableNameSuffix);
                        Assert.AreEqual(dMSolution.PascalCase, loadedDMSolution.PascalCase);
                        Assert.AreEqual(dMSolution.SolutionDirectory, loadedDMSolution.SolutionDirectory);
                        Assert.AreEqual(dMSolution.UIProjectName, loadedDMSolution.UIProjectName);
                        Assert.AreEqual(dMSolution.BOProjectName, loadedDMSolution.BOProjectName);
                        Assert.AreEqual(dMSolution.LogicProjectName, loadedDMSolution.LogicProjectName);
                        Assert.AreEqual(dMSolution.BaseProjectName, loadedDMSolution.BaseProjectName);
                        Assert.AreEqual(dMSolution.Generated, loadedDMSolution.Generated);
                        Assert.AreEqual(dMSolution.BOTestProjectName, loadedDMSolution.BOTestProjectName);
                        Assert.AreEqual(dMSolution.UITestProjectName, loadedDMSolution.UITestProjectName);
        }

        [Ignore("Can no longer delete ")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer delete 
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSolution", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtilsShared.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtilsShared.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtilsShared.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtilsShared.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtilsShared.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            dMSolution.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSolution retrievedDMSolution =
                    Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            
            Assert.AreEqual(valueForSolutionName, retrievedDMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, retrievedDMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, retrievedDMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, retrievedDMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, retrievedDMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, retrievedDMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, retrievedDMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, retrievedDMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, retrievedDMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, retrievedDMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, retrievedDMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, retrievedDMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, retrievedDMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, retrievedDMSolution.UITestProjectName);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtilsShared.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtilsShared.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtilsShared.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtilsShared.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtilsShared.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, dMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, dMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, dMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, dMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, dMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, dMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, dMSolution.UITestProjectName);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtilsShared.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtilsShared.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtilsShared.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtilsShared.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtilsShared.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtilsShared.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.GetPropertyValue("SolutionName"));
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.GetPropertyValue("DefaultAssemblyID"));
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.GetPropertyValue("HabaneroDllPath"));
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.GetPropertyValue("TableNamePrefix"));
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.GetPropertyValue("TableNameSuffix"));
            Assert.AreEqual(valueForPascalCase, dMSolution.GetPropertyValue("PascalCase"));
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.GetPropertyValue("SolutionDirectory"));
            Assert.AreEqual(valueForUIProjectName, dMSolution.GetPropertyValue("UIProjectName"));
            Assert.AreEqual(valueForBOProjectName, dMSolution.GetPropertyValue("BOProjectName"));
            Assert.AreEqual(valueForLogicProjectName, dMSolution.GetPropertyValue("LogicProjectName"));
            Assert.AreEqual(valueForBaseProjectName, dMSolution.GetPropertyValue("BaseProjectName"));
            Assert.AreEqual(valueForGenerated, dMSolution.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.GetPropertyValue("BOTestProjectName"));
            Assert.AreEqual(valueForUITestProjectName, dMSolution.GetPropertyValue("UITestProjectName"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtilsShared.GetRandomString(2,100);            
            dMSolution.SetPropertyValue("SolutionName", valueForSolutionName);
            object valueForDefaultAssemblyID = TestUtilsDMAssembly.CreateSavedDMAssembly().AssemblyID;            
            dMSolution.SetPropertyValue("DefaultAssemblyID", valueForDefaultAssemblyID);
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("HabaneroDllPath", valueForHabaneroDllPath);
            object valueForTableNamePrefix = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("TableNamePrefix", valueForTableNamePrefix);
            object valueForTableNameSuffix = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("TableNameSuffix", valueForTableNameSuffix);
            object valueForPascalCase = TestUtilsShared.GetRandomBoolean();            
            dMSolution.SetPropertyValue("PascalCase", valueForPascalCase);
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("SolutionDirectory", valueForSolutionDirectory);
            object valueForUIProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("UIProjectName", valueForUIProjectName);
            object valueForBOProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("BOProjectName", valueForBOProjectName);
            object valueForLogicProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("LogicProjectName", valueForLogicProjectName);
            object valueForBaseProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("BaseProjectName", valueForBaseProjectName);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMSolution.SetPropertyValue("Generated", valueForGenerated);
            object valueForBOTestProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("BOTestProjectName", valueForBOTestProjectName);
            object valueForUITestProjectName = TestUtilsShared.GetRandomString();            
            dMSolution.SetPropertyValue("UITestProjectName", valueForUITestProjectName);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, dMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, dMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, dMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, dMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, dMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, dMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, dMSolution.UITestProjectName);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.HabaneroDllPath = null;
            dMSolution.TableNamePrefix = null;
            dMSolution.TableNameSuffix = null;
            dMSolution.PascalCase = null;
            dMSolution.UIProjectName = null;
            dMSolution.BOProjectName = null;
            dMSolution.LogicProjectName = null;
            dMSolution.BaseProjectName = null;
            dMSolution.Generated = null;
            dMSolution.BOTestProjectName = null;
            dMSolution.UITestProjectName = null;
            dMSolution.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSolution retrievedDMSolution =
                    Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            
            Assert.IsNull(retrievedDMSolution.HabaneroDllPath);
            Assert.IsNull(retrievedDMSolution.TableNamePrefix);
            Assert.IsNull(retrievedDMSolution.TableNameSuffix);
            Assert.IsNull(retrievedDMSolution.PascalCase);
            Assert.IsNull(retrievedDMSolution.UIProjectName);
            Assert.IsNull(retrievedDMSolution.BOProjectName);
            Assert.IsNull(retrievedDMSolution.LogicProjectName);
            Assert.IsNull(retrievedDMSolution.BaseProjectName);
            Assert.IsNull(retrievedDMSolution.Generated);
            Assert.IsNull(retrievedDMSolution.BOTestProjectName);
            Assert.IsNull(retrievedDMSolution.UITestProjectName);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = new DMSolution();
            TestUtilsDMSolution.UpdateWithValidData(dMSolution);

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.SolutionID = null;
            dMSolution.SolutionName = null;
            dMSolution.DefaultAssemblyID = null;
            dMSolution.SolutionDirectory = null;
            
            try
            {
                dMSolution.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("SolutionID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Solution Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Default Assembly ID' is a compulsory field and has no value", ex.Message);
                //StringAssert.Contains("Solution Directory' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSolution>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DefaultAssemblyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["HabaneroDllPath"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNamePrefix"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNameSuffix"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PascalCase"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionDirectory"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BOProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LogicProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BaseProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BOTestProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UITestProjectName"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            DMAssembly boForRelationshipDefaultAssembly = TestUtilsDMAssembly.CreateSavedDMAssembly();
            dMSolution.DefaultAssembly = boForRelationshipDefaultAssembly;
            dMSolution.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMAssembly loadedRelatedBO = Broker.GetBusinessObject<DMAssembly>(boForRelationshipDefaultAssembly.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDefaultAssembly, loadedDMSolution.DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, dMSolution.DefaultAssembly);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Assemblies()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            DMAssembly boForRelationshipAssemblies = TestUtilsDMAssembly.CreateUnsavedValidDMAssembly();
            boForRelationshipAssemblies.SolutionID = dMSolution.SolutionID;
            boForRelationshipAssemblies.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            dMSolution.Assemblies.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(2, dMSolution.Assemblies.Count, "One saved now and one by the Solution Default assembly");
            //---------------Execute Test ----------------------
            DMAssembly loadedRelatedBO = Broker.GetBusinessObject<DMAssembly>(boForRelationshipAssemblies.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(2, loadedDMSolution.Assemblies.Count,"The one added now and the default assembly");
            Assert.IsTrue(loadedDMSolution.Assemblies.Contains(boForRelationshipAssemblies));
            Assert.IsTrue(loadedDMSolution.Assemblies.Contains(boForRelationshipAssemblies));
            Assert.IsTrue(dMSolution.Assemblies.Contains(loadedRelatedBO));
        }
//        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
//        public void Test_LoadThroughMultipleRelationship_PropertyTypes()
//        {
//            CheckIfTestShouldBeIgnored();
//            //---------------Set up test pack-------------------
//            BORegistry.DataAccessor = new DataAccessorInMemory();
//            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();
//
//            DMPropertyType boForRelationshipPropertyTypes = TestUtilsDMPropertyType.CreateUnsavedValidDMPropertyType();
////            boForRelationshipPropertyTypes.SolutionID = dMSolution.SolutionID;
//            boForRelationshipPropertyTypes.Save();
//
//            BusinessObjectManager.Instance.ClearLoadedObjects();
//            GC.Collect();
//            TestUtils.WaitForGC();
//            //---------------Assert Preconditions---------------
//            Assert.AreEqual(1, dMSolution.PropertyTypes.Count);
//            //---------------Execute Test ----------------------
//            DMPropertyType loadedRelatedBO = Broker.GetBusinessObject<DMPropertyType>(boForRelationshipPropertyTypes.ID);
//            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
//            //---------------Test Result -----------------------
//            Assert.AreEqual(1, loadedDMSolution.PropertyTypes.Count);
//            Assert.AreEqual(boForRelationshipPropertyTypes, loadedDMSolution.PropertyTypes[0]);
//            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.PropertyTypes[0]);
//            Assert.AreEqual(loadedRelatedBO, dMSolution.PropertyTypes[0]);
//        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIControlMapperTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIControlMapperType boForRelationshipUIControlMapperTypes = TestUtilsUIControlMapperType.CreateUnsavedValidUIControlMapperType();
            boForRelationshipUIControlMapperTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIControlMapperTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            dMSolution.UIControlMapperTypes.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(3, dMSolution.UIControlMapperTypes.Count);
            //---------------Execute Test ----------------------
            UIControlMapperType loadedRelatedBO = Broker.GetBusinessObject<UIControlMapperType>(boForRelationshipUIControlMapperTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            BusinessObjectCollection<UIControlMapperType> uiControlMapperTypes = loadedDMSolution.UIControlMapperTypes;
            Assert.AreEqual(3, uiControlMapperTypes.Count);
            Assert.IsTrue(uiControlMapperTypes.Contains(boForRelationshipUIControlMapperTypes));
            Assert.AreEqual(boForRelationshipUIControlMapperTypes, uiControlMapperTypes[0]);
            Assert.AreEqual(loadedRelatedBO, uiControlMapperTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIControlMapperTypes[0]);
        }

        [Ignore(" Not sure if this is relevant given that we are creating a solution with it control types")] //TODO Brett 02 Apr 2009: Not sure if this is relevant given that we are creating a solution with it control types
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIControlType boForRelationshipUIControlTypes = TestUtilsUIControlType.CreateUnsavedValidUIControlType();
            boForRelationshipUIControlTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIControlTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(5, dMSolution.UIControlTypes.Count);
            //---------------Execute Test ----------------------
            UIControlType loadedRelatedBO = Broker.GetBusinessObject<UIControlType>(boForRelationshipUIControlTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(5, loadedDMSolution.UIControlTypes.Count);
            Assert.AreEqual(boForRelationshipUIControlTypes, loadedDMSolution.UIControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.UIControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIControlTypes[0]);
        }

        [Ignore(" Not sure if this is relevant given that we are creating a solution with it control types")] //TODO Brett 02 Apr 2009: Not sure if this is relevant given that we are creating a solution with it control types
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIGridColumnControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIGridColumnControlType boForRelationshipUIGridColumnControlTypes = TestUtilsUIGridColumnControlType.CreateUnsavedValidUIGridColumnControlType();
            boForRelationshipUIGridColumnControlTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIGridColumnControlTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(4, dMSolution.UIGridColumnControlTypes.Count);
            //---------------Execute Test ----------------------
            UIGridColumnControlType loadedRelatedBO = Broker.GetBusinessObject<UIGridColumnControlType>(boForRelationshipUIGridColumnControlTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(4, loadedDMSolution.UIGridColumnControlTypes.Count);
            Assert.AreEqual(boForRelationshipUIGridColumnControlTypes, loadedDMSolution.UIGridColumnControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.UIGridColumnControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIGridColumnControlTypes[0]);
        }
        
        //[Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        [Ignore("Can no longer delete DMSolution")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer delete DMSolution
            [Test]
        public void Test_MultipleRelationshipDeletion_DeleteRelated_Assemblies()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            DMAssembly boForRelationshipAssemblies = TestUtilsDMAssembly.CreateUnsavedValidDMAssembly();
            boForRelationshipAssemblies.SolutionID = dMSolution.SolutionID;
            boForRelationshipAssemblies.Save();
            dMSolution.Assemblies.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(2, dMSolution.Assemblies.Count, "Default plus added assembly");
            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["Assemblies"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<DMAssembly>(boForRelationshipAssemblies.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMAssembly"));
            }
        }
//        [Test]  // Checks that deleting a parent deletes the child
//        public void Test_MultipleRelationshipDeletion_DeleteRelated_PropertyTypes()
//        {
//            CheckIfTestShouldBeIgnored();
//            //---------------Set up test pack-------------------
//            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();
//
//            DMPropertyType boForRelationshipPropertyTypes = TestUtilsDMPropertyType.CreateUnsavedValidDMPropertyType();
//            boForRelationshipPropertyTypes.SolutionID = dMSolution.SolutionID;
//            boForRelationshipPropertyTypes.Save();
//
//            //---------------Assert Preconditions---------------
//            Assert.AreEqual(1, dMSolution.PropertyTypes.Count);
//            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["PropertyTypes"];
//            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
//            //---------------Execute Test ----------------------
//            dMSolution.MarkForDelete();
//            dMSolution.Save();
//            //---------------Execute Test ----------------------
//            BusinessObjectManager.Instance.ClearLoadedObjects();
//            GC.Collect();
//            TestUtils.WaitForGC();
//
//            try
//            {
//                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
//                Assert.Fail("BO should no longer exist and exception should be thrown");
//            }
//            catch (BusObjDeleteConcurrencyControlException ex)
//            {
//                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
//            }            
//            
//            try
//            {
//                Broker.GetBusinessObject<DMPropertyType>(boForRelationshipPropertyTypes.ID);
//                Assert.Fail("BO should no longer exist and exception should be thrown");
//            }
//            catch (BusObjDeleteConcurrencyControlException ex)
//            {
//                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMPropertyType"));
//            }
//        }
        [Ignore("Can no longer delete solution")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer delete solution
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIControlMapperTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIControlMapperType boForRelationshipUIControlMapperTypes = TestUtilsUIControlMapperType.CreateUnsavedValidUIControlMapperType();
            boForRelationshipUIControlMapperTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIControlMapperTypes.Save();
            dMSolution.UIControlMapperTypes.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(3, dMSolution.UIControlMapperTypes.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIControlMapperTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIControlMapperType>(boForRelationshipUIControlMapperTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIControlMapperType"));
            }
        }

        [Ignore("Can no longer delete DMSolution due to having System PropTypes")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer delete DMSolution due to having System PropTypes
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIControlType boForRelationshipUIControlTypes = TestUtilsUIControlType.CreateUnsavedValidUIControlType();
            boForRelationshipUIControlTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIControlTypes.Save();
            dMSolution.UIControlTypes.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(5, dMSolution.UIControlTypes.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIControlTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIControlType>(boForRelationshipUIControlTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIControlType"));
            }
        }

        [Ignore("Can no longer Delete Solution")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer Delete Solution
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIGridColumnControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            UIGridColumnControlType boForRelationshipUIGridColumnControlTypes = TestUtilsUIGridColumnControlType.CreateUnsavedValidUIGridColumnControlType();
            boForRelationshipUIGridColumnControlTypes.SolutionID = dMSolution.SolutionID;
            boForRelationshipUIGridColumnControlTypes.Save();
            dMSolution.UIGridColumnControlTypes.Refresh();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(4, dMSolution.UIGridColumnControlTypes.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIGridColumnControlTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIGridColumnControlType>(boForRelationshipUIGridColumnControlTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridColumnControlType"));
            }
        }

        [Ignore("Can no longer Delete Solution")] //TODO Brett 09 Feb 2010: Ignored Test - Can no longer Delete Solution
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtilsShared.CreateSavedDMSolution();

            DMAssembly boForRelationshipDefaultAssembly = TestUtilsDMAssembly.CreateSavedDMAssembly();
            dMSolution.DefaultAssembly = boForRelationshipDefaultAssembly;
            dMSolution.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["DefaultAssembly"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.MarkForDelete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }

            try
            {
                Broker.GetBusinessObject<DMAssembly>(boForRelationshipDefaultAssembly.ID);
                Assert.Fail("expected Err");
            }
                //---------------Test Result -----------------------
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("There are no records in the database for the Class: DMAssembly identified b", ex.Message, "The default assembly is added to the Assemblies and is thus deleted as part of this relationship");
            }
            
        }
        // ReSharper restore RedundantNameQualifier       
    }
}
