// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests DMSortOrder objects
    [TestFixture]
    public partial class TestDMSortOrder
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSortOrderWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSortOrder dMSortOrder = new DMSortOrder();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMSortOrder.DMSortOrderID);
            Assert.IsInstanceOf(dMSortOrder.Props["DMSortOrderID"].PropertyType, dMSortOrder.DMSortOrderID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateUnsavedValidDMSortOrder();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSortOrder.Status.IsNew);
            BusinessObjectCollection<DMSortOrder> col = new BusinessObjectCollection<DMSortOrder>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMSortOrder.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSortOrder.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();

            //---------------Execute Test ----------------------
            DMSortOrder loadedDMSortOrder = Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSortOrder.DMSortOrderID, loadedDMSortOrder.DMSortOrderID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortOrder.MarkForDelete();
            dMSortOrder.Save();
            //---------------Test Result -----------------------
            try
            {
                DMSortOrder retrievedDMSortOrder = Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSortOrder", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortOrder.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSortOrder retrievedDMSortOrder =
                    Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);
            
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = new DMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = new DMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = new DMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortOrder.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSortOrder retrievedDMSortOrder =
                    Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateUnsavedValidDMSortOrder();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortOrder.DMSortOrderID = null;
            
            try
            {
                dMSortOrder.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains(".DM Sort Order ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSortOrder>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DMSortOrderID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_DMSortProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();

            DMSortProperty boForRelationshipDMSortProperties = TestUtilsDMSortProperty.CreateUnsavedValidDMSortProperty();
            boForRelationshipDMSortProperties.DMSortOrderID = dMSortOrder.DMSortOrderID;
            boForRelationshipDMSortProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSortOrder.DMSortProperties.Count);
            //---------------Execute Test ----------------------
            DMSortProperty loadedRelatedBO = Broker.GetBusinessObject<DMSortProperty>(boForRelationshipDMSortProperties.ID);
            DMSortOrder loadedDMSortOrder = Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSortOrder.DMSortProperties.Count);
            Assert.AreEqual(boForRelationshipDMSortProperties, loadedDMSortOrder.DMSortProperties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSortOrder.DMSortProperties[0]);
            Assert.AreEqual(loadedRelatedBO, dMSortOrder.DMSortProperties[0]);
        }
        
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_DMSortProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortOrder dMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();

            DMSortProperty boForRelationshipDMSortProperties = TestUtilsDMSortProperty.CreateUnsavedValidDMSortProperty();
            boForRelationshipDMSortProperties.DMSortOrderID = dMSortOrder.DMSortOrderID;
            boForRelationshipDMSortProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSortOrder.DMSortProperties.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMSortOrder>().RelationshipDefCol["DMSortProperties"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSortOrder.MarkForDelete();
            dMSortOrder.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSortOrder>(dMSortOrder.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("There are no records in the database for the Class: DMSortOrder", ex.Message);
            }            
            
            try
            {
                Broker.GetBusinessObject<DMSortProperty>(boForRelationshipDMSortProperties.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("There are no records in the database for the Class: DMSortProperty", ex.Message);
            }
        }
    }
}
