// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMUniqueConstraint objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDMUniqueConstraint
    {
        /// <summary>
        /// Creates a new saved DMUniqueConstraint with a random value assigned to every property
        /// </summary>
        public static DMUniqueConstraint CreateSavedDMUniqueConstraint()
		{
		    DMUniqueConstraint dMUniqueConstraint = CreateUnsavedValidDMUniqueConstraint();
			dMUniqueConstraint.Save();
			return dMUniqueConstraint;
		}

        /// <summary>
        /// Creates a new unsaved DMUniqueConstraint with a random value assigned to every property
        /// </summary>
		public static DMUniqueConstraint CreateUnsavedValidDMUniqueConstraint()
		{
            return CreateUnsavedValidDMUniqueConstraint(null);
		}

        /// <summary>
        /// Creates a new unsaved DMUniqueConstraint with a random value assigned to every property
        /// </summary>
		public static DMUniqueConstraint CreateUnsavedValidDMUniqueConstraint(DMClass dmClass)
		{
			DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();
            if (dmClass == null)
            {
                dMUniqueConstraint.ClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            }
            else
            {
                dMUniqueConstraint.Class = dmClass;
            }

            dMUniqueConstraint.Message = TestUtilsShared.GetRandomString();
			dMUniqueConstraint.IgnoreIfNull = TestUtilsShared.GetRandomBoolean();
			dMUniqueConstraint.UniqueConstraintName = TestUtilsShared.GetRandomString();
			dMUniqueConstraint.Generated = TestUtilsShared.GetRandomBoolean();
			dMUniqueConstraint.MappedAlternateKeyID = Guid.NewGuid();
			return dMUniqueConstraint;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMUniqueConstraint where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMUniqueConstraint CreateUnsavedDefaultDMUniqueConstraint()
		{
			DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();
			return dMUniqueConstraint;
		}

        public static DMUniqueConstraint CreateUniqueConstraint(IDMClass dmClass, params IDMProperty[] ucProps)
        {
            DMUniqueConstraint uniqueConstraint = CreateUniqueConstraint(dmClass);
            foreach (DMProperty ucProp in ucProps)
            {
                uniqueConstraint.UniqueConstraintProperties.Add(new DMUniqueConstraintProperty { Property = ucProp });
            }
            return uniqueConstraint;
        }

        public static DMUniqueConstraint CreateUniqueConstraint(IDMClass dmClass)
        {
            var dmUniqueConstraint = new DMUniqueConstraint { Class = (DMClass) dmClass };
            dmUniqueConstraint.UniqueConstraintName = TestUtilsShared.GetRandomString();
            return dmUniqueConstraint;
        }
    }
    
    // Provides the part of the test class that tests DMUniqueConstraint objects
    [TestFixture]
    public partial class TestDMUniqueConstraint : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMUniqueConstraintWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMUniqueConstraint.UniqueConstraintID);
            Assert.IsInstanceOf(dMUniqueConstraint.Props["UniqueConstraintID"].PropertyType, dMUniqueConstraint.UniqueConstraintID);
                        Assert.IsNull(dMUniqueConstraint.ClassID);
                        Assert.IsNull(dMUniqueConstraint.Message);
                        Assert.IsNotNull(dMUniqueConstraint.IgnoreIfNull);
            Assert.IsInstanceOf(dMUniqueConstraint.Props["IgnoreIfNull"].PropertyType, dMUniqueConstraint.IgnoreIfNull);
                        Assert.IsNull(dMUniqueConstraint.UniqueConstraintName);
                        Assert.IsNotNull(dMUniqueConstraint.Generated);
            Assert.IsInstanceOf(dMUniqueConstraint.Props["Generated"].PropertyType, dMUniqueConstraint.Generated);
                        Assert.IsNull(dMUniqueConstraint.MappedAlternateKeyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMUniqueConstraint()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateUnsavedValidDMUniqueConstraint();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMUniqueConstraint.Status.IsNew);
            BusinessObjectCollection<DMUniqueConstraint> col = new BusinessObjectCollection<DMUniqueConstraint>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMUniqueConstraint.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMUniqueConstraint.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMUniqueConstraint()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();

            //---------------Execute Test ----------------------
            DMUniqueConstraint loadedDMUniqueConstraint = Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMUniqueConstraint.UniqueConstraintID, loadedDMUniqueConstraint.UniqueConstraintID);
                        Assert.AreEqual(dMUniqueConstraint.ClassID, loadedDMUniqueConstraint.ClassID);
                        Assert.AreEqual(dMUniqueConstraint.Message, loadedDMUniqueConstraint.Message);
                        Assert.AreEqual(dMUniqueConstraint.IgnoreIfNull, loadedDMUniqueConstraint.IgnoreIfNull);
                        Assert.AreEqual(dMUniqueConstraint.UniqueConstraintName, loadedDMUniqueConstraint.UniqueConstraintName);
                        Assert.AreEqual(dMUniqueConstraint.Generated, loadedDMUniqueConstraint.Generated);
                        Assert.AreEqual(dMUniqueConstraint.MappedAlternateKeyID, loadedDMUniqueConstraint.MappedAlternateKeyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMUniqueConstraint()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraint.MarkForDelete();
            dMUniqueConstraint.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMUniqueConstraint", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMUniqueConstraint()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMUniqueConstraint.ClassID = (System.Guid?) valueForClassID;
            object valueForMessage = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.Message = (System.String) valueForMessage;
            object valueForIgnoreIfNull = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.IgnoreIfNull = (System.Boolean) valueForIgnoreIfNull;
            object valueForName = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.UniqueConstraintName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedAlternateKeyID = Guid.NewGuid();
            dMUniqueConstraint.MappedAlternateKeyID = (System.Guid) valueForMappedAlternateKeyID;
            dMUniqueConstraint.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMUniqueConstraint retrievedDMUniqueConstraint =
                    Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
            
            Assert.AreEqual(valueForClassID, retrievedDMUniqueConstraint.ClassID);
            Assert.AreEqual(valueForMessage, retrievedDMUniqueConstraint.Message);
            Assert.AreEqual(valueForIgnoreIfNull, retrievedDMUniqueConstraint.IgnoreIfNull);
            Assert.AreEqual(valueForName, retrievedDMUniqueConstraint.UniqueConstraintName);
            Assert.AreEqual(valueForGenerated, retrievedDMUniqueConstraint.Generated);
            Assert.AreEqual(valueForMappedAlternateKeyID, retrievedDMUniqueConstraint.MappedAlternateKeyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMUniqueConstraint.ClassID = (System.Guid?) valueForClassID;
            object valueForMessage = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.Message = (System.String) valueForMessage;
            object valueForIgnoreIfNull = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.IgnoreIfNull = (System.Boolean) valueForIgnoreIfNull;
            object valueForName = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.UniqueConstraintName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedAlternateKeyID = Guid.NewGuid();
            dMUniqueConstraint.MappedAlternateKeyID = (System.Guid) valueForMappedAlternateKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMUniqueConstraint.ClassID);
            Assert.AreEqual(valueForMessage, dMUniqueConstraint.Message);
            Assert.AreEqual(valueForIgnoreIfNull, dMUniqueConstraint.IgnoreIfNull);
            Assert.AreEqual(valueForName, dMUniqueConstraint.UniqueConstraintName);
            Assert.AreEqual(valueForGenerated, dMUniqueConstraint.Generated);
            Assert.AreEqual(valueForMappedAlternateKeyID, dMUniqueConstraint.MappedAlternateKeyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMUniqueConstraint.ClassID = (System.Guid?) valueForClassID;
            object valueForMessage = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.Message = (System.String) valueForMessage;
            object valueForIgnoreIfNull = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.IgnoreIfNull = (System.Boolean) valueForIgnoreIfNull;
            object valueForName = TestUtilsShared.GetRandomString();
            dMUniqueConstraint.UniqueConstraintName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMUniqueConstraint.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedAlternateKeyID = Guid.NewGuid();
            dMUniqueConstraint.MappedAlternateKeyID = (System.Guid) valueForMappedAlternateKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMUniqueConstraint.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForMessage, dMUniqueConstraint.GetPropertyValue("Message"));
            Assert.AreEqual(valueForIgnoreIfNull, dMUniqueConstraint.GetPropertyValue("IgnoreIfNull"));
            Assert.AreEqual(valueForName, dMUniqueConstraint.GetPropertyValue("UniqueConstraintName"));
            Assert.AreEqual(valueForGenerated, dMUniqueConstraint.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForMappedAlternateKeyID, dMUniqueConstraint.GetPropertyValue("MappedAlternateKeyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = new DMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;            
            dMUniqueConstraint.SetPropertyValue("ClassID", valueForClassID);
            object valueForMessage = TestUtilsShared.GetRandomString();            
            dMUniqueConstraint.SetPropertyValue("Message", valueForMessage);
            object valueForIgnoreIfNull = TestUtilsShared.GetRandomBoolean();            
            dMUniqueConstraint.SetPropertyValue("IgnoreIfNull", valueForIgnoreIfNull);
            object valueForName = TestUtilsShared.GetRandomString();            
            dMUniqueConstraint.SetPropertyValue("UniqueConstraintName", valueForName);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMUniqueConstraint.SetPropertyValue("Generated", valueForGenerated);
            object valueForMappedAlternateKeyID = Guid.NewGuid();            
            dMUniqueConstraint.SetPropertyValue("MappedAlternateKeyID", valueForMappedAlternateKeyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMUniqueConstraint.ClassID);
            Assert.AreEqual(valueForMessage, dMUniqueConstraint.Message);
            Assert.AreEqual(valueForIgnoreIfNull, dMUniqueConstraint.IgnoreIfNull);
            Assert.AreEqual(valueForName, dMUniqueConstraint.UniqueConstraintName);
            Assert.AreEqual(valueForGenerated, dMUniqueConstraint.Generated);
            Assert.AreEqual(valueForMappedAlternateKeyID, dMUniqueConstraint.MappedAlternateKeyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraint.MappedAlternateKeyID = null;
            dMUniqueConstraint.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMUniqueConstraint retrievedDMUniqueConstraint =
                    Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
            
            Assert.IsNull(retrievedDMUniqueConstraint.MappedAlternateKeyID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateUnsavedValidDMUniqueConstraint();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMUniqueConstraint.UniqueConstraintID = null;
            dMUniqueConstraint.ClassID = null;
            dMUniqueConstraint.IgnoreIfNull = null;
            dMUniqueConstraint.UniqueConstraintName = null;
            dMUniqueConstraint.Generated = null;
            
            try
            {
                dMUniqueConstraint.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Unique Constraint ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Class ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Ignore If Null' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Unique Constraint Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMUniqueConstraint>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UniqueConstraintID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Message"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IgnoreIfNull"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UniqueConstraintName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedAlternateKeyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();

            DMClass boForRelationshipClass = dMUniqueConstraint.Class;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMClass loadedRelatedBO = Broker.GetBusinessObject<DMClass>(boForRelationshipClass.ID);
            DMUniqueConstraint loadedDMUniqueConstraint = Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedDMUniqueConstraint.Class);
            Assert.AreEqual(loadedRelatedBO, loadedDMUniqueConstraint.Class);
            Assert.AreEqual(loadedRelatedBO, dMUniqueConstraint.Class);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UniqueConstraintProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();

            DMUniqueConstraintProperty boForRelationshipUniqueConstraintProperties = TestUtilsDMUniqueConstraintProperty.CreateUnsavedValidDMUniqueConstraintProperty();
            boForRelationshipUniqueConstraintProperties.UniqueConstraintID = dMUniqueConstraint.UniqueConstraintID;
            boForRelationshipUniqueConstraintProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMUniqueConstraint.UniqueConstraintProperties.Count);
            //---------------Execute Test ----------------------
            DMUniqueConstraintProperty loadedRelatedBO = Broker.GetBusinessObject<DMUniqueConstraintProperty>(boForRelationshipUniqueConstraintProperties.ID);
            DMUniqueConstraint loadedDMUniqueConstraint = Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMUniqueConstraint.UniqueConstraintProperties.Count);
            Assert.AreEqual(boForRelationshipUniqueConstraintProperties, loadedDMUniqueConstraint.UniqueConstraintProperties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMUniqueConstraint.UniqueConstraintProperties[0]);
            Assert.AreEqual(loadedRelatedBO, dMUniqueConstraint.UniqueConstraintProperties[0]);
        }
        
        
        [Test]  // Checks that deleting a parent clears the related property on the child
        public void Test_MultipleRelationshipDeletion_DereferenceRelated_UniqueConstraintProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMUniqueConstraint dMUniqueConstraint = TestUtilsDMUniqueConstraint.CreateSavedDMUniqueConstraint();

            DMUniqueConstraintProperty boForRelationshipUniqueConstraintProperties = TestUtilsDMUniqueConstraintProperty.CreateUnsavedValidDMUniqueConstraintProperty();
            boForRelationshipUniqueConstraintProperties.UniqueConstraintID = dMUniqueConstraint.UniqueConstraintID;
            boForRelationshipUniqueConstraintProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMUniqueConstraint.UniqueConstraintProperties.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMUniqueConstraint>().RelationshipDefCol["UniqueConstraintProperties"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMUniqueConstraint.MarkForDelete();
            dMUniqueConstraint.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMUniqueConstraint>(dMUniqueConstraint.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMUniqueConstraint"));
            }
            Assert.IsTrue(dMUniqueConstraint.Status.IsNew);           
            Assert.IsTrue(dMUniqueConstraint.Status.IsDeleted);           
        }
        // ReSharper restore RedundantNameQualifier
    }
}
