// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests GenerationSettings objects
    [TestFixture]
    public partial class TestGenerationSettings : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateGenerationSettingsWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            string defaultHabaneroDllPath = @"D:\Systems\Habanero\trunk\bin";
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            GenerationSettings generationSettings = new GenerationSettings();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(generationSettings.GenerationSettingsID);
                        Assert.IsInstanceOf(generationSettings.Props["GenerationSettingsID"].PropertyType, generationSettings.GenerationSettingsID);
                        Assert.IsNull(generationSettings.SolutionID);
                        Assert.IsNull(generationSettings.SolutionName);
                        Assert.IsNull(generationSettings.DatabaseConnectionID);
                        Assert.IsNull(generationSettings.SolutionDirectory);
                        Assert.IsNotNull(generationSettings.HabaneroDllPath);
                        Assert.IsNull(generationSettings.SolutionTypeID);
                        Assert.AreEqual(defaultHabaneroDllPath, generationSettings.HabaneroDllPath);
            
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveGenerationSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateUnsavedValidGenerationSettings();

            //---------------Assert Precondition----------------
            Assert.IsTrue(generationSettings.Status.IsNew);
            BusinessObjectCollection<GenerationSettings> col = new BusinessObjectCollection<GenerationSettings>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            generationSettings.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(generationSettings.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadGenerationSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();

            //---------------Execute Test ----------------------
            GenerationSettings loadedGenerationSettings = Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(generationSettings.GenerationSettingsID, loadedGenerationSettings.GenerationSettingsID);
                        Assert.AreEqual(generationSettings.SolutionID, loadedGenerationSettings.SolutionID);
                        Assert.AreEqual(generationSettings.SolutionName, loadedGenerationSettings.SolutionName);
                        Assert.AreEqual(generationSettings.DatabaseConnectionID, loadedGenerationSettings.DatabaseConnectionID);
                        Assert.AreEqual(generationSettings.SolutionDirectory, loadedGenerationSettings.SolutionDirectory);
                        Assert.AreEqual(generationSettings.HabaneroDllPath, loadedGenerationSettings.HabaneroDllPath);
                        Assert.AreEqual(generationSettings.SolutionTypeID, loadedGenerationSettings.SolutionTypeID);
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateGenerationSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionID = TestUtilsDMSolution.CreateSavedDMSolution().SolutionID;
            generationSettings.SolutionID = (System.Guid) valueForSolutionID;
            object valueForSolutionName = TestUtilsShared.GetRandomString();
            generationSettings.SolutionName = (System.String)valueForSolutionName;
            object valueForDatabaseConnectionID = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            generationSettings.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            generationSettings.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            generationSettings.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForSolutionTypeID = Guid.NewGuid();
            generationSettings.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            generationSettings.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            GenerationSettings retrievedGenerationSettings =
                    Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);
            
            Assert.AreEqual(valueForSolutionID, retrievedGenerationSettings.SolutionID);
            Assert.AreEqual(valueForSolutionName, retrievedGenerationSettings.SolutionName);
            Assert.AreEqual(valueForDatabaseConnectionID, retrievedGenerationSettings.DatabaseConnectionID);
            Assert.AreEqual(valueForSolutionDirectory, retrievedGenerationSettings.SolutionDirectory);
            Assert.AreEqual(valueForHabaneroDllPath, retrievedGenerationSettings.HabaneroDllPath);
            Assert.AreEqual(valueForSolutionTypeID, retrievedGenerationSettings.SolutionTypeID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = new GenerationSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionID = TestUtilsDMSolution.CreateSavedDMSolution().SolutionID;
            generationSettings.SolutionID = (System.Guid) valueForSolutionID;
            object valueForSolutionName = TestUtilsShared.GetRandomString();
            generationSettings.SolutionName = (System.String)valueForSolutionName;
            object valueForDatabaseConnectionID = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            generationSettings.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            generationSettings.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            generationSettings.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForSolutionTypeID = Guid.NewGuid();
            generationSettings.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionID, generationSettings.SolutionID);
            Assert.AreEqual(valueForSolutionName, generationSettings.SolutionName);
            Assert.AreEqual(valueForDatabaseConnectionID, generationSettings.DatabaseConnectionID);
            Assert.AreEqual(valueForSolutionDirectory, generationSettings.SolutionDirectory);
            Assert.AreEqual(valueForHabaneroDllPath, generationSettings.HabaneroDllPath);
            Assert.AreEqual(valueForSolutionTypeID, generationSettings.SolutionTypeID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = new GenerationSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionID = TestUtilsDMSolution.CreateSavedDMSolution().SolutionID;
            generationSettings.SolutionID = (System.Guid) valueForSolutionID;
            object valueForSolutionName = TestUtilsShared.GetRandomString();
            generationSettings.SolutionName = (System.String)valueForSolutionName;
            object valueForDatabaseConnectionID = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            generationSettings.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();
            generationSettings.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();
            generationSettings.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForSolutionTypeID = Guid.NewGuid();
            generationSettings.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionID, generationSettings.GetPropertyValue("SolutionID"));
            Assert.AreEqual(valueForSolutionName, generationSettings.GetPropertyValue("SolutionName"));
            Assert.AreEqual(valueForDatabaseConnectionID, generationSettings.GetPropertyValue("DatabaseConnectionID"));
            Assert.AreEqual(valueForSolutionDirectory, generationSettings.GetPropertyValue("SolutionDirectory"));
            Assert.AreEqual(valueForHabaneroDllPath, generationSettings.GetPropertyValue("HabaneroDllPath"));
            Assert.AreEqual(valueForSolutionTypeID, generationSettings.GetPropertyValue("SolutionTypeID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = new GenerationSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionID = TestUtilsDMSolution.CreateSavedDMSolution().SolutionID;            
            generationSettings.SetPropertyValue("SolutionID", valueForSolutionID);
            object valueForSolutionName = TestUtilsShared.GetRandomString();
            generationSettings.SetPropertyValue("SolutionName", valueForSolutionName);
            object valueForDatabaseConnectionID = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;            
            generationSettings.SetPropertyValue("DatabaseConnectionID", valueForDatabaseConnectionID);
            object valueForSolutionDirectory = TestUtilsShared.GetRandomString();            
            generationSettings.SetPropertyValue("SolutionDirectory", valueForSolutionDirectory);
            object valueForHabaneroDllPath = TestUtilsShared.GetRandomString();            
            generationSettings.SetPropertyValue("HabaneroDllPath", valueForHabaneroDllPath);
            object valueForSolutionTypeID = Guid.NewGuid();            
            generationSettings.SetPropertyValue("SolutionTypeID", valueForSolutionTypeID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionID, generationSettings.SolutionID);
            Assert.AreEqual(valueForSolutionName, generationSettings.SolutionName);
            Assert.AreEqual(valueForDatabaseConnectionID, generationSettings.DatabaseConnectionID);
            Assert.AreEqual(valueForSolutionDirectory, generationSettings.SolutionDirectory);
            Assert.AreEqual(valueForHabaneroDllPath, generationSettings.HabaneroDllPath);
            Assert.AreEqual(valueForSolutionTypeID, generationSettings.SolutionTypeID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            generationSettings.SolutionName = null;
            generationSettings.DatabaseConnectionID = null;
            generationSettings.SolutionDirectory = null;
            generationSettings.HabaneroDllPath = null;
            generationSettings.SolutionTypeID = null;
            generationSettings.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            GenerationSettings retrievedGenerationSettings =
                    Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);

            Assert.IsNull(retrievedGenerationSettings.SolutionName);
            Assert.IsNull(retrievedGenerationSettings.DatabaseConnectionID);
            Assert.IsNull(retrievedGenerationSettings.SolutionDirectory);
            Assert.IsNull(retrievedGenerationSettings.HabaneroDllPath);
            Assert.IsNull(retrievedGenerationSettings.SolutionTypeID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateUnsavedValidGenerationSettings();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            generationSettings.GenerationSettingsID = null;
            generationSettings.SolutionID = null;
            
            try
            {
                generationSettings.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Generation Settings ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Solution' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<GenerationSettings>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["GenerationSettingsID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DatabaseConnectionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionDirectory"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["HabaneroDllPath"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionTypeID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_DatabaseConnection()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();

            DatabaseConnectionInfo boForRelationshipDatabaseConnection = TestUtilsDatabaseConnectionInfo.CreateSavedDatabaseConnectionInfo();
            generationSettings.DatabaseConnection = boForRelationshipDatabaseConnection;
            generationSettings.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DatabaseConnectionInfo loadedRelatedBO = Broker.GetBusinessObject<DatabaseConnectionInfo>(boForRelationshipDatabaseConnection.ID);
            GenerationSettings loadedGenerationSettings = Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDatabaseConnection, loadedGenerationSettings.DatabaseConnection);
            Assert.AreEqual(loadedRelatedBO, loadedGenerationSettings.DatabaseConnection);
            Assert.AreEqual(loadedRelatedBO, generationSettings.DatabaseConnection);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();

            DMSolution boForRelationshipSolution = TestUtilsDMSolution.CreateSavedDMSolution();
            generationSettings.Solution = boForRelationshipSolution;
            generationSettings.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMSolution loadedRelatedBO = Broker.GetBusinessObject<DMSolution>(boForRelationshipSolution.ID);
            GenerationSettings loadedGenerationSettings = Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedGenerationSettings.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedGenerationSettings.Solution);
            Assert.AreEqual(loadedRelatedBO, generationSettings.Solution);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ProjectTypeGenerations()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();

            ProjectTypeGeneration boForRelationshipProjectTypeGenerations = TestUtilsProjectTypeGeneration.CreateUnsavedValidProjectTypeGeneration();
            boForRelationshipProjectTypeGenerations.GenerationSettingsID = generationSettings.GenerationSettingsID;
            boForRelationshipProjectTypeGenerations.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, generationSettings.ProjectTypeGenerations.Count);
            //---------------Execute Test ----------------------
            ProjectTypeGeneration loadedRelatedBO = Broker.GetBusinessObject<ProjectTypeGeneration>(boForRelationshipProjectTypeGenerations.ID);
            GenerationSettings loadedGenerationSettings = Broker.GetBusinessObject<GenerationSettings>(generationSettings.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedGenerationSettings.ProjectTypeGenerations.Count);
            Assert.AreEqual(boForRelationshipProjectTypeGenerations, loadedGenerationSettings.ProjectTypeGenerations[0]);
            Assert.AreEqual(loadedRelatedBO, loadedGenerationSettings.ProjectTypeGenerations[0]);
            Assert.AreEqual(loadedRelatedBO, generationSettings.ProjectTypeGenerations[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ProjectTypeGenerations()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            GenerationSettings generationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();

            ProjectTypeGeneration boForRelationshipProjectTypeGenerations = TestUtilsProjectTypeGeneration.CreateUnsavedValidProjectTypeGeneration();
            boForRelationshipProjectTypeGenerations.GenerationSettingsID = generationSettings.GenerationSettingsID;
            boForRelationshipProjectTypeGenerations.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, generationSettings.ProjectTypeGenerations.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<GenerationSettings>().RelationshipDefCol["ProjectTypeGenerations"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                generationSettings.MarkForDelete();
                generationSettings.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
        }
        
        
        
        
        
       
    }
}
