// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests ProjectType objects
    [TestFixture]
    public partial class TestProjectType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateProjectTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ProjectType projectType = new ProjectType();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(projectType.ProjectTypeID);
            Assert.IsInstanceOf(projectType.Props["ProjectTypeID"].PropertyType, projectType.ProjectTypeID);
                        Assert.IsNull(projectType.Name);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateUnsavedValidProjectType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(projectType.Status.IsNew);
            BusinessObjectCollection<ProjectType> col = new BusinessObjectCollection<ProjectType>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            projectType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(projectType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();

            //---------------Execute Test ----------------------
            ProjectType loadedProjectType = Broker.GetBusinessObject<ProjectType>(projectType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(projectType.ProjectTypeID, loadedProjectType.ProjectTypeID);
                        Assert.AreEqual(projectType.Name, loadedProjectType.Name);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectType.MarkForDelete();
            projectType.Save();
            //---------------Test Result -----------------------
            try
            {
                ProjectType retrievedProjectType = Broker.GetBusinessObject<ProjectType>(projectType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: ProjectType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            projectType.Name = (System.String) valueForName;
            projectType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ProjectType retrievedProjectType =
                    Broker.GetBusinessObject<ProjectType>(projectType.ID);
            
            Assert.AreEqual(valueForName, retrievedProjectType.Name);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = new ProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            projectType.Name = (System.String) valueForName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, projectType.Name);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = new ProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            projectType.Name = (System.String) valueForName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, projectType.GetPropertyValue("Name"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = new ProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();            
            projectType.SetPropertyValue("Name", valueForName);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, projectType.Name);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ProjectType retrievedProjectType =
                    Broker.GetBusinessObject<ProjectType>(projectType.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ProjectType projectType = TestUtilsProjectType.CreateUnsavedValidProjectType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectType.ProjectTypeID = null;
            projectType.Name = null;
            
            try
            {
                projectType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Project Type ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Name' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<ProjectType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["ProjectTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ProjectSolutionTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();

            SolutionTypeProject boForRelationshipProjectSolutionTypes = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();
            boForRelationshipProjectSolutionTypes.ProjectTypeID = projectType.ProjectTypeID;
            boForRelationshipProjectSolutionTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, projectType.ProjectSolutionTypes.Count);
            //---------------Execute Test ----------------------
            SolutionTypeProject loadedRelatedBO = Broker.GetBusinessObject<SolutionTypeProject>(boForRelationshipProjectSolutionTypes.ID);
            ProjectType loadedProjectType = Broker.GetBusinessObject<ProjectType>(projectType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedProjectType.ProjectSolutionTypes.Count);
            Assert.AreEqual(boForRelationshipProjectSolutionTypes, loadedProjectType.ProjectSolutionTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedProjectType.ProjectSolutionTypes[0]);
            Assert.AreEqual(loadedRelatedBO, projectType.ProjectSolutionTypes[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ProjectSolutionTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectType projectType = TestUtilsProjectType.CreateSavedProjectType();

            SolutionTypeProject boForRelationshipProjectSolutionTypes = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();
            boForRelationshipProjectSolutionTypes.ProjectTypeID = projectType.ProjectTypeID;
            boForRelationshipProjectSolutionTypes.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, projectType.ProjectSolutionTypes.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<ProjectType>().RelationshipDefCol["ProjectSolutionTypes"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                projectType.MarkForDelete();
                projectType.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
        }
        
        
        
        
        
       
    }
}
