// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests ProjectTypeGeneration objects
    [TestFixture]
    public partial class TestProjectTypeGeneration : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateProjectTypeGenerationWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ProjectTypeGeneration projectTypeGeneration = new ProjectTypeGeneration();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(projectTypeGeneration.ProjectTypeGenerationID);
            Assert.IsInstanceOf(projectTypeGeneration.Props["ProjectTypeGenerationID"].PropertyType, projectTypeGeneration.ProjectTypeGenerationID);
                        Assert.IsNull(projectTypeGeneration.GenerationSettingsID);
                        Assert.IsNull(projectTypeGeneration.ProjectTypeID);
                        Assert.IsNull(projectTypeGeneration.ProjectName);
                        Assert.IsNotNull(projectTypeGeneration.ToBeGenerated);
            Assert.IsInstanceOf(projectTypeGeneration.Props["ToBeGenerated"].PropertyType, projectTypeGeneration.ToBeGenerated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveProjectTypeGeneration()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateUnsavedValidProjectTypeGeneration();

            //---------------Assert Precondition----------------
            Assert.IsTrue(projectTypeGeneration.Status.IsNew);
            BusinessObjectCollection<ProjectTypeGeneration> col = new BusinessObjectCollection<ProjectTypeGeneration>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            projectTypeGeneration.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(projectTypeGeneration.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadProjectTypeGeneration()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();

            //---------------Execute Test ----------------------
            ProjectTypeGeneration loadedProjectTypeGeneration = Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(projectTypeGeneration.ProjectTypeGenerationID, loadedProjectTypeGeneration.ProjectTypeGenerationID);
                        Assert.AreEqual(projectTypeGeneration.GenerationSettingsID, loadedProjectTypeGeneration.GenerationSettingsID);
                        Assert.AreEqual(projectTypeGeneration.ProjectTypeID, loadedProjectTypeGeneration.ProjectTypeID);
                        Assert.AreEqual(projectTypeGeneration.ProjectName, loadedProjectTypeGeneration.ProjectName);
                        Assert.AreEqual(projectTypeGeneration.ToBeGenerated, loadedProjectTypeGeneration.ToBeGenerated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteProjectTypeGeneration()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectTypeGeneration.MarkForDelete();
            projectTypeGeneration.Save();
            //---------------Test Result -----------------------
            try
            {
                ProjectTypeGeneration retrievedProjectTypeGeneration = Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: ProjectTypeGeneration", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateProjectTypeGeneration()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerationSettingsID = TestUtilsGenerationSettings.CreateSavedGenerationSettings().GenerationSettingsID;
            projectTypeGeneration.GenerationSettingsID = (System.Guid) valueForGenerationSettingsID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            projectTypeGeneration.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            object valueForProjectName = TestUtilsShared.GetRandomString();
            projectTypeGeneration.ProjectName = (System.String) valueForProjectName;
            object valueForToBeGenerated = TestUtilsShared.GetRandomBoolean();
            projectTypeGeneration.ToBeGenerated = (System.Boolean) valueForToBeGenerated;
            projectTypeGeneration.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ProjectTypeGeneration retrievedProjectTypeGeneration =
                    Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
            
            Assert.AreEqual(valueForGenerationSettingsID, retrievedProjectTypeGeneration.GenerationSettingsID);
            Assert.AreEqual(valueForProjectTypeID, retrievedProjectTypeGeneration.ProjectTypeID);
            Assert.AreEqual(valueForProjectName, retrievedProjectTypeGeneration.ProjectName);
            Assert.AreEqual(valueForToBeGenerated, retrievedProjectTypeGeneration.ToBeGenerated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = new ProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerationSettingsID = TestUtilsGenerationSettings.CreateSavedGenerationSettings().GenerationSettingsID;
            projectTypeGeneration.GenerationSettingsID = (System.Guid) valueForGenerationSettingsID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            projectTypeGeneration.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            object valueForProjectName = TestUtilsShared.GetRandomString();
            projectTypeGeneration.ProjectName = (System.String) valueForProjectName;
            object valueForToBeGenerated = TestUtilsShared.GetRandomBoolean();
            projectTypeGeneration.ToBeGenerated = (System.Boolean) valueForToBeGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerationSettingsID, projectTypeGeneration.GenerationSettingsID);
            Assert.AreEqual(valueForProjectTypeID, projectTypeGeneration.ProjectTypeID);
            Assert.AreEqual(valueForProjectName, projectTypeGeneration.ProjectName);
            Assert.AreEqual(valueForToBeGenerated, projectTypeGeneration.ToBeGenerated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = new ProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerationSettingsID = TestUtilsGenerationSettings.CreateSavedGenerationSettings().GenerationSettingsID;
            projectTypeGeneration.GenerationSettingsID = (System.Guid) valueForGenerationSettingsID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            projectTypeGeneration.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            object valueForProjectName = TestUtilsShared.GetRandomString();
            projectTypeGeneration.ProjectName = (System.String) valueForProjectName;
            object valueForToBeGenerated = TestUtilsShared.GetRandomBoolean();
            projectTypeGeneration.ToBeGenerated = (System.Boolean) valueForToBeGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerationSettingsID, projectTypeGeneration.GetPropertyValue("GenerationSettingsID"));
            Assert.AreEqual(valueForProjectTypeID, projectTypeGeneration.GetPropertyValue("ProjectTypeID"));
            Assert.AreEqual(valueForProjectName, projectTypeGeneration.GetPropertyValue("ProjectName"));
            Assert.AreEqual(valueForToBeGenerated, projectTypeGeneration.GetPropertyValue("ToBeGenerated"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = new ProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerationSettingsID = TestUtilsGenerationSettings.CreateSavedGenerationSettings().GenerationSettingsID;            
            projectTypeGeneration.SetPropertyValue("GenerationSettingsID", valueForGenerationSettingsID);
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;            
            projectTypeGeneration.SetPropertyValue("ProjectTypeID", valueForProjectTypeID);
            object valueForProjectName = TestUtilsShared.GetRandomString();            
            projectTypeGeneration.SetPropertyValue("ProjectName", valueForProjectName);
            object valueForToBeGenerated = TestUtilsShared.GetRandomBoolean();            
            projectTypeGeneration.SetPropertyValue("ToBeGenerated", valueForToBeGenerated);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerationSettingsID, projectTypeGeneration.GenerationSettingsID);
            Assert.AreEqual(valueForProjectTypeID, projectTypeGeneration.ProjectTypeID);
            Assert.AreEqual(valueForProjectName, projectTypeGeneration.ProjectName);
            Assert.AreEqual(valueForToBeGenerated, projectTypeGeneration.ToBeGenerated);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectTypeGeneration.GenerationSettingsID = null;
            projectTypeGeneration.ProjectName = null;
            projectTypeGeneration.ToBeGenerated = null;
            projectTypeGeneration.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ProjectTypeGeneration retrievedProjectTypeGeneration =
                    Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
            
            Assert.IsNull(retrievedProjectTypeGeneration.GenerationSettingsID);
            Assert.IsNull(retrievedProjectTypeGeneration.ProjectName);
            Assert.IsNull(retrievedProjectTypeGeneration.ToBeGenerated);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateUnsavedValidProjectTypeGeneration();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            projectTypeGeneration.ProjectTypeGenerationID = null;
            projectTypeGeneration.ProjectTypeID = null;
            
            try
            {
                projectTypeGeneration.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Project Type Generation' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Project Type ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<ProjectTypeGeneration>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["ProjectTypeGenerationID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["GenerationSettingsID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ProjectTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ToBeGenerated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_GenerationSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();

            GenerationSettings boForRelationshipGenerationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();
            projectTypeGeneration.GenerationSettings = boForRelationshipGenerationSettings;
            projectTypeGeneration.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            GenerationSettings loadedRelatedBO = Broker.GetBusinessObject<GenerationSettings>(boForRelationshipGenerationSettings.ID);
            ProjectTypeGeneration loadedProjectTypeGeneration = Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipGenerationSettings, loadedProjectTypeGeneration.GenerationSettings);
            Assert.AreEqual(loadedRelatedBO, loadedProjectTypeGeneration.GenerationSettings);
            Assert.AreEqual(loadedRelatedBO, projectTypeGeneration.GenerationSettings);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();

            ProjectType boForRelationshipProjectType = TestUtilsProjectType.CreateSavedProjectType();
            projectTypeGeneration.ProjectType = boForRelationshipProjectType;
            projectTypeGeneration.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            ProjectType loadedRelatedBO = Broker.GetBusinessObject<ProjectType>(boForRelationshipProjectType.ID);
            ProjectTypeGeneration loadedProjectTypeGeneration = Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipProjectType, loadedProjectTypeGeneration.ProjectType);
            Assert.AreEqual(loadedRelatedBO, loadedProjectTypeGeneration.ProjectType);
            Assert.AreEqual(loadedRelatedBO, projectTypeGeneration.ProjectType);
        }
        
        
        
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_GenerationSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();

            GenerationSettings boForRelationshipGenerationSettings = TestUtilsGenerationSettings.CreateSavedGenerationSettings();
            projectTypeGeneration.GenerationSettings = boForRelationshipGenerationSettings;
            projectTypeGeneration.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<ProjectTypeGeneration>().RelationshipDefCol["GenerationSettings"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            projectTypeGeneration.MarkForDelete();
            projectTypeGeneration.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: ProjectTypeGeneration"));
            }            
            
            GenerationSettings relatedBO = Broker.GetBusinessObject<GenerationSettings>(boForRelationshipGenerationSettings.ID);
            Assert.AreEqual(relatedBO,boForRelationshipGenerationSettings);
            
        }
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_ProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ProjectTypeGeneration projectTypeGeneration = TestUtilsProjectTypeGeneration.CreateSavedProjectTypeGeneration();

            ProjectType boForRelationshipProjectType = TestUtilsProjectType.CreateSavedProjectType();
            projectTypeGeneration.ProjectType = boForRelationshipProjectType;
            projectTypeGeneration.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<ProjectTypeGeneration>().RelationshipDefCol["ProjectType"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            projectTypeGeneration.MarkForDelete();
            projectTypeGeneration.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<ProjectTypeGeneration>(projectTypeGeneration.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: ProjectTypeGeneration"));
            }            
            
            ProjectType relatedBO = Broker.GetBusinessObject<ProjectType>(boForRelationshipProjectType.ID);
            Assert.AreEqual(relatedBO,boForRelationshipProjectType);
            
        }
       
    }
}
