// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests SolutionTypeProject objects
    [TestFixture]
    public partial class TestSolutionTypeProject : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateSolutionTypeProjectWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SolutionTypeProject solutionTypeProject = new SolutionTypeProject();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(solutionTypeProject.SolutionTypeProjectID);
            Assert.IsInstanceOf(solutionTypeProject.Props["SolutionTypeProjectID"].PropertyType, solutionTypeProject.SolutionTypeProjectID);
                        Assert.IsNull(solutionTypeProject.SolutionTypeID);
                        Assert.IsNull(solutionTypeProject.ProjectTypeID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveSolutionTypeProject()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();

            //---------------Assert Precondition----------------
            Assert.IsTrue(solutionTypeProject.Status.IsNew);
            BusinessObjectCollection<SolutionTypeProject> col = new BusinessObjectCollection<SolutionTypeProject>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            solutionTypeProject.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(solutionTypeProject.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadSolutionTypeProject()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();

            //---------------Execute Test ----------------------
            SolutionTypeProject loadedSolutionTypeProject = Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(solutionTypeProject.SolutionTypeProjectID, loadedSolutionTypeProject.SolutionTypeProjectID);
                        Assert.AreEqual(solutionTypeProject.SolutionTypeID, loadedSolutionTypeProject.SolutionTypeID);
                        Assert.AreEqual(solutionTypeProject.ProjectTypeID, loadedSolutionTypeProject.ProjectTypeID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteSolutionTypeProject()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionTypeProject.MarkForDelete();
            solutionTypeProject.Save();
            //---------------Test Result -----------------------
            try
            {
                SolutionTypeProject retrievedSolutionTypeProject = Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: SolutionTypeProject", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateSolutionTypeProject()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionTypeID = TestUtilsSolutionType.CreateSavedSolutionType().SolutionTypeID;
            solutionTypeProject.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            solutionTypeProject.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            solutionTypeProject.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            SolutionTypeProject retrievedSolutionTypeProject =
                    Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
            
            Assert.AreEqual(valueForSolutionTypeID, retrievedSolutionTypeProject.SolutionTypeID);
            Assert.AreEqual(valueForProjectTypeID, retrievedSolutionTypeProject.ProjectTypeID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = new SolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionTypeID = TestUtilsSolutionType.CreateSavedSolutionType().SolutionTypeID;
            solutionTypeProject.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            solutionTypeProject.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionTypeID, solutionTypeProject.SolutionTypeID);
            Assert.AreEqual(valueForProjectTypeID, solutionTypeProject.ProjectTypeID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = new SolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionTypeID = TestUtilsSolutionType.CreateSavedSolutionType().SolutionTypeID;
            solutionTypeProject.SolutionTypeID = (System.Guid) valueForSolutionTypeID;
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;
            solutionTypeProject.ProjectTypeID = (System.Guid) valueForProjectTypeID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionTypeID, solutionTypeProject.GetPropertyValue("SolutionTypeID"));
            Assert.AreEqual(valueForProjectTypeID, solutionTypeProject.GetPropertyValue("ProjectTypeID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = new SolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionTypeID = TestUtilsSolutionType.CreateSavedSolutionType().SolutionTypeID;            
            solutionTypeProject.SetPropertyValue("SolutionTypeID", valueForSolutionTypeID);
            object valueForProjectTypeID = TestUtilsProjectType.CreateSavedProjectType().ProjectTypeID;            
            solutionTypeProject.SetPropertyValue("ProjectTypeID", valueForProjectTypeID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionTypeID, solutionTypeProject.SolutionTypeID);
            Assert.AreEqual(valueForProjectTypeID, solutionTypeProject.ProjectTypeID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionTypeProject.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            SolutionTypeProject retrievedSolutionTypeProject =
                    Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionTypeProject.SolutionTypeProjectID = null;
            solutionTypeProject.SolutionTypeID = null;
            solutionTypeProject.ProjectTypeID = null;
            
            try
            {
                solutionTypeProject.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Solution Type Project ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Solution Type ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Project Type ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<SolutionTypeProject>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["SolutionTypeProjectID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ProjectTypeID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();

            ProjectType boForRelationshipProjectType = TestUtilsProjectType.CreateSavedProjectType();
            solutionTypeProject.ProjectType = boForRelationshipProjectType;
            solutionTypeProject.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            ProjectType loadedRelatedBO = Broker.GetBusinessObject<ProjectType>(boForRelationshipProjectType.ID);
            SolutionTypeProject loadedSolutionTypeProject = Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipProjectType, loadedSolutionTypeProject.ProjectType);
            Assert.AreEqual(loadedRelatedBO, loadedSolutionTypeProject.ProjectType);
            Assert.AreEqual(loadedRelatedBO, solutionTypeProject.ProjectType);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_SolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();

            SolutionType boForRelationshipSolutionType = TestUtilsSolutionType.CreateSavedSolutionType();
            solutionTypeProject.SolutionType = boForRelationshipSolutionType;
            solutionTypeProject.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            SolutionType loadedRelatedBO = Broker.GetBusinessObject<SolutionType>(boForRelationshipSolutionType.ID);
            SolutionTypeProject loadedSolutionTypeProject = Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolutionType, loadedSolutionTypeProject.SolutionType);
            Assert.AreEqual(loadedRelatedBO, loadedSolutionTypeProject.SolutionType);
            Assert.AreEqual(loadedRelatedBO, solutionTypeProject.SolutionType);
        }
        
        
        
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_ProjectType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();

            ProjectType boForRelationshipProjectType = TestUtilsProjectType.CreateSavedProjectType();
            solutionTypeProject.ProjectType = boForRelationshipProjectType;
            solutionTypeProject.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<SolutionTypeProject>().RelationshipDefCol["ProjectType"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            solutionTypeProject.MarkForDelete();
            solutionTypeProject.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: SolutionTypeProject"));
            }            
            
            ProjectType relatedBO = Broker.GetBusinessObject<ProjectType>(boForRelationshipProjectType.ID);
            Assert.AreEqual(relatedBO,boForRelationshipProjectType);
            
        }
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_SolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionTypeProject solutionTypeProject = TestUtilsSolutionTypeProject.CreateSavedSolutionTypeProject();

            SolutionType boForRelationshipSolutionType = TestUtilsSolutionType.CreateSavedSolutionType();
            solutionTypeProject.SolutionType = boForRelationshipSolutionType;
            solutionTypeProject.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<SolutionTypeProject>().RelationshipDefCol["SolutionType"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            solutionTypeProject.MarkForDelete();
            solutionTypeProject.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<SolutionTypeProject>(solutionTypeProject.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: SolutionTypeProject"));
            }            
            
            SolutionType relatedBO = Broker.GetBusinessObject<SolutionType>(boForRelationshipSolutionType.ID);
            Assert.AreEqual(relatedBO,boForRelationshipSolutionType);
            
        }
       
    }
}
