// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    

    // Provides the part of the test class that tests TransactionLogEntry objects
    [TestFixture]
    public partial class TestTransactionLogEntry : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateTransactionLogWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            TransactionLogEntry transactionLogEntry = new TransactionLogEntry();

            //---------------Test Result -----------------------
                        Assert.IsNull(transactionLogEntry.TransactionSequenceNo);
                        Assert.IsNull(transactionLogEntry.DateTimeUpdated);
                        Assert.IsNull(transactionLogEntry.WindowsUser);
                        Assert.IsNull(transactionLogEntry.LogonUser);
                        Assert.IsNull(transactionLogEntry.MachineName);
                        Assert.IsNull(transactionLogEntry.BusinessObjectTypeName);
                        Assert.IsNull(transactionLogEntry.CRUDAction);
                        Assert.IsNull(transactionLogEntry.DirtyXML);
                        Assert.IsNull(transactionLogEntry.BusinessObjectToString);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveTransactionLog()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateUnsavedValidTransactionLogEntry();

            //---------------Assert Precondition----------------
            Assert.IsTrue(transactionLogEntry.Status.IsNew);
            BusinessObjectCollection<TransactionLogEntry> col = new BusinessObjectCollection<TransactionLogEntry>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            transactionLogEntry.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(transactionLogEntry.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadTransactionLog()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateSavedTransactionLogEntry();

            //---------------Execute Test ----------------------
            TransactionLogEntry loadedTransactionLogEntry = Broker.GetBusinessObject<TransactionLogEntry>(transactionLogEntry.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(transactionLogEntry.TransactionSequenceNo, loadedTransactionLogEntry.TransactionSequenceNo);
                        Assert.AreEqual(transactionLogEntry.DateTimeUpdated, loadedTransactionLogEntry.DateTimeUpdated);
                        Assert.AreEqual(transactionLogEntry.WindowsUser, loadedTransactionLogEntry.WindowsUser);
                        Assert.AreEqual(transactionLogEntry.LogonUser, loadedTransactionLogEntry.LogonUser);
                        Assert.AreEqual(transactionLogEntry.MachineName, loadedTransactionLogEntry.MachineName);
                        Assert.AreEqual(transactionLogEntry.BusinessObjectTypeName, loadedTransactionLogEntry.BusinessObjectTypeName);
                        Assert.AreEqual(transactionLogEntry.CRUDAction, loadedTransactionLogEntry.CRUDAction);
                        Assert.AreEqual(transactionLogEntry.DirtyXML, loadedTransactionLogEntry.DirtyXML);
                        Assert.AreEqual(transactionLogEntry.BusinessObjectToString, loadedTransactionLogEntry.BusinessObjectToString);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteTransactionLog()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateSavedTransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            transactionLogEntry.MarkForDelete();
            transactionLogEntry.Save();
            //---------------Test Result -----------------------
            try
            {
                TransactionLogEntry retrievedTransactionLogEntry = Broker.GetBusinessObject<TransactionLogEntry>(transactionLogEntry.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: TransactionLogEntry", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateTransactionLog()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateSavedTransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTransactionSequenceNo = TestUtilsShared.GetRandomInt();
            transactionLogEntry.TransactionSequenceNo = (System.Int32) valueForTransactionSequenceNo;
            object valueForDateTimeUpdated = TestUtilsShared.GetRandomDate();
            transactionLogEntry.DateTimeUpdated = (System.DateTime) valueForDateTimeUpdated;
            object valueForWindowsUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.WindowsUser = (System.String) valueForWindowsUser;
            object valueForLogonUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.LogonUser = (System.String) valueForLogonUser;
            object valueForMachineName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.MachineName = (System.String) valueForMachineName;
            object valueForBusinessObjectTypeName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectTypeName = (System.String) valueForBusinessObjectTypeName;
            object valueForCRUDAction = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.CRUDAction = (System.String) valueForCRUDAction;
            object valueForDirtyXML = null;
            transactionLogEntry.DirtyXML = (Habanero.Util.LongText) valueForDirtyXML;
            object valueForBusinessObjectToString = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectToString = (System.String) valueForBusinessObjectToString;
            transactionLogEntry.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            TransactionLogEntry retrievedTransactionLogEntry =
                    Broker.GetBusinessObject<TransactionLogEntry>(transactionLogEntry.ID);
            
            Assert.AreEqual(valueForTransactionSequenceNo, retrievedTransactionLogEntry.TransactionSequenceNo);
            Assert.AreEqual(valueForDateTimeUpdated, retrievedTransactionLogEntry.DateTimeUpdated);
            Assert.AreEqual(valueForWindowsUser, retrievedTransactionLogEntry.WindowsUser);
            Assert.AreEqual(valueForLogonUser, retrievedTransactionLogEntry.LogonUser);
            Assert.AreEqual(valueForMachineName, retrievedTransactionLogEntry.MachineName);
            Assert.AreEqual(valueForBusinessObjectTypeName, retrievedTransactionLogEntry.BusinessObjectTypeName);
            Assert.AreEqual(valueForCRUDAction, retrievedTransactionLogEntry.CRUDAction);
            Assert.AreEqual(valueForDirtyXML, retrievedTransactionLogEntry.DirtyXML);
            Assert.AreEqual(valueForBusinessObjectToString, retrievedTransactionLogEntry.BusinessObjectToString);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = new TransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTransactionSequenceNo = TestUtilsShared.GetRandomInt();
            transactionLogEntry.TransactionSequenceNo = (System.Int32) valueForTransactionSequenceNo;
            object valueForDateTimeUpdated = TestUtilsShared.GetRandomDate();
            transactionLogEntry.DateTimeUpdated = (System.DateTime) valueForDateTimeUpdated;
            object valueForWindowsUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.WindowsUser = (System.String) valueForWindowsUser;
            object valueForLogonUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.LogonUser = (System.String) valueForLogonUser;
            object valueForMachineName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.MachineName = (System.String) valueForMachineName;
            object valueForBusinessObjectTypeName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectTypeName = (System.String) valueForBusinessObjectTypeName;
            object valueForCRUDAction = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.CRUDAction = (System.String) valueForCRUDAction;
            object valueForDirtyXML = null;
            transactionLogEntry.DirtyXML = (Habanero.Util.LongText) valueForDirtyXML;
            object valueForBusinessObjectToString = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectToString = (System.String) valueForBusinessObjectToString;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTransactionSequenceNo, transactionLogEntry.TransactionSequenceNo);
            Assert.AreEqual(valueForDateTimeUpdated, transactionLogEntry.DateTimeUpdated);
            Assert.AreEqual(valueForWindowsUser, transactionLogEntry.WindowsUser);
            Assert.AreEqual(valueForLogonUser, transactionLogEntry.LogonUser);
            Assert.AreEqual(valueForMachineName, transactionLogEntry.MachineName);
            Assert.AreEqual(valueForBusinessObjectTypeName, transactionLogEntry.BusinessObjectTypeName);
            Assert.AreEqual(valueForCRUDAction, transactionLogEntry.CRUDAction);
            Assert.AreEqual(valueForDirtyXML, transactionLogEntry.DirtyXML);
            Assert.AreEqual(valueForBusinessObjectToString, transactionLogEntry.BusinessObjectToString);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = new TransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTransactionSequenceNo = TestUtilsShared.GetRandomInt();
            transactionLogEntry.TransactionSequenceNo = (System.Int32) valueForTransactionSequenceNo;
            object valueForDateTimeUpdated = TestUtilsShared.GetRandomDate();
            transactionLogEntry.DateTimeUpdated = (System.DateTime) valueForDateTimeUpdated;
            object valueForWindowsUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.WindowsUser = (System.String) valueForWindowsUser;
            object valueForLogonUser = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.LogonUser = (System.String) valueForLogonUser;
            object valueForMachineName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.MachineName = (System.String) valueForMachineName;
            object valueForBusinessObjectTypeName = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectTypeName = (System.String) valueForBusinessObjectTypeName;
            object valueForCRUDAction = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.CRUDAction = (System.String) valueForCRUDAction;
            object valueForDirtyXML = null;
            transactionLogEntry.DirtyXML = (Habanero.Util.LongText) valueForDirtyXML;
            object valueForBusinessObjectToString = TestUtilsShared.GetRandomString(255);
            transactionLogEntry.BusinessObjectToString = (System.String) valueForBusinessObjectToString;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTransactionSequenceNo, transactionLogEntry.GetPropertyValue("TransactionSequenceNo"));
            Assert.AreEqual(valueForDateTimeUpdated, transactionLogEntry.GetPropertyValue("DateTimeUpdated"));
            Assert.AreEqual(valueForWindowsUser, transactionLogEntry.GetPropertyValue("WindowsUser"));
            Assert.AreEqual(valueForLogonUser, transactionLogEntry.GetPropertyValue("LogonUser"));
            Assert.AreEqual(valueForMachineName, transactionLogEntry.GetPropertyValue("MachineName"));
            Assert.AreEqual(valueForBusinessObjectTypeName, transactionLogEntry.GetPropertyValue("BusinessObjectTypeName"));
            Assert.AreEqual(valueForCRUDAction, transactionLogEntry.GetPropertyValue("CRUDAction"));
            Assert.AreEqual(valueForDirtyXML, transactionLogEntry.GetPropertyValue("DirtyXML"));
            Assert.AreEqual(valueForBusinessObjectToString, transactionLogEntry.GetPropertyValue("BusinessObjectToString"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = new TransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForTransactionSequenceNo = TestUtilsShared.GetRandomInt();            
            transactionLogEntry.SetPropertyValue("TransactionSequenceNo", valueForTransactionSequenceNo);
            object valueForDateTimeUpdated = TestUtilsShared.GetRandomDate();            
            transactionLogEntry.SetPropertyValue("DateTimeUpdated", valueForDateTimeUpdated);
            object valueForWindowsUser = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("WindowsUser", valueForWindowsUser);
            object valueForLogonUser = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("LogonUser", valueForLogonUser);
            object valueForMachineName = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("MachineName", valueForMachineName);
            object valueForBusinessObjectTypeName = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("BusinessObjectTypeName", valueForBusinessObjectTypeName);
            object valueForCRUDAction = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("CRUDAction", valueForCRUDAction);
            object valueForDirtyXML = null;            
            transactionLogEntry.SetPropertyValue("DirtyXML", valueForDirtyXML);
            object valueForBusinessObjectToString = TestUtilsShared.GetRandomString(255);            
            transactionLogEntry.SetPropertyValue("BusinessObjectToString", valueForBusinessObjectToString);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForTransactionSequenceNo, transactionLogEntry.TransactionSequenceNo);
            Assert.AreEqual(valueForDateTimeUpdated, transactionLogEntry.DateTimeUpdated);
            Assert.AreEqual(valueForWindowsUser, transactionLogEntry.WindowsUser);
            Assert.AreEqual(valueForLogonUser, transactionLogEntry.LogonUser);
            Assert.AreEqual(valueForMachineName, transactionLogEntry.MachineName);
            Assert.AreEqual(valueForBusinessObjectTypeName, transactionLogEntry.BusinessObjectTypeName);
            Assert.AreEqual(valueForCRUDAction, transactionLogEntry.CRUDAction);
            Assert.AreEqual(valueForDirtyXML, transactionLogEntry.DirtyXML);
            Assert.AreEqual(valueForBusinessObjectToString, transactionLogEntry.BusinessObjectToString);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateSavedTransactionLogEntry();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            transactionLogEntry.DateTimeUpdated = null;
            transactionLogEntry.WindowsUser = null;
            transactionLogEntry.LogonUser = null;
            transactionLogEntry.MachineName = null;
            transactionLogEntry.BusinessObjectTypeName = null;
            transactionLogEntry.CRUDAction = null;
            transactionLogEntry.DirtyXML = null;
            transactionLogEntry.BusinessObjectToString = null;
            transactionLogEntry.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            TransactionLogEntry retrievedTransactionLogEntry =
                    Broker.GetBusinessObject<TransactionLogEntry>(transactionLogEntry.ID);
            
            Assert.IsNull(retrievedTransactionLogEntry.DateTimeUpdated);
            Assert.IsNull(retrievedTransactionLogEntry.WindowsUser);
            Assert.IsNull(retrievedTransactionLogEntry.LogonUser);
            Assert.IsNull(retrievedTransactionLogEntry.MachineName);
            Assert.IsNull(retrievedTransactionLogEntry.BusinessObjectTypeName);
            Assert.IsNull(retrievedTransactionLogEntry.CRUDAction);
            Assert.IsNull(retrievedTransactionLogEntry.DirtyXML);
            Assert.IsNull(retrievedTransactionLogEntry.BusinessObjectToString);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateUnsavedValidTransactionLogEntry();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            transactionLogEntry.TransactionSequenceNo = null;
            
            try
            {
                transactionLogEntry.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Transaction Sequence No' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<TransactionLogEntry>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TransactionSequenceNo"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DateTimeUpdated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["WindowsUser"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LogonUser"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MachineName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BusinessObjectTypeName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["CRUDAction"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DirtyXML"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BusinessObjectToString"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            TransactionLogEntry transactionLogEntry = TestUtilsTransactionLogEntry.CreateSavedTransactionLogEntry();
            
            //---------------Execute Test ----------------------
            TransactionLogEntry transactionLogEntryDuplicate = TestUtilsTransactionLogEntry.CreateUnsavedValidTransactionLogEntry();
            transactionLogEntryDuplicate.TransactionSequenceNo = transactionLogEntry.TransactionSequenceNo;
            try
            {
                transactionLogEntryDuplicate.Save();
                Assert.Fail("Should raise err");
            }
                //---------------Test Result -----------------------
            catch (BusObjDuplicateConcurrencyControlException ex)
            {
                StringAssert.Contains("A 'TransactionLogEntry' already exists with the same identifier:", ex.Message);
            }
        }
        
        
        
        
        
        
        
        
        
       
    }
}
