// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample UIControlMapperType objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public partial class TestUtilsUIControlMapperType
    {
        /// <summary>
        /// Creates a new saved UIControlMapperType with a random value assigned to every property
        /// </summary>
        public static UIControlMapperType CreateSavedUIControlMapperType()
		{
		    UIControlMapperType uIControlMapperType = CreateUnsavedValidUIControlMapperType();
			uIControlMapperType.Save();
			return uIControlMapperType;
		}

        /// <summary>
        /// Creates a new unsaved UIControlMapperType with a random value assigned to every property
        /// </summary>
		public static UIControlMapperType CreateUnsavedValidUIControlMapperType()
		{
			UIControlMapperType uIControlMapperType = new UIControlMapperType();
			uIControlMapperType.AssemblyName = TestUtilsShared.GetRandomString();
			uIControlMapperType.TypeName = TestUtilsShared.GetRandomString();
            uIControlMapperType.SolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
			return uIControlMapperType;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIControlMapperType where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIControlMapperType CreateUnsavedDefaultUIControlMapperType()
		{
			UIControlMapperType uIControlMapperType = new UIControlMapperType();
			return uIControlMapperType;
		}
    }
    
    // Provides the part of the test class that tests UIControlMapperType objects
    [TestFixture]
    public partial class TestUIControlMapperType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIControlMapperTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIControlMapperType uIControlMapperType = new UIControlMapperType();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIControlMapperType.UIControlMapperTypeID);
            Assert.IsInstanceOf(uIControlMapperType.Props["UIControlMapperTypeID"].PropertyType, uIControlMapperType.UIControlMapperTypeID);
                        Assert.IsNull(uIControlMapperType.AssemblyName);
                        Assert.IsNull(uIControlMapperType.TypeName);
                        Assert.IsNull(uIControlMapperType.SolutionID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIControlMapperType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateUnsavedValidUIControlMapperType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIControlMapperType.Status.IsNew);
            BusinessObjectCollection<UIControlMapperType> col = new BusinessObjectCollection<UIControlMapperType>();
            col.LoadAll();
            Assert.AreEqual(2, col.Count);

            //---------------Execute Test ----------------------
            uIControlMapperType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIControlMapperType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(3, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIControlMapperType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();

            //---------------Execute Test ----------------------
            UIControlMapperType loadedUIControlMapperType = Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIControlMapperType.UIControlMapperTypeID, loadedUIControlMapperType.UIControlMapperTypeID);
                        Assert.AreEqual(uIControlMapperType.AssemblyName, loadedUIControlMapperType.AssemblyName);
                        Assert.AreEqual(uIControlMapperType.TypeName, loadedUIControlMapperType.TypeName);
                        Assert.AreEqual(uIControlMapperType.SolutionID, loadedUIControlMapperType.SolutionID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIControlMapperType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlMapperType.MarkForDelete();
            uIControlMapperType.Save();
            //---------------Test Result -----------------------
            try
            {
                UIControlMapperType retrievedUIControlMapperType = Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIControlMapperType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIControlMapperType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlMapperType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlMapperType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlMapperType.SolutionID = (System.Guid) valueForSolutionID;
            uIControlMapperType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIControlMapperType retrievedUIControlMapperType =
                    Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);
            
            Assert.AreEqual(valueForAssemblyName, retrievedUIControlMapperType.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedUIControlMapperType.TypeName);
            Assert.AreEqual(valueForSolutionID, retrievedUIControlMapperType.SolutionID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = new UIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlMapperType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlMapperType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlMapperType.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlMapperType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIControlMapperType.TypeName);
            Assert.AreEqual(valueForSolutionID, uIControlMapperType.SolutionID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = new UIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlMapperType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlMapperType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlMapperType.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlMapperType.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, uIControlMapperType.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForSolutionID, uIControlMapperType.GetPropertyValue("SolutionID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = new UIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();            
            uIControlMapperType.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtilsShared.GetRandomString();            
            uIControlMapperType.SetPropertyValue("TypeName", valueForTypeName);
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;            
            uIControlMapperType.SetPropertyValue("SolutionID", valueForSolutionID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlMapperType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIControlMapperType.TypeName);
            Assert.AreEqual(valueForSolutionID, uIControlMapperType.SolutionID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlMapperType.AssemblyName = null;
            uIControlMapperType.TypeName = null;
            uIControlMapperType.SolutionID = null;
            uIControlMapperType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIControlMapperType retrievedUIControlMapperType =
                    Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);
            
            Assert.IsNull(retrievedUIControlMapperType.AssemblyName);
            Assert.IsNull(retrievedUIControlMapperType.TypeName);
            Assert.IsNull(retrievedUIControlMapperType.SolutionID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateUnsavedValidUIControlMapperType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlMapperType.UIControlMapperTypeID = null;
            
            try
            {
                uIControlMapperType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Control Mapper Type ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIControlMapperType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIControlMapperTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();
            DMSolution solution = uIControlMapperType.Solution;
            //DMSolution boForRelationshipSolution = TestUtilsShared.CreateSavedDMSolution();
            //uIControlMapperType.Solution = boForRelationshipSolution;
            //uIControlMapperType.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMSolution loadedRelatedBO = Broker.GetBusinessObject<DMSolution>(solution.ID);
            UIControlMapperType loadedUIControlMapperType = Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(solution, loadedUIControlMapperType.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedUIControlMapperType.Solution);
            Assert.AreEqual(loadedRelatedBO, uIControlMapperType.Solution);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();

            UIField boForRelationshipUIFields = TestUtilsUIField.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIControlMapperTypeID = uIControlMapperType.UIControlMapperTypeID;
            boForRelationshipUIFields.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIControlMapperType.UIFields.Count);
            //---------------Execute Test ----------------------
            UIField loadedRelatedBO = Broker.GetBusinessObject<UIField>(boForRelationshipUIFields.ID);
            UIControlMapperType loadedUIControlMapperType = Broker.GetBusinessObject<UIControlMapperType>(uIControlMapperType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIControlMapperType.UIFields.Count);
            Assert.AreEqual(boForRelationshipUIFields, loadedUIControlMapperType.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIControlMapperType.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, uIControlMapperType.UIFields[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlMapperType uIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();

            UIField boForRelationshipUIFields = TestUtilsUIField.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIControlMapperTypeID = uIControlMapperType.UIControlMapperTypeID;
            boForRelationshipUIFields.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIControlMapperType.UIFields.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIControlMapperType>().RelationshipDefCol["UIFields"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                uIControlMapperType.MarkForDelete();
                //uIControlMapperType.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("You cannot delete the 'UIControlMapperType', as the IsDeletable is set to false for the object"));
            Assert.IsTrue(expectedException.Message.Contains("since it is related to 1 Business Objects via the UIFields relationship"));
        }
        
        
        
        
        
       
    }
}
