// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIControlType objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests UIControlType objects
    [TestFixture]
    public partial class TestUIControlType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIControlTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIControlType uIControlType = new UIControlType();

            //---------------Test Result -----------------------
                        Assert.IsNull(uIControlType.AssemblyName);
                        Assert.IsNull(uIControlType.TypeName);
                        Assert.IsNotNull(uIControlType.UIControlTypeID);
            Assert.IsInstanceOf(uIControlType.Props["UIControlTypeID"].PropertyType, uIControlType.UIControlTypeID);
                        Assert.IsNull(uIControlType.SolutionID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateUnsavedValidUIControlType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIControlType.Status.IsNew);
            BusinessObjectCollection<UIControlType> col = new BusinessObjectCollection<UIControlType>();
            col.LoadAll();
            Assert.AreEqual(4, col.Count);

            //---------------Execute Test ----------------------
            uIControlType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIControlType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(5, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();

            //---------------Execute Test ----------------------
            UIControlType loadedUIControlType = Broker.GetBusinessObject<UIControlType>(uIControlType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIControlType.AssemblyName, loadedUIControlType.AssemblyName);
                        Assert.AreEqual(uIControlType.TypeName, loadedUIControlType.TypeName);
                        Assert.AreEqual(uIControlType.UIControlTypeID, loadedUIControlType.UIControlTypeID);
                        Assert.AreEqual(uIControlType.SolutionID, loadedUIControlType.SolutionID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlType.MarkForDelete();
            uIControlType.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIControlType>(uIControlType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIControlType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlType.SolutionID = (System.Guid) valueForSolutionID;
            uIControlType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIControlType retrievedUIControlType =
                    Broker.GetBusinessObject<UIControlType>(uIControlType.ID);
            
            Assert.AreEqual(valueForAssemblyName, retrievedUIControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedUIControlType.TypeName);
            Assert.AreEqual(valueForSolutionID, retrievedUIControlType.SolutionID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = new UIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlType.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIControlType.TypeName);
            Assert.AreEqual(valueForSolutionID, uIControlType.SolutionID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = new UIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uIControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uIControlType.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uIControlType.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlType.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, uIControlType.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForSolutionID, uIControlType.GetPropertyValue("SolutionID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = new UIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();            
            uIControlType.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtilsShared.GetRandomString();            
            uIControlType.SetPropertyValue("TypeName", valueForTypeName);
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;            
            uIControlType.SetPropertyValue("SolutionID", valueForSolutionID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIControlType.TypeName);
            Assert.AreEqual(valueForSolutionID, uIControlType.SolutionID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            Broker.GetBusinessObject<UIControlType>(uIControlType.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlType uIControlType = TestUtilsUIControlType.CreateUnsavedValidUIControlType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIControlType.AssemblyName = null;
            uIControlType.TypeName = null;
            uIControlType.UIControlTypeID = null;
            uIControlType.SolutionID = null;
            
            try
            {
                uIControlType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Assembly Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Type Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI Control Type ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Solution' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIControlType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["UIControlTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
        }
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();

            DMSolution boForRelationshipSolution = TestUtilsShared.CreateSavedDMSolution();
            uIControlType.Solution = boForRelationshipSolution;
            uIControlType.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMSolution loadedRelatedBO = Broker.GetBusinessObject<DMSolution>(boForRelationshipSolution.ID);
            UIControlType loadedUIControlType = Broker.GetBusinessObject<UIControlType>(uIControlType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedUIControlType.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedUIControlType.Solution);
            Assert.AreEqual(loadedRelatedBO, uIControlType.Solution);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();

            UIField boForRelationshipUIFields = TestUtilsUIField.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIControlTypeID = uIControlType.UIControlTypeID;
            boForRelationshipUIFields.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIControlType.UIFields.Count);
            //---------------Execute Test ----------------------
            UIField loadedRelatedBO = Broker.GetBusinessObject<UIField>(boForRelationshipUIFields.ID);
            UIControlType loadedUIControlType = Broker.GetBusinessObject<UIControlType>(uIControlType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIControlType.UIFields.Count);
            Assert.AreEqual(boForRelationshipUIFields, loadedUIControlType.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIControlType.UIFields[0]);
            Assert.AreEqual(loadedRelatedBO, uIControlType.UIFields[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UIFields()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIControlType uIControlType = TestUtilsUIControlType.CreateSavedUIControlType();

            UIField boForRelationshipUIFields = TestUtilsUIField.CreateUnsavedValidUIField();
            boForRelationshipUIFields.UIControlTypeID = uIControlType.UIControlTypeID;
            boForRelationshipUIFields.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIControlType.UIFields.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIControlType>().RelationshipDefCol["UIFields"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                uIControlType.MarkForDelete();
            }
            //---------------Test Result -----------------------
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("You cannot delete the 'UIControlType', as the IsDeletable is set to false"));
            Assert.IsTrue(expectedException.Message.Contains("since it is related to 1 Business Objects via the UIFields relationship"));
        }
        // ReSharper restore RedundantNameQualifier       
    }
}
