// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIField objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests UIField objects
    [TestFixture]
    public partial class TestUIField : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIFieldWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIField uIField = new UIField();

            //---------------Test Result -----------------------
            Assert.IsNotNull(uIField.UIFieldID);
            Assert.IsInstanceOf(uIField.Props["UIFieldID"].PropertyType, uIField.UIFieldID);
            Assert.IsNull(uIField.LabelText);
            Assert.IsNull(uIField.PropertyName);
            Assert.IsNull(uIField.UIControlTypeID);
            Assert.IsNull(uIField.UIControlMapperTypeID);
            Assert.IsNotNull(uIField.Editable);
            Assert.IsInstanceOf(uIField.Props["Editable"].PropertyType, uIField.Editable);
            Assert.IsNull(uIField.ToolTipText);
            Assert.IsNotNull(uIField.Generated);
            Assert.IsInstanceOf(uIField.Props["Generated"].PropertyType, uIField.Generated);
            Assert.IsNull(uIField.UIColumnLayoutID);
            Assert.AreEqual("Label", uIField.Layout);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIField()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateUnsavedValidUIField();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIField.Status.IsNew);
            BusinessObjectCollection<UIField> col = new BusinessObjectCollection<UIField>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIField.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIField.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIField()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            //---------------Execute Test ----------------------
            UIField loadedUIField = Broker.GetBusinessObject<UIField>(uIField.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(uIField.UIFieldID, loadedUIField.UIFieldID);
            Assert.AreEqual(uIField.LabelText, loadedUIField.LabelText);
            Assert.AreEqual(uIField.PropertyName, loadedUIField.PropertyName);
            Assert.AreEqual(uIField.UIControlTypeID, loadedUIField.UIControlTypeID);
            Assert.AreEqual(uIField.UIControlMapperTypeID, loadedUIField.UIControlMapperTypeID);
            Assert.AreEqual(uIField.Editable, loadedUIField.Editable);
            Assert.AreEqual(uIField.ToolTipText, loadedUIField.ToolTipText);
            Assert.AreEqual(uIField.Generated, loadedUIField.Generated);
            Assert.AreEqual(uIField.UIColumnLayoutID, loadedUIField.UIColumnLayoutID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIField()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateSavedUIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIField.MarkForDelete();
            uIField.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIField>(uIField.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIField", ex.Message);
            }
        }


        [Test]
        public void Test_DeleteUIField_MarksAsDeleted()
        {
            //---------------Set up test pack-------------------
            UIField uiField = TestUtilsUIField.CreateSavedUIField();

            //---------------Assert Precondition----------------
            Assert.IsFalse(uiField.Status.IsNew);
            string message;
            Assert.IsTrue(uiField.IsDeletable(out message));

            //---------------Execute Test ----------------------
            uiField.MarkForDelete();
            uiField.Save();

            //---------------Test Result -----------------------  
            Assert.IsTrue(uiField.Status.IsNew);
            Assert.IsTrue(uiField.Status.IsDeleted);
        }

//        [Test]
//        public void Test_UpdateUIField()
//        {
//            //---------------Set up test pack-------------------
//            UIField uiField = TestUtilsUIField.CreateSavedUIField();
//
//            //---------------Assert Precondition----------------
//            Assert.IsFalse(uiField.Status.IsNew);
//            string message;
//            Assert.IsTrue(uiField.IsEditable(out message));
//
//            //---------------Execute Test ----------------------
//            TestUtils.UpdateUIFieldWithValidData(uiField);
//
//            //---------------Test Result -----------------------
//            Assert.IsFalse(uiField.Status.IsNew);
//        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIField()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateSavedUIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLabel = TestUtilsShared.GetRandomString();
            uIField.LabelText = (System.String) valueForLabel;
            object valueForUIControlTypeID = TestUtilsUIControlType.CreateSavedUIControlType().UIControlTypeID;
            uIField.UIControlTypeID = (System.Guid) valueForUIControlTypeID;
            object valueForUIControlMapperTypeID = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType().UIControlMapperTypeID;
            uIField.UIControlMapperTypeID = (System.Guid) valueForUIControlMapperTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIField.Editable = (System.Boolean) valueForEditable;
            object valueForToolTipText = TestUtilsShared.GetRandomString();
            uIField.ToolTipText = (System.String) valueForToolTipText;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIField.Generated = (System.Boolean) valueForGenerated;
            object valueForUIColumnLayoutID = TestUtilsUIColumnLayout.CreateSavedUIColumnLayout().UIColumnLayoutID;
            uIField.UIColumnLayoutID = (System.Guid) valueForUIColumnLayoutID;
            uIField.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIField retrievedUIField =
                    Broker.GetBusinessObject<UIField>(uIField.ID);
            
            Assert.AreEqual(valueForLabel, retrievedUIField.LabelText);
//            Assert.AreEqual(valueForProperty, retrievedUIField.Property);
            Assert.AreEqual(valueForUIControlTypeID, retrievedUIField.UIControlTypeID);
            Assert.AreEqual(valueForUIControlMapperTypeID, retrievedUIField.UIControlMapperTypeID);
            Assert.AreEqual(valueForEditable, retrievedUIField.Editable);
            Assert.AreEqual(valueForToolTipText, retrievedUIField.ToolTipText);
            Assert.AreEqual(valueForGenerated, retrievedUIField.Generated);
            Assert.AreEqual(valueForUIColumnLayoutID, retrievedUIField.UIColumnLayoutID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = new UIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLabel = TestUtilsShared.GetRandomString();
            uIField.LabelText = (System.String) valueForLabel;
            object valueForUIControlTypeID = TestUtilsUIControlType.CreateSavedUIControlType().UIControlTypeID;
            uIField.UIControlTypeID = (System.Guid) valueForUIControlTypeID;
            object valueForUIControlMapperTypeID = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType().UIControlMapperTypeID;
            uIField.UIControlMapperTypeID = (System.Guid) valueForUIControlMapperTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIField.Editable = (System.Boolean) valueForEditable;
            object valueForToolTipText = TestUtilsShared.GetRandomString();
            uIField.ToolTipText = (System.String) valueForToolTipText;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIField.Generated = (System.Boolean) valueForGenerated;
            object valueForUIColumnLayoutID = TestUtilsUIColumnLayout.CreateSavedUIColumnLayout().UIColumnLayoutID;
            uIField.UIColumnLayoutID = (System.Guid) valueForUIColumnLayoutID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLabel, uIField.LabelText);
            Assert.AreEqual(valueForUIControlTypeID, uIField.UIControlTypeID);
            Assert.AreEqual(valueForUIControlMapperTypeID, uIField.UIControlMapperTypeID);
            Assert.AreEqual(valueForEditable, uIField.Editable);
            Assert.AreEqual(valueForToolTipText, uIField.ToolTipText);
            Assert.AreEqual(valueForGenerated, uIField.Generated);
            Assert.AreEqual(valueForUIColumnLayoutID, uIField.UIColumnLayoutID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = new UIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLabel = TestUtilsShared.GetRandomString();
            uIField.LabelText = (System.String) valueForLabel;
            object valueForUIControlTypeID = TestUtilsUIControlType.CreateSavedUIControlType().UIControlTypeID;
            uIField.UIControlTypeID = (System.Guid) valueForUIControlTypeID;
            object valueForUIControlMapperTypeID = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType().UIControlMapperTypeID;
            uIField.UIControlMapperTypeID = (System.Guid) valueForUIControlMapperTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIField.Editable = (System.Boolean) valueForEditable;
            object valueForToolTipText = TestUtilsShared.GetRandomString();
            uIField.ToolTipText = (System.String) valueForToolTipText;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIField.Generated = (System.Boolean) valueForGenerated;
            object valueForUIColumnLayoutID = TestUtilsUIColumnLayout.CreateSavedUIColumnLayout().UIColumnLayoutID;
            uIField.UIColumnLayoutID = (System.Guid) valueForUIColumnLayoutID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLabel, uIField.GetPropertyValue("LabelText"));
//            Assert.AreEqual(valueForProperty, uIField.GetPropertyValue("Property"));
            Assert.AreEqual(valueForUIControlTypeID, uIField.GetPropertyValue("UIControlTypeID"));
            Assert.AreEqual(valueForUIControlMapperTypeID, uIField.GetPropertyValue("UIControlMapperTypeID"));
            Assert.AreEqual(valueForEditable, uIField.GetPropertyValue("Editable"));
            Assert.AreEqual(valueForToolTipText, uIField.GetPropertyValue("ToolTipText"));
            Assert.AreEqual(valueForGenerated, uIField.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIColumnLayoutID, uIField.GetPropertyValue("UIColumnLayoutID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = new UIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLabel = TestUtilsShared.GetRandomString();            
            uIField.SetPropertyValue("LabelText", valueForLabel);
//            object valueForProperty = TestUtilsShared.GetRandomString();            
//            uIField.SetPropertyValue("Property", valueForProperty);
            object valueForUIControlTypeID = TestUtilsUIControlType.CreateSavedUIControlType().UIControlTypeID;            
            uIField.SetPropertyValue("UIControlTypeID", valueForUIControlTypeID);
            object valueForUIControlMapperTypeID = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType().UIControlMapperTypeID;            
            uIField.SetPropertyValue("UIControlMapperTypeID", valueForUIControlMapperTypeID);
            object valueForEditable = TestUtilsShared.GetRandomBoolean();            
            uIField.SetPropertyValue("Editable", valueForEditable);
            object valueForToolTipText = TestUtilsShared.GetRandomString();            
            uIField.SetPropertyValue("ToolTipText", valueForToolTipText);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIField.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIColumnLayoutID = TestUtilsUIColumnLayout.CreateSavedUIColumnLayout().UIColumnLayoutID;            
            uIField.SetPropertyValue("UIColumnLayoutID", valueForUIColumnLayoutID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLabel, uIField.LabelText);
//            Assert.AreEqual(valueForProperty, uIField.Property);
            Assert.AreEqual(valueForUIControlTypeID, uIField.UIControlTypeID);
            Assert.AreEqual(valueForUIControlMapperTypeID, uIField.UIControlMapperTypeID);
            Assert.AreEqual(valueForEditable, uIField.Editable);
            Assert.AreEqual(valueForToolTipText, uIField.ToolTipText);
            Assert.AreEqual(valueForGenerated, uIField.Generated);
            Assert.AreEqual(valueForUIColumnLayoutID, uIField.UIColumnLayoutID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateSavedUIField();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIField.LabelText = null;
            uIField.UIControlMapperTypeID = null;
            uIField.Editable = null;
            uIField.ToolTipText = null;
            uIField.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIField retrievedUIField =
                    Broker.GetBusinessObject<UIField>(uIField.ID);
            
            Assert.IsNull(retrievedUIField.LabelText);
            Assert.IsNull(retrievedUIField.UIControlMapperTypeID);
            Assert.IsNull(retrievedUIField.Editable);
            Assert.IsNull(retrievedUIField.ToolTipText);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIField uIField = TestUtilsUIField.CreateUnsavedValidUIField();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIField.UIFieldID = null;
            uIField.PropertyName = null;
            uIField.UIControlTypeID = null;
            uIField.Generated = null;
            uIField.UIColumnLayoutID = null;
            uIField.Layout = null;
            
            try
            {
                uIField.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Field ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI Control Type ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI Column Layout ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Layout' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIField>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIFieldID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LabelText"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIControlTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIControlMapperTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Editable"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ToolTipText"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIColumnLayoutID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIColumnLayout()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            UIColumnLayout boForRelationshipUIColumnLayout = TestUtilsUIColumnLayout.CreateSavedUIColumnLayout();
            uIField.UIColumnLayout = boForRelationshipUIColumnLayout;
            uIField.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIColumnLayout loadedRelatedBO = Broker.GetBusinessObject<UIColumnLayout>(boForRelationshipUIColumnLayout.ID);
            UIField loadedUIField = Broker.GetBusinessObject<UIField>(uIField.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIColumnLayout, loadedUIField.UIColumnLayout);
            Assert.AreEqual(loadedRelatedBO, loadedUIField.UIColumnLayout);
            Assert.AreEqual(loadedRelatedBO, uIField.UIColumnLayout);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIControlMapperType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            UIControlMapperType boForRelationshipUIControlMapperType = TestUtilsUIControlMapperType.CreateSavedUIControlMapperType();
            uIField.UIControlMapperType = boForRelationshipUIControlMapperType;
            uIField.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIControlMapperType loadedRelatedBO = Broker.GetBusinessObject<UIControlMapperType>(boForRelationshipUIControlMapperType.ID);
            UIField loadedUIField = Broker.GetBusinessObject<UIField>(uIField.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIControlMapperType, loadedUIField.UIControlMapperType);
            Assert.AreEqual(loadedRelatedBO, loadedUIField.UIControlMapperType);
            Assert.AreEqual(loadedRelatedBO, uIField.UIControlMapperType);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            UIControlType boForRelationshipUIControlType = TestUtilsUIControlType.CreateSavedUIControlType();
            uIField.UIControlType = boForRelationshipUIControlType;
            uIField.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIControlType loadedRelatedBO = Broker.GetBusinessObject<UIControlType>(boForRelationshipUIControlType.ID);
            UIField loadedUIField = Broker.GetBusinessObject<UIField>(uIField.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIControlType, loadedUIField.UIControlType);
            Assert.AreEqual(loadedRelatedBO, loadedUIField.UIControlType);
            Assert.AreEqual(loadedRelatedBO, uIField.UIControlType);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            UIParameter boForRelationshipUIParameters = TestUtilsUIParameter.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIFieldID = uIField.UIFieldID;
            boForRelationshipUIParameters.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIField.UIParameters.Count);
            //---------------Execute Test ----------------------
            UIParameter loadedRelatedBO = Broker.GetBusinessObject<UIParameter>(boForRelationshipUIParameters.ID);
            UIField loadedUIField = Broker.GetBusinessObject<UIField>(uIField.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIField.UIParameters.Count);
            Assert.AreEqual(boForRelationshipUIParameters, loadedUIField.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIField.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, uIField.UIParameters[0]);
        }
        
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIField uIField = TestUtilsUIField.CreateSavedUIField();

            UIParameter boForRelationshipUIParameters = TestUtilsUIParameter.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIFieldID = uIField.UIFieldID;
            boForRelationshipUIParameters.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIField.UIParameters.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIField>().RelationshipDefCol["UIParameters"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIField.MarkForDelete();
            uIField.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIField>(uIField.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIField"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIParameter>(boForRelationshipUIParameters.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIParameter"));
            }
        }
        // ReSharper restore RedundantNameQualifier
    }
}
