// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIFormInfo objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIFormInfo
    {
        /// <summary>
        /// Creates a new saved UIFormInfo with a random value assigned to every property
        /// </summary>
        public static UIFormInfo CreateSavedUIFormInfo()
		{
		    UIFormInfo uIFormInfo = CreateUnsavedValidUIFormInfo();
			uIFormInfo.Save();
			return uIFormInfo;
		}

        /// <summary>
        /// Creates a new unsaved UIFormInfo with a random value assigned to every property
        /// </summary>
		public static UIFormInfo CreateUnsavedValidUIFormInfo()
		{
            UIFormInfo uIFormInfo = CreateUnsavedValidUIFormInfo_WNoUIView();
            uIFormInfo.UIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
			return uIFormInfo;
		}
        /// <summary>
        /// Creates a new unsaved UIFormInfo with a random value assigned to every property
        /// </summary>
		public static UIFormInfo CreateUnsavedValidUIFormInfo_WNoUIView()
		{
			UIFormInfo uIFormInfo = new UIFormInfo();
			uIFormInfo.Width = TestUtilsShared.GetRandomInt();
			uIFormInfo.Height = TestUtilsShared.GetRandomInt();
			uIFormInfo.Title = TestUtilsShared.GetRandomString();
			uIFormInfo.Generated = TestUtilsShared.GetRandomBoolean();
			return uIFormInfo;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIFormInfo where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIFormInfo CreateUnsavedDefaultUIFormInfo()
		{
			UIFormInfo uIFormInfo = new UIFormInfo();
			return uIFormInfo;
		}

    }
    
    // Provides the part of the test class that tests UIFormInfo objects
    [TestFixture]
    public partial class TestUIFormInfo : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }


        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIFormInfoWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIFormInfo uIFormInfo = new UIFormInfo();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIFormInfo.UIFormID);
            Assert.IsInstanceOf(uIFormInfo.Props["UIFormID"].PropertyType, uIFormInfo.UIFormID);
                        Assert.IsNotNull(uIFormInfo.Width);
            Assert.IsInstanceOf(uIFormInfo.Props["Width"].PropertyType, uIFormInfo.Width);
                        Assert.IsNotNull(uIFormInfo.Height);
            Assert.IsInstanceOf(uIFormInfo.Props["Height"].PropertyType, uIFormInfo.Height);
                        Assert.IsNull(uIFormInfo.Title);
                        Assert.IsNotNull(uIFormInfo.Generated);
            Assert.IsInstanceOf(uIFormInfo.Props["Generated"].PropertyType, uIFormInfo.Generated);
                        Assert.IsNull(uIFormInfo.UIViewID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateUnsavedValidUIFormInfo();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIFormInfo.Status.IsNew);
            BusinessObjectCollection<UIFormInfo> col = new BusinessObjectCollection<UIFormInfo>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIFormInfo.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();

            //---------------Execute Test ----------------------
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIFormInfo.UIFormID, loadedUIFormInfo.UIFormID);
                        Assert.AreEqual(uIFormInfo.Width, loadedUIFormInfo.Width);
                        Assert.AreEqual(uIFormInfo.Height, loadedUIFormInfo.Height);
                        Assert.AreEqual(uIFormInfo.Title, loadedUIFormInfo.Title);
                        Assert.AreEqual(uIFormInfo.Generated, loadedUIFormInfo.Generated);
                        Assert.AreEqual(uIFormInfo.UIViewID, loadedUIFormInfo.UIViewID);
        }

        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.MarkForDelete();
            uIFormInfo.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIFormInfo", ex.Message);
            }
        }

        [Test]
        public void Test_UpdateUIFormInfo_UpdateTitle()
        {
            //---------------Set up test pack-------------------
            UIFormInfo uiFormInfo = TestUtilsShared.CreateSavedUIFormInfo();

            //---------------Assert Precondition----------------
            Assert.IsFalse(uiFormInfo.Status.IsNew);
            string message;
            Assert.IsTrue(uiFormInfo.IsEditable(out message));

            //---------------Execute Test ----------------------
            uiFormInfo.Title = "Test Form";

            //---------------Test Result -----------------------
            Assert.IsFalse(uiFormInfo.Status.IsNew);
        }
        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtilsShared.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtilsShared.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIFormInfo retrievedUIFormInfo =
                    Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            
            Assert.AreEqual(valueForWidth, retrievedUIFormInfo.Width);
            Assert.AreEqual(valueForHeight, retrievedUIFormInfo.Height);
            Assert.AreEqual(valueForTitle, retrievedUIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, retrievedUIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, retrievedUIFormInfo.UIViewID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtilsShared.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtilsShared.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.Width);
            Assert.AreEqual(valueForHeight, uIFormInfo.Height);
            Assert.AreEqual(valueForTitle, uIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, uIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIFormInfo.UIViewID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtilsShared.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtilsShared.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.GetPropertyValue("Width"));
            Assert.AreEqual(valueForHeight, uIFormInfo.GetPropertyValue("Height"));
            Assert.AreEqual(valueForTitle, uIFormInfo.GetPropertyValue("Title"));
            Assert.AreEqual(valueForGenerated, uIFormInfo.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIViewID, uIFormInfo.GetPropertyValue("UIViewID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtilsShared.GetRandomInt();            
            uIFormInfo.SetPropertyValue("Width", valueForWidth);
            object valueForHeight = TestUtilsShared.GetRandomInt();            
            uIFormInfo.SetPropertyValue("Height", valueForHeight);
            object valueForTitle = TestUtilsShared.GetRandomString();            
            uIFormInfo.SetPropertyValue("Title", valueForTitle);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIFormInfo.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;            
            uIFormInfo.SetPropertyValue("UIViewID", valueForUIViewID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.Width);
            Assert.AreEqual(valueForHeight, uIFormInfo.Height);
            Assert.AreEqual(valueForTitle, uIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, uIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIFormInfo.UIViewID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.Title = null;
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIFormInfo retrievedUIFormInfo =
                    Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            
            Assert.IsNull(retrievedUIFormInfo.Title);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtilsShared.CreateUnsavedValidUIFormInfo();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.UIFormID = null;
            uIFormInfo.Width = null;
            uIFormInfo.Height = null;
            uIFormInfo.Generated = null;
            uIFormInfo.UIViewID = null;
            
            try
            {
                uIFormInfo.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Form ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Width' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Height' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI View ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIFormInfo>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIFormID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Width"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Height"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Title"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIViewID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();

            UIView boForRelationshipUIView = uIFormInfo.UIView;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIView loadedRelatedBO = Broker.GetBusinessObject<UIView>(boForRelationshipUIView.ID);
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIView, loadedUIFormInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, loadedUIFormInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, uIFormInfo.UIView);
        }

        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UITabs()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();

            UITab boForRelationshipUITabs = TestUtilsUITab.CreateUnsavedValidUITab();
            boForRelationshipUITabs.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUITabs.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UITabs.Count);
            //---------------Execute Test ----------------------
            UITab loadedRelatedBO = Broker.GetBusinessObject<UITab>(boForRelationshipUITabs.ID);
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIFormInfo.UITabs.Count);
            Assert.AreEqual(boForRelationshipUITabs, loadedUIFormInfo.UITabs[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIFormInfo.UITabs[0]);
            Assert.AreEqual(loadedRelatedBO, uIFormInfo.UITabs[0]);
        }
        
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UITabs()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtilsShared.CreateSavedUIFormInfo();

            UITab boForRelationshipUITabs = TestUtilsUITab.CreateUnsavedValidUITab();
            boForRelationshipUITabs.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUITabs.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UITabs.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIFormInfo>().RelationshipDefCol["UITabs"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIFormInfo.MarkForDelete();
            uIFormInfo.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIFormInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UITab>(boForRelationshipUITabs.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UITab"));
            }
        }





        // ReSharper restore RedundantNameQualifier
    }
}
