// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIGridFilterProp objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIGridFilterProp
    {
        /// <summary>
        /// Creates a new saved UIGridFilterProp with a random value assigned to every property
        /// </summary>
        public static UIGridFilterProp CreateSavedUIGridFilterProp()
		{
		    UIGridFilterProp uIGridFilterProp = CreateUnsavedValidUIGridFilterProp();
			uIGridFilterProp.Save();
			return uIGridFilterProp;
		}

        /// <summary>
        /// Creates a new unsaved UIGridFilterProp with a random value assigned to every property
        /// </summary>
		public static UIGridFilterProp CreateUnsavedValidUIGridFilterProp()
		{
			UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();
			uIGridFilterProp.UIGridFilter = TestUtilsUIGridFilter.CreateSavedUIGridFilter();
            uIGridFilterProp.PropertyName = TestUtilsDMProperty.CreateSavedDMProperty().PropertyName;
			uIGridFilterProp.Generated = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.UIGridFilterType = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();
			uIGridFilterProp.LabelText = TestUtilsShared.GetRandomString();
			uIGridFilterProp.DefaultValue = TestUtilsShared.GetRandomString();
			uIGridFilterProp.Nullable = TestUtilsShared.GetRandomBoolean();
//			uIGridFilterProp.IncludeStartDate = TestUtilsShared.GetRandomBoolean();
//			uIGridFilterProp.IncludeEndDate = TestUtilsShared.GetRandomBoolean();
			uIGridFilterProp.FilterClauseOp = null;
			return uIGridFilterProp;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIGridFilterProp where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIGridFilterProp CreateUnsavedDefaultUIGridFilterProp()
		{
			UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();
			return uIGridFilterProp;
		}
    }
    
    // Provides the part of the test class that tests UIGridFilterProp objects
    [TestFixture]
    public partial class TestUIGridFilterProp : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIGridFilterPropWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIGridFilterProp.UIGridFilterPropID);
            Assert.IsInstanceOf(uIGridFilterProp.Props["UIGridFilterPropID"].PropertyType, uIGridFilterProp.UIGridFilterPropID);
                        Assert.IsNull(uIGridFilterProp.UIGridFilterID);
                        Assert.IsNull(uIGridFilterProp.PropertyName);
                        Assert.IsNotNull(uIGridFilterProp.Generated);
            Assert.IsInstanceOf(uIGridFilterProp.Props["Generated"].PropertyType, uIGridFilterProp.Generated);
//            Assert.IsInstanceOf(uIGridFilterProp.Props["FilterControlType"].PropertyType, uIGridFilterProp.FilterControlType);
//            Assert.AreEqual(FilterControlTypeInfo.StringFilterTextBox, uIGridFilterProp.FilterControlType);
                        Assert.IsNull(uIGridFilterProp.LabelText);
                        Assert.IsNull(uIGridFilterProp.DefaultValue);
                        Assert.IsNull(uIGridFilterProp.Nullable);
//                        Assert.IsNull(uIGridFilterProp.IncludeStartDate);
//                        Assert.IsNull(uIGridFilterProp.IncludeEndDate);
                        Assert.IsNull(uIGridFilterProp.FilterClauseOp);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIGridFilterProp()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateUnsavedValidUIGridFilterProp();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIGridFilterProp.Status.IsNew);
            BusinessObjectCollection<UIGridFilterProp> col = new BusinessObjectCollection<UIGridFilterProp>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIGridFilterProp.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIGridFilterProp.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIGridFilterProp()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();

            //---------------Execute Test ----------------------
            UIGridFilterProp loadedUIGridFilterProp = Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIGridFilterProp.UIGridFilterPropID, loadedUIGridFilterProp.UIGridFilterPropID);
                        Assert.AreEqual(uIGridFilterProp.UIGridFilterID, loadedUIGridFilterProp.UIGridFilterID);
                        Assert.AreEqual(uIGridFilterProp.PropertyName, loadedUIGridFilterProp.PropertyName);
                        Assert.AreEqual(uIGridFilterProp.Generated, loadedUIGridFilterProp.Generated);
//                        Assert.AreEqual(uIGridFilterProp.FilterControlType, loadedUIGridFilterProp.FilterControlType);
                        Assert.AreEqual(uIGridFilterProp.LabelText, loadedUIGridFilterProp.LabelText);
                        Assert.AreEqual(uIGridFilterProp.DefaultValue, loadedUIGridFilterProp.DefaultValue);
                        Assert.AreEqual(uIGridFilterProp.Nullable, loadedUIGridFilterProp.Nullable);
//                        Assert.AreEqual(uIGridFilterProp.IncludeStartDate, loadedUIGridFilterProp.IncludeStartDate);
//                        Assert.AreEqual(uIGridFilterProp.IncludeEndDate, loadedUIGridFilterProp.IncludeEndDate);
                        Assert.AreEqual(uIGridFilterProp.FilterClauseOp, loadedUIGridFilterProp.FilterClauseOp);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIGridFilterProp()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilterProp.MarkForDelete();
            uIGridFilterProp.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIGridFilterProp", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIGridFilterProp()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridFilterID = TestUtilsUIGridFilter.CreateSavedUIGridFilter().UIGridFilterID;
            uIGridFilterProp.UIGridFilterID = (System.Guid) valueForUIGridFilterID;
//            object valueForPropertyName = TestUtilsShared.GetRandomString();
//            uIGridFilterProp.PropertyName = (System.String) valueForPropertyName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Generated = (System.Boolean) valueForGenerated;
            object valueForLabelText = TestUtilsShared.GetRandomString();
            uIGridFilterProp.LabelText = (System.String) valueForLabelText;
            object valueForDefaultValue = TestUtilsShared.GetRandomString();
            uIGridFilterProp.DefaultValue = (System.String) valueForDefaultValue;
            object valueForNullable = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Nullable = (System.Boolean) valueForNullable;
//            object valueForIncludeStartDate = TestUtilsShared.GetRandomBoolean();
////            uIGridFilterProp.IncludeStartDate = (System.Boolean) valueForIncludeStartDate;
//            object valueForIncludeEndDate = TestUtilsShared.GetRandomBoolean();
////            uIGridFilterProp.IncludeEndDate = (System.Boolean) valueForIncludeEndDate;
            uIGridFilterProp.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridFilterProp retrievedUIGridFilterProp =
                    Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);
            
            Assert.AreEqual(valueForUIGridFilterID, retrievedUIGridFilterProp.UIGridFilterID);
//            Assert.AreEqual(valueForPropertyName, retrievedUIGridFilterProp.PropertyName);
            Assert.AreEqual(valueForGenerated, retrievedUIGridFilterProp.Generated);
            Assert.AreEqual(valueForLabelText, retrievedUIGridFilterProp.LabelText);
            Assert.AreEqual(valueForDefaultValue, retrievedUIGridFilterProp.DefaultValue);
            Assert.AreEqual(valueForNullable, retrievedUIGridFilterProp.Nullable);
//            Assert.AreEqual(valueForIncludeStartDate, retrievedUIGridFilterProp.IncludeStartDate);
//            Assert.AreEqual(valueForIncludeEndDate, retrievedUIGridFilterProp.IncludeEndDate);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridFilterID = TestUtilsUIGridFilter.CreateSavedUIGridFilter().UIGridFilterID;
            uIGridFilterProp.UIGridFilterID = (System.Guid) valueForUIGridFilterID;
//            object valueForPropertyName = TestUtilsShared.GetRandomString();
//            uIGridFilterProp.PropertyName = (System.String) valueForPropertyName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Generated = (System.Boolean) valueForGenerated;
            object valueForLabelText = TestUtilsShared.GetRandomString();
            uIGridFilterProp.LabelText = (System.String) valueForLabelText;
            object valueForDefaultValue = TestUtilsShared.GetRandomString();
            uIGridFilterProp.DefaultValue = (System.String) valueForDefaultValue;
            object valueForNullable = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Nullable = (System.Boolean) valueForNullable;
//            object valueForIncludeStartDate = TestUtilsShared.GetRandomBoolean();
////            uIGridFilterProp.IncludeStartDate = (System.Boolean) valueForIncludeStartDate;
//            object valueForIncludeEndDate = TestUtilsShared.GetRandomBoolean();
////            uIGridFilterProp.IncludeEndDate = (System.Boolean) valueForIncludeEndDate;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridFilterID, uIGridFilterProp.UIGridFilterID);
//            Assert.AreEqual(valueForPropertyName, uIGridFilterProp.PropertyName);
            Assert.AreEqual(valueForGenerated, uIGridFilterProp.Generated);
            Assert.AreEqual(valueForLabelText, uIGridFilterProp.LabelText);
            Assert.AreEqual(valueForDefaultValue, uIGridFilterProp.DefaultValue);
            Assert.AreEqual(valueForNullable, uIGridFilterProp.Nullable);
//            Assert.AreEqual(valueForIncludeStartDate, uIGridFilterProp.IncludeStartDate);
//            Assert.AreEqual(valueForIncludeEndDate, uIGridFilterProp.IncludeEndDate);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridFilterID = TestUtilsUIGridFilter.CreateSavedUIGridFilter().UIGridFilterID;
            uIGridFilterProp.UIGridFilterID = (System.Guid) valueForUIGridFilterID;
//            object valueForPropertyName = TestUtilsShared.GetRandomString();
//            uIGridFilterProp.PropertyName = (System.String) valueForPropertyName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Generated = (System.Boolean) valueForGenerated;
            object valueForLabelText = TestUtilsShared.GetRandomString();
            uIGridFilterProp.LabelText = (System.String) valueForLabelText;
            object valueForDefaultValue = TestUtilsShared.GetRandomString();
            uIGridFilterProp.DefaultValue = (System.String) valueForDefaultValue;
            object valueForNullable = TestUtilsShared.GetRandomBoolean();
            uIGridFilterProp.Nullable = (System.Boolean) valueForNullable;
            //object valueForIncludeStartDate = TestUtilsShared.GetRandomBoolean();
//            uIGridFilterProp.IncludeStartDate = (System.Boolean) valueForIncludeStartDate;
            //object valueForIncludeEndDate = TestUtilsShared.GetRandomBoolean();
//            uIGridFilterProp.IncludeEndDate = (System.Boolean) valueForIncludeEndDate;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridFilterID, uIGridFilterProp.GetPropertyValue("UIGridFilterID"));
//            Assert.AreEqual(valueForPropertyName, uIGridFilterProp.GetPropertyValue("PropertyName"));
            Assert.AreEqual(valueForGenerated, uIGridFilterProp.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForLabelText, uIGridFilterProp.GetPropertyValue("LabelText"));
            Assert.AreEqual(valueForDefaultValue, uIGridFilterProp.GetPropertyValue("DefaultValue"));
            Assert.AreEqual(valueForNullable, uIGridFilterProp.GetPropertyValue("Nullable"));
//            Assert.AreEqual(valueForIncludeStartDate, uIGridFilterProp.GetPropertyValue("IncludeStartDate"));
//            Assert.AreEqual(valueForIncludeEndDate, uIGridFilterProp.GetPropertyValue("IncludeEndDate"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = new UIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridFilterID = TestUtilsUIGridFilter.CreateSavedUIGridFilter().UIGridFilterID;            
            uIGridFilterProp.SetPropertyValue("UIGridFilterID", valueForUIGridFilterID);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIGridFilterProp.SetPropertyValue("Generated", valueForGenerated);
            object valueForLabelText = TestUtilsShared.GetRandomString();            
            uIGridFilterProp.SetPropertyValue("LabelText", valueForLabelText);
            object valueForDefaultValue = TestUtilsShared.GetRandomString();            
            uIGridFilterProp.SetPropertyValue("DefaultValue", valueForDefaultValue);
            object valueForNullable = TestUtilsShared.GetRandomBoolean();            
            uIGridFilterProp.SetPropertyValue("Nullable", valueForNullable);
//            object valueForIncludeStartDate = TestUtilsShared.GetRandomBoolean();            
//            uIGridFilterProp.SetPropertyValue("IncludeStartDate", valueForIncludeStartDate);
//            object valueForIncludeEndDate = TestUtilsShared.GetRandomBoolean();            
//            uIGridFilterProp.SetPropertyValue("IncludeEndDate", valueForIncludeEndDate);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridFilterID, uIGridFilterProp.UIGridFilterID);
            Assert.AreEqual(valueForGenerated, uIGridFilterProp.Generated);
            Assert.AreEqual(valueForLabelText, uIGridFilterProp.LabelText);
            Assert.AreEqual(valueForDefaultValue, uIGridFilterProp.DefaultValue);
            Assert.AreEqual(valueForNullable, uIGridFilterProp.Nullable);
//            Assert.AreEqual(valueForIncludeStartDate, uIGridFilterProp.IncludeStartDate);
//            Assert.AreEqual(valueForIncludeEndDate, uIGridFilterProp.IncludeEndDate);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilterProp.LabelText = null;
            uIGridFilterProp.DefaultValue = null;
            uIGridFilterProp.Nullable = null;
//            uIGridFilterProp.IncludeStartDate = null;
//            uIGridFilterProp.IncludeEndDate = null;
            uIGridFilterProp.FilterClauseOp = null;
            uIGridFilterProp.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridFilterProp retrievedUIGridFilterProp =
                    Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);
            
            Assert.IsNotNull(retrievedUIGridFilterProp.LabelText);
            Assert.IsNull(retrievedUIGridFilterProp.DefaultValue);
            Assert.IsNull(retrievedUIGridFilterProp.Nullable);
//            Assert.IsNull(retrievedUIGridFilterProp.IncludeStartDate);
//            Assert.IsNull(retrievedUIGridFilterProp.IncludeEndDate);
            Assert.IsNull(retrievedUIGridFilterProp.FilterClauseOp);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateUnsavedValidUIGridFilterProp();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilterProp.UIGridFilterID = null;
            uIGridFilterProp.Generated = null;
            
            try
            {
                uIGridFilterProp.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Grid Filter ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIGridFilterProp>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIGridFilterPropID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridFilterID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
//			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["FilterControlType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LabelText"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DefaultValue"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Nullable"].ReadWriteRule.ToString());
//			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IncludeStartDate"].ReadWriteRule.ToString());
//			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IncludeEndDate"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["FilterClauseOp"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();

            UIGridFilter boForRelationshipUIGridFilter = uIGridFilterProp.UIGridFilter;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridFilter loadedRelatedBO = Broker.GetBusinessObject<UIGridFilter>(boForRelationshipUIGridFilter.ID);
            UIGridFilterProp loadedUIGridFilterProp = Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridFilter, loadedUIGridFilterProp.UIGridFilter);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridFilterProp.UIGridFilter);
            Assert.AreEqual(loadedRelatedBO, uIGridFilterProp.UIGridFilter);
        }
        
        
        
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_UIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilterProp uIGridFilterProp = TestUtilsUIGridFilterProp.CreateSavedUIGridFilterProp();

            UIGridFilter boForRelationshipUIGridFilter = uIGridFilterProp.UIGridFilter;

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<UIGridFilterProp>().RelationshipDefCol["UIGridFilter"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridFilterProp.MarkForDelete();
            uIGridFilterProp.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridFilterProp>(uIGridFilterProp.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridFilterProp"));
            }            
            
            UIGridFilter relatedBO = Broker.GetBusinessObject<UIGridFilter>(boForRelationshipUIGridFilter.ID);
            Assert.AreEqual(relatedBO,boForRelationshipUIGridFilter);
            
        }

        // ReSharper restore RedundantNameQualifier
    }
}
