// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIGridInfo objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIGridInfo
    {
        /// <summary>
        /// Creates a new saved UIGridInfo with a random value assigned to every property
        /// </summary>
        public static UIGridInfo CreateSavedUIGridInfo()
		{
		    UIGridInfo uIGridInfo = CreateUnsavedValidUIGridInfo();
			uIGridInfo.Save();
			return uIGridInfo;
		}

        /// <summary>
        /// Creates a new unsaved UIGridInfo with a random value assigned to every property
        /// </summary>
		public static UIGridInfo CreateUnsavedValidUIGridInfo()
		{
            UIGridInfo uIGridInfo = CreateUnsavedValidUIGridInfo_WNoUIView();
			uIGridInfo.UIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
			return uIGridInfo;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIGridInfo where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIGridInfo CreateUnsavedDefaultUIGridInfo()
		{
			UIGridInfo uIGridInfo = new UIGridInfo();
			return uIGridInfo;
		}
        /// <summary>
        /// Creates a new unsaved UIGridInfo with a random value assigned to every property
        /// </summary>
        public static UIGridInfo CreateUnsavedValidUIGridInfo_WNoUIView()
        {
            UIGridInfo uIGridInfo = new UIGridInfo();
            uIGridInfo.SortColumn = TestUtilsShared.GetRandomString();
            uIGridInfo.Generated = TestUtilsShared.GetRandomBoolean();
            return uIGridInfo;            
        }
    }
    
    // Provides the part of the test class that tests UIGridInfo objects
    [TestFixture]
    public partial class TestUIGridInfo : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIGridInfoWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIGridInfo uIGridInfo = new UIGridInfo();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIGridInfo.UIGridID);
            Assert.IsInstanceOf(uIGridInfo.Props["UIGridID"].PropertyType, uIGridInfo.UIGridID);
                        Assert.IsNull(uIGridInfo.SortColumn);
                        Assert.IsNotNull(uIGridInfo.Generated);
            Assert.IsInstanceOf(uIGridInfo.Props["Generated"].PropertyType, uIGridInfo.Generated);
                        Assert.IsNull(uIGridInfo.UIViewID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateUnsavedValidUIGridInfo();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIGridInfo.Status.IsNew);
            BusinessObjectCollection<UIGridInfo> col = new BusinessObjectCollection<UIGridInfo>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIGridInfo.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIGridInfo.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            //---------------Execute Test ----------------------
            UIGridInfo loadedUIGridInfo = Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIGridInfo.UIGridID, loadedUIGridInfo.UIGridID);
                        Assert.AreEqual(uIGridInfo.SortColumn, loadedUIGridInfo.SortColumn);
                        Assert.AreEqual(uIGridInfo.Generated, loadedUIGridInfo.Generated);
                        Assert.AreEqual(uIGridInfo.UIViewID, loadedUIGridInfo.UIViewID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridInfo.MarkForDelete();
            uIGridInfo.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIGridInfo", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSortColumn = TestUtilsShared.GetRandomString();
            uIGridInfo.SortColumn = (System.String) valueForSortColumn;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIGridInfo.UIViewID = (System.Guid) valueForUIViewID;
            uIGridInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridInfo retrievedUIGridInfo =
                    Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
            
            Assert.AreEqual(valueForSortColumn, retrievedUIGridInfo.SortColumn);
            Assert.AreEqual(valueForGenerated, retrievedUIGridInfo.Generated);
            Assert.AreEqual(valueForUIViewID, retrievedUIGridInfo.UIViewID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = new UIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSortColumn = TestUtilsShared.GetRandomString();
            uIGridInfo.SortColumn = (System.String) valueForSortColumn;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIGridInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSortColumn, uIGridInfo.SortColumn);
            Assert.AreEqual(valueForGenerated, uIGridInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIGridInfo.UIViewID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = new UIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSortColumn = TestUtilsShared.GetRandomString();
            uIGridInfo.SortColumn = (System.String) valueForSortColumn;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;
            uIGridInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSortColumn, uIGridInfo.GetPropertyValue("SortColumn"));
            Assert.AreEqual(valueForGenerated, uIGridInfo.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIViewID, uIGridInfo.GetPropertyValue("UIViewID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = new UIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSortColumn = TestUtilsShared.GetRandomString();            
            uIGridInfo.SetPropertyValue("SortColumn", valueForSortColumn);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIGridInfo.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIViewID = TestUtilsUIView.CreateSavedUIView().UIViewID;            
            uIGridInfo.SetPropertyValue("UIViewID", valueForUIViewID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSortColumn, uIGridInfo.SortColumn);
            Assert.AreEqual(valueForGenerated, uIGridInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIGridInfo.UIViewID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridInfo.SortColumn = null;
            uIGridInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridInfo retrievedUIGridInfo =
                    Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
            
            Assert.IsNull(retrievedUIGridInfo.SortColumn);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridInfo uIGridInfo = TestUtilsShared.CreateUnsavedValidUIGridInfo();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridInfo.UIGridID = null;
            uIGridInfo.Generated = null;
            uIGridInfo.UIViewID = null;
            
            try
            {
                uIGridInfo.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Grid ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI View ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIGridInfo>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIGridID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SortColumn"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIViewID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            UIGridFilter boForRelationshipUIGridFilter = TestUtilsUIGridFilter.CreateUnsavedValidUIGridFilter_WNoUIGrid();
            uIGridInfo.UIGridFilter = boForRelationshipUIGridFilter;
            uIGridInfo.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridFilter loadedRelatedBO = Broker.GetBusinessObject<UIGridFilter>(boForRelationshipUIGridFilter.ID);
            UIGridInfo loadedUIGridInfo = Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridFilter, loadedUIGridInfo.UIGridFilter);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridInfo.UIGridFilter);
            Assert.AreEqual(loadedRelatedBO, uIGridInfo.UIGridFilter);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            UIView boForRelationshipUIView = uIGridInfo.UIView;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIView loadedRelatedBO = Broker.GetBusinessObject<UIView>(boForRelationshipUIView.ID);
            UIGridInfo loadedUIGridInfo = Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIView, loadedUIGridInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, uIGridInfo.UIView);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            UIGridColumnInfo boForRelationshipUIGridColumns = TestUtilsUIGridColumnInfo.CreateUnsavedValidUIColumn();
            boForRelationshipUIGridColumns.UIGridID = uIGridInfo.UIGridID;
            boForRelationshipUIGridColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridInfo.UIColumns.Count);
            //---------------Execute Test ----------------------
            UIGridColumnInfo loadedRelatedBO = Broker.GetBusinessObject<UIGridColumnInfo>(boForRelationshipUIGridColumns.ID);
            UIGridInfo loadedUIGridInfo = Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIGridInfo.UIColumns.Count);
            Assert.AreEqual(boForRelationshipUIGridColumns, loadedUIGridInfo.UIColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridInfo.UIColumns[0]);
            Assert.AreEqual(loadedRelatedBO, uIGridInfo.UIColumns[0]);
        }
        
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            UIGridColumnInfo boForRelationshipUIGridColumns = TestUtilsUIGridColumnInfo.CreateUnsavedValidUIColumn();
            boForRelationshipUIGridColumns.UIGridID = uIGridInfo.UIGridID;
            boForRelationshipUIGridColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridInfo.UIColumns.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIGridInfo>().RelationshipDefCol["UIColumns"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridInfo.MarkForDelete();
            uIGridInfo.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIGridColumnInfo>(boForRelationshipUIGridColumns.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridColumnInfo"));
            }
        }

        [Ignore(" ")] //TODO Brett 24 Feb 2009: Ignored Test - 
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_SingleRelationshipDeletion_DeleteRelated_UIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridInfo uIGridInfo = TestUtilsShared.CreateSavedUIGridInfo();

            UIGridFilter boForRelationshipUIGridFilter = TestUtilsUIGridFilter.CreateSavedUIGridFilter();
            uIGridInfo.UIGridFilter = boForRelationshipUIGridFilter;
            uIGridInfo.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<UIGridInfo>().RelationshipDefCol["UIGridFilter"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridInfo.MarkForDelete();
            uIGridInfo.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridInfo>(uIGridInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIGridFilter>(boForRelationshipUIGridFilter.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridFilter"));
            }
            
        }

        // ReSharper restore RedundantNameQualifier
    }
}
